/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - AvP[V - t[^C}[
      $Id$
                  Copyright (C) 2003-2004, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: AvP[V: t[^C}[
 *
 * t[^C}[`܂B
 *
 * @author ABE Shigeru
 * @date 2004/02/04
 */
#ifndef _BODY_APPILICATION_W32FRAMETIMER_H_20040204Wed_185317_
#define _BODY_APPILICATION_W32FRAMETIMER_H_20040204Wed_185317_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// Win32 t[^C}[
class W32FrameTimer : public FrameTimer
{
public: /* FrameTimer C^[tFCX */
    
    /// t[҂
    virtual time_t on_wait_frame ( void ) = 0;
    
public:
    
    /// ^C}[f[^
    class schedule_t
    {
    private:
        
        /// ̃e[u\ FPS
        const unsigned int num_fps;
        
        /// t[ԃe[u (~b)
        unsigned int ary_table [ 16 ];
        
        /// e[u
        /** ̃f[^\܂Bz񒷂𒴂Ȃ悤ɋC邱ƁB */
        unsigned int num_length;
        
        /// 
        /** e[ȗSf[^vlłB */
        unsigned int num_distance;
        
    public:
        
        /// RXgN^
        schedule_t ( unsigned int fps, ... );
        
        /// t[Ԋu擾
        unsigned int get_interval ( unsigned int n ) const
        {
            return this->ary_table[n];
        }
        
        /// t[Ԋu擾
        unsigned int get_length ( void ) const
        {
            return this->num_length;
        }
        
        /// 擾
        unsigned int get_distance ( void ) const
        {
            return this->num_distance;
        }
        
        /// ^C}[ FPS 擾
        unsigned int get_fps ( void ) const
        {
            return this->num_fps;
        }
        
    };
    
private:
    
    /// gp̃^C}[f[^
    const schedule_t * const ptr_schedule;
    
    /// C^[oe[üʒu
    unsigned int num_interval_index;
    
    /// }`fBA^C}[pf[^
    MMTIME obj_mmtime;
    
protected:
    
    /// ݂̃C^[oe[uʒu擾
    unsigned int get_interval_index ( void ) const
    {
        return this->num_interval_index;
    }
    
    /// C^[oe[uʒui߂
    /**
     * @return i߂Õe[uʒu
     */
    unsigned int advance_interval_index ( void )
    {
        const unsigned int ret = this->num_interval_index;
        
        this->num_interval_index += 1;
        if( this->num_interval_index >= this->ptr_schedule->get_length() ) {
            this->num_interval_index = 0;
        }
        
        return ret;
    }
    
public:
    
    /// ݎ擾
    time_t get_current_time ( void );
    
public:
    
    /// RXgN^
    W32FrameTimer ( unsigned int fps, time_t curr );
    
    /// fXgN^
    virtual ~W32FrameTimer ();
    
    /// gpĂ^C}[f[^擾
    const schedule_t * get_schedule ( void ) const
    {
        return this->ptr_schedule;
    }
    
};


/// x^C}[
class W32CPUFrameTimer : public W32FrameTimer
{
public: /* FrameTimer C^[tFCX */
    
    /// t[҂
    virtual time_t on_wait_frame ( void );
    
private:
    
    /// Õt[
    /** ̏Əd邯ǁc */
    time_t num_last_time;
    
public:
    
    /// RXgN^
    W32CPUFrameTimer ( unsigned int fps );
    
    /// fXgN^
    virtual ~W32CPUFrameTimer ();
    
};


} /* namespace BK */


#endif /* _BODY_APPILICATION_W32FRAMETIMER_H_20040204Wed_185317_ */
