/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - [eBeB - DirectX - _
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: [eBeB: DirectX: _
 *
 * Direct3D Ŏgp钸_f[^NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _BODY_DIRECTX_VERTEXBASE_H_20031219Fri_141632_
#define _BODY_DIRECTX_VERTEXBASE_H_20031219Fri_141632_


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// _IuWFNg̊{^
/**
 * _Op̒_IuWFNg\܂B
 *
 * u\bhȂvƂG[邽߂̃NXłB
 */
struct VertexBase
{
    void set_x ( float v )
    {
    }
    
    float get_x ( void ) const
    {
        return 0.0;
    }
    
    void set_y ( float v )
    {
    }
    
    float get_y ( void ) const
    {
        return 0.0;
    }
    
    void set_z ( float v )
    {
    }
    
    float get_z ( void ) const
    {
        return 0.0;
    }
    
    void set_rhw ( float v )
    {
    }
    
    float get_rhw ( void ) const
    {
        return 0.0;
    }
    
    void set_diffuse ( D3DCOLOR v )
    {
    }
    
    D3DCOLOR get_diffuse ( void ) const
    {
        return 0;
    }
    
    void set_texture1_x ( float v )
    {
    }
    
    float get_texture1_x ( void ) const
    {
        return 0.0;
    }
    
    void set_texture1_y ( float v )
    {
    }
    
    float get_texture1_y ( void ) const
    {
        return 0.0;
    }
};


/// _ (fBt[Y)
struct TLVertex : public VertexBase
{
    float x;
    float y;
    float z;
    float w;
    D3DCOLOR diffuse;
    
    static DWORD get_vertex_format ( void )
    {
        return D3DFVF_XYZRHW | D3DFVF_DIFFUSE;
    }
    
    void set_x ( float v )
    {
        x = v;
    }
    
    float get_x ( void ) const
    {
        return x;
    }
    
    void set_y ( float v )
    {
        y = v;
    }
    
    float get_y ( void ) const
    {
        return y;
    }
    
    void set_z ( float v )
    {
        z = v;
    }
    
    float get_z ( void ) const
    {
        return z;
    }
    
    void set_rhw ( float v )
    {
        w = v;
    }
    
    float get_rhw ( void ) const
    {
        return w;
    }
    
    void set_diffuse ( D3DCOLOR v )
    {
        diffuse = v;
    }
    
    D3DCOLOR get_diffuse ( void ) const
    {
        return diffuse;
    }
    
    TLVertex & operator += ( Point2 const & p )
    {
        set_x( get_x() + p.get_x() );
        set_y( get_y() + p.get_y() );
        return *this;
    }
};


/// 1 ̃eNX`_
struct Tex1Vertex : public VertexBase
{
    float x;
    float y;
    float z;
    float w;
    float u1;
    float v1;
    
    static DWORD get_vertex_format ( void )
    {
        return D3DFVF_XYZRHW | D3DFVF_TEX1;
    }
    
    void set_x ( float v )
    {
        x = v;
    }
    
    float get_x ( void ) const
    {
        return x;
    }
    
    void set_y ( float v )
    {
        y = v;
    }
    
    float get_y ( void ) const
    {
        return y;
    }
    
    void set_z ( float v )
    {
        z = v;
    }
    
    float get_z ( void ) const
    {
        return z;
    }
    
    void set_rhw ( float v )
    {
        w = v;
    }
    
    float get_rhw ( void ) const
    {
        return w;
    }
    
    void set_texture1_x ( float v )
    {
        u1 = v;
    }
    
    float get_texture1_x ( void ) const
    {
        return u1;
    }
    
    void set_texture1_y ( float v )
    {
        v1 = v;
    }
    
    float get_texture1_y ( void ) const
    {
        return v1;
    }
    
    Tex1Vertex & operator += ( Point2 const & p )
    {
        set_x( get_x() + p.get_x() );
        set_y( get_y() + p.get_y() );
        return *this;
    }
};


/// 1 ̃eNX`_ (fBt[Y)
struct Tex1TLVertex : public VertexBase
{
    float x;
    float y;
    float z;
    float w;
    D3DCOLOR diffuse;
    float u1;
    float v1;
    
    static DWORD get_vertex_format ( void )
    {
        return D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1;
    }
    
    void set_x ( float v )
    {
        x = v;
    }
    
    float get_x ( void ) const
    {
        return x;
    }
    
    void set_y ( float v )
    {
        y = v;
    }
    
    float get_y ( void ) const
    {
        return y;
    }
    
    void set_z ( float v )
    {
        z = v;
    }
    
    float get_z ( void ) const
    {
        return z;
    }
    
    void set_rhw ( float v )
    {
        w = v;
    }
    
    float get_rhw ( void ) const
    {
        return w;
    }
    
    void set_diffuse ( D3DCOLOR v )
    {
        diffuse = v;
    }
    
    D3DCOLOR get_diffuse ( void ) const
    {
        return diffuse;
    }
    
    void set_texture1_x ( float v )
    {
        u1 = v;
    }
    
    float get_texture1_x ( void ) const
    {
        return u1;
    }
    
    void set_texture1_y ( float v )
    {
        v1 = v;
    }
    
    float get_texture1_y ( void ) const
    {
        return v1;
    }
    
    Tex1TLVertex & operator += ( Point2 const & p )
    {
        set_x( get_x() + p.get_x() );
        set_y( get_y() + p.get_y() );
        return *this;
    }
};


} /* namespace DirectX */
} /* namespace BK */


#endif /* _BODY_DIRECTX_VERTEXBASE_H_20031219Fri_141632_ */
