/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - [eBeB - DirectX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: [eBeB: DirectX
 *
 * DirectX Ɋ֌W[eBeBW߂wb_t@CłB
 *
 * @author ABE Shigeru
 * @date 2003/09/13
 */
#ifndef _BODY_UTILITY_DIRECTX_H_20030913Sat_075134_
#define _BODY_UTILITY_DIRECTX_H_20030913Sat_075134_


/*   CN[h
------------------------------------------------------------------- */
#include "bk_VertexBase.h"


/*   DirectX ֐` (x[XT[rX)
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// G[bZ[W擾
const char * result_to_message ( HRESULT result );


/// QƃJEg炷
inline ULONG Release ( IUnknown * obj )
{
    return (obj)? obj->Release(): 0;
}


/// QƃJEg𑝉
inline ULONG AddRef ( IUnknown * obj )
{
    return (obj)? obj->AddRef(): 0;
}


/// Rect2  D3DRECT ɕϊ
inline D3DRECT toD3DRECT ( Rect2 const & r )
{
    D3DRECT ret;
    ret.x1 = r.get_left();
    ret.y1 = r.get_top();
    ret.x2 = r.get_right();
    ret.y2 = r.get_bottom();
    return ret;
}


} /* namespace DirectX */
} /* namespace BK */


/*   DirectX ֐` (OtBbN)
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// D3DFORMAT 𕶎ɕϊ
/**
 * @param format [in] ϊtH[}bgl
 * @return lɑΉ镶
 */
const char * D3DFORMAT_to_string ( D3DFORMAT format );


/// D3DFORMAT  BK::Canvas::pixel_t ɕϊ
/**
 * @param format [in] ϊtH[}bgl
 * @return lɑΉl
 */
BK::Canvas::pixel_t D3DFORMAT_to_pixel ( D3DFORMAT format );


/// D3DPOOL 𕶎ɕϊ
/**
 * @param pool [in] ϊv[l
 * @return lɑΉ镶
 */
const char * D3DPOOL_to_string ( D3DPOOL pool );


/// D3DPOOL  BK::Picture::pool_t ɕϊ
/**
 * @param pool [in] ϊv[l
 * @return lɑΉl
 */
BK::Bitmap::pool_t D3DPOOL_to_pool ( D3DPOOL pool );


/// D3DDEVTYPE 𕶎ɕϊ
const char * D3DDEVTYPE_to_string ( D3DDEVTYPE type );


/// Direct3D foCX̏擾ĕ\z
std::string inspect_d3d_device ( IDirect3DDevice9 * dev );


/// Direct3D T[tFX̏擾ĕ\z
std::string inspect_d3d_surface ( IDirect3DSurface9 * surface );


/// Direct3D eNX`̏擾ĕ\z
std::string inspect_d3d_texture ( IDirect3DTexture9 * texture );


/// Ff[^ D3DCOLOR ɕϊ
inline D3DCOLOR Color_to_D3DCOLOR ( Color const & c )
{
    return D3DCOLOR_XRGB(c.get_red(), c.get_green(), c.get_blue());
}


/// xtFf[^ D3DCOLOR ɕϊ
inline D3DCOLOR AlphaColor_to_D3DCOLOR ( AlphaColor const & c )
{
    return D3DCOLOR_ARGB(c.get_alpha(), c.get_red(), c.get_green(), c.get_blue());
}


/// vC}A_v^̃fBXvC[h擾
D3DDISPLAYMODE * get_primary_display_desc ( IDirect3D9 * obj, D3DDISPLAYMODE * desc );


/// Direct3D foCX̏擾
D3DCAPS9 * get_d3d_device_desc ( IDirect3DDevice9 * device, D3DCAPS9 * desc );


/// Direct3D T[tFX̏擾
D3DSURFACE_DESC * get_d3d_surface_desc ( IDirect3DSurface9 * surface, D3DSURFACE_DESC * desc );


/// Direct3D eNX`̏擾
D3DSURFACE_DESC * get_d3d_texture_desc ( IDirect3DTexture9 * texture, D3DSURFACE_DESC * desc, unsigned int level = 0 );


/// C[Wt@C̏擾
D3DXIMAGE_INFO * get_imagefile_info ( const char * filename, D3DXIMAGE_INFO * info );


/// ɓWJꂽC[Wt@C̏擾
D3DXIMAGE_INFO * get_imagefile_info ( void const * src, unsigned int cap, D3DXIMAGE_INFO * info );


} /* namespace DirectX */
} /* namespace BK */


/*   DirectX ֐` (OtBbNE_)
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// _f[^ւ̍W
template < typename vertex_t >
void write_point_vertex ( vertex_t & vertex, int x, int y )
{
    vertex.set_x( static_cast< float >( x ) );
    vertex.set_y( static_cast< float >( y ) );
}


/// _f[^ւ̍W
template < typename vertex_t >
void write_point_vertex ( vertex_t & vertex, const Point2 & p )
{
    write_point_vertex( vertex, p.get_x(), p.get_y() );
}


/// _f[^ւ̋`W
/**
 * nꂽWA_f[^ɏ݂܂B
 * Op`v~eBugp܂B(_ 6)
 *
 * @param buffer [out] ݐ̒_obt@
 * @param points [in] ]̍WXg
 * @param ar [in] AXyNg`
 * @param diffuse [in] fBt[YF
 * @param z [in] Z W
 * @return ܂ꂽ_
 */
template < typename vertex_t >
int write_points_trilist ( vertex_t * buffer, const BK::ProjectionInfo::destination_t & points, const AspectRect2 & ar, D3DCOLOR diffuse, float z = 1.0 )
{
    vertex_t * ptr = buffer;
    
    write_point_vertex( *ptr, points.topleft );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ptr->set_texture1_x( ar.get_left() );
    ptr->set_texture1_y( ar.get_top() );
    ++ptr;
    
    write_point_vertex( *ptr, points.topright );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ptr->set_texture1_x( ar.get_right() );
    ptr->set_texture1_y( ar.get_top() );
    ++ptr;
    
    write_point_vertex( *ptr, points.bottomleft );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ptr->set_texture1_x( ar.get_left() );
    ptr->set_texture1_y( ar.get_bottom() );
    ++ptr;
    
    *(ptr++) = buffer[2];
    
    *(ptr++) = buffer[1];
    
    write_point_vertex( *ptr, points.bottomright );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ptr->set_texture1_x( ar.get_right() );
    ptr->set_texture1_y( ar.get_bottom() );
    ++ptr;
    
    return 6;
}


/// _f[^ւ̋`W
/**
 * AXyNggpȂo[WłB
 *
 * @param buffer [out] ݐ̒_obt@
 * @param points [in] WXg (擪珇ɁuvuEvuEvuv)
 * @param diffuse [in] fBt[YF
 * @param z [in] Z W
 * @return ܂ꂽ_
 */
template < typename vertex_t >
int write_points_trilist ( vertex_t * buffer, const BK::ProjectionInfo::destination_t & points, D3DCOLOR diffuse, float z = 1.0 )
{
    vertex_t * ptr = buffer;
    
    write_point_vertex( *ptr, points.topleft );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ++ptr;
    
    write_point_vertex( *ptr, points.topright );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ++ptr;
    
    write_point_vertex( *ptr, points.bottomleft );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ++ptr;
    
    *(ptr++) = buffer[2];
    
    *(ptr++) = buffer[1];
    
    write_point_vertex( *ptr, points.bottomright );
    ptr->set_z( z );
    ptr->set_rhw( 1 );
    ptr->set_diffuse( diffuse );
    ++ptr;
    
    return 6;
}


} /* namespace DirectX */
} /* namespace BK */


/*   DirectX ֐` ()
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// DirectInput8 ̃foCX񃊃Xg
typedef std::list< DIDEVICEINSTANCE > inputdevinst_list_t;


/// DirectInput foCX̃CX^Xׂė񋓂
/**
 * @param obj [in] DirectInput foCX
 * @param list [out] foCX̃Xg
 */
void enum_input_devices ( IDirectInput8 * obj, inputdevinst_list_t * list );


/// DirectInput foCXCX^X̏𕶎ɕϊ
std::string inspect_input_device_instance ( DIDEVICEINSTANCE const & inst );


} /* namespace DirectX */
} /* namespace BK */


#endif /* _BODY_UTILITY_DIRECTX_H_20030913Sat_075134_ */
