/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - OtBbNfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: OtBbNfoCX
 *
 * OtBbNfoCX̎񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/23
 */
#ifndef _BODY_GRAPHIC_GRAPHICDEVICE_H_20031223Tue_212955_
#define _BODY_GRAPHIC_GRAPHICDEVICE_H_20031223Tue_212955_


/*   foCXNX`
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCX (DirectX)
/**
 * Win32 p̃OtBbNfoCXłB
 * DirectX9 gp܂B
 */
class Dx9GraphicDevice : public GraphicDevice
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static Dx9GraphicDevice * singleton_object;
    
public: /* static \bh */
    
    /// \zꂽAvP[VfoCX擾
    static Dx9GraphicDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* GraphicDevice C^[tFCX */
    
    /// obNobt@XN[ɓ]
    virtual void update_screen ( void );
    
    /// obNobt@\LoX̎擾
    virtual Canvas * create_canvas ( Rect2 const * area = NULL );
    
    /// XN[̃tB
    virtual void fill_screen ( const Color & color );
    
    /// XN[̎ẅtB
    virtual void fill_screen ( const Rect2 & r, const Color & color );
    
    /// XN[ɃsN`]
    virtual void blit_picture ( const Point2 & p, Picture * pict, const Rect2 * rect = NULL );
    
    /// ̃sN`𐶐
    virtual Picture * create_picture ( const Size2 & size );
    
    /// t@CsN`[h
    virtual Picture * load_picture_from_file ( const char * filename );
    
    /// ̃t@CsN`[h
    virtual Picture * load_picture_from_memory ( void const * src, unsigned int cap );
    
    /// ̃C[W𐶐
    virtual Image * create_image ( const Size2 & size );
    
    /// t@CC[W[h
    virtual Image * load_image_from_file ( const char * filename );
    
    /// ̃t@CC[W[h
    virtual Image * load_image_from_memory ( void const * src, unsigned int cap );
    
    /// ̃sN`f[^𐶐
    virtual PictureData * create_picture_data ( const Size2 & size );
    
    /// t@CsN`f[^[h
    virtual PictureData * load_picture_data_from_file ( const char * filename );
    
    /// ̃t@CsN`f[^[h
    virtual PictureData * load_picture_data_from_memory ( void const * src, unsigned int cap );
    
private:
    
    /// DirectGraphics IuWFNg
    IDirect3D9 * ptr_graphics;
    
    /// DirectGraphics foCXIuWFNg
    IDirect3DDevice9 * ptr_graphics_device;
    
    /// obNobt@T[tFX
    Dx9Surface * ptr_back_surface;
    
    /// eNX`ɍœKȃsNZtH[}bg
    D3DFORMAT num_texture_format;
    
    /// S\[X̉s
    /** RXgN^̓fXgN^Ŏgp܂ */
    void release_all ( void );
    
public:
    
    /// RXgN^
    Dx9GraphicDevice ( void );
    
    /// fXgN^
    ~Dx9GraphicDevice ();
    
    /// DirectGraphics IuWFNg擾
    /**
     * foCXJn͕K NULL Ԃ܂B
     */
    IDirect3D9 * get_direct_graphics ( void )
    {
        return ptr_graphics;
    }
    
    /// DirectGraphics foCXIuWFNg擾
    /**
     * foCXJn͕K NULL Ԃ܂B
     */
    IDirect3DDevice9 * get_direct_graphics_device ( void )
    {
        return ptr_graphics_device;
    }
    
    /// obNobt@T[tFX擾
    Dx9Surface * get_backbuffer ( void )
    {
        return ptr_back_surface;
    }
    
    /// obNobt@NA
    void clear_screen ( D3DCOLOR color );
    
    /// obNobt@NA
    void clear_screen ( Rect2 const & r, D3DCOLOR color );
    
    /// XN[ɃT[tFX]
    void copy_surface ( Point2 const & p, Dx9Surface & surface, const Rect2 * rect = NULL );
    
    /// ItXN[T[tFX𐶐
    /**
     * IDirect3DDevice9::CreateOffscreenPlainSurface ̃bp[B
     * p[^͓B
     */
    HRESULT CreateOffscreenPlainSurface ( const Size2 & size, D3DFORMAT format, D3DPOOL pool, IDirect3DSurface9 * * surface );
    
    /// x 1 eNX`𐶐
    /**
     * IDirect3DDevice9::Createtexture ̃bp[B
     * p[^͓B
     */
    HRESULT CreateLv1Texture ( const Size2 & size, D3DFORMAT format, D3DPOOL pool, IDirect3DTexture9 * * texture );
    
    /// eNX`ɂ钸_̃_O
    /**
     * Op`Xgŕ\ꂽv~eBu̕`s܂B
     * vptr Ɋi[ꂽ_̐́Atriangles ~ 3 ƓȂ΂Ȃ܂B
     * vsize ́Ae_f[^TCYłB
     *
     * texture  NULL nꂽꍇAeNX`͎gp܂B
     * ̏ꍇA_^ɂ̓eNX`܂܂Ȃ̂gpĂB
     *
     * @param texture [in] gpeNX`
     * @param fvf [in] _tH[}bgʎq
     * @param triangles [in] v~eBu
     * @param vptr [in] _Xg
     * @param vsize [in] e_̃f[^TCY
     */
    void render_triangle ( Dx9Texture * texture, DWORD fvf, UINT triangles, const void * vptr, UINT vsize );
    
    /// eNX`ɂ钸_̃_O
    /** w肳ꂽ_^ɂAIɃp[^肳܂B */
    template < typename vertex_t >
    void render_triangle ( Dx9Texture * texture, UINT triangles, vertex_t const * vptr )
    {
        render_triangle( texture, vertex_t::get_vertex_format(), triangles, vptr, sizeof(vertex_t) );
    }
    
    /// eNX`ɂ钸_̃_O
    /** w肳ꂽobt@sA_Os܂B */
    template < typename vertex_t, typename info_t >
    void render_triangle ( Dx9Texture * texture, DirectX::ProjectionVertexBuffer< vertex_t, info_t > & buf )
    {
        buf.execute();
        render_triangle( texture, buf.get_vertex_length() / 3, buf.get_vertex_array() );
    }
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_GRAPHICDEVICE_H_20031223Tue_212955_ */
