/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - CvbgfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: CvbgfoCX
 *
 * DirectX g̓foCX̎`܂B
 *
 * @author ABE Shigeru
 * @date 2003/09/15
 */
#ifndef _BODY_INPUT_MAIN_H_20030915Mon_184812_
#define _BODY_INPUT_MAIN_H_20030915Mon_184812_


/*   CN[h
------------------------------------------------------------------- */
#include "schema/main.h"


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// DirectInput foCX
/**
 * DirectInput ɂfoCX̊NXłB
 * efoCX́AXL[}Œ`ꂽNXƁÅNXp܂B
 */
class InputDevice
{
private:
    
    /// foCXCX^X
    DIDEVICEINSTANCE  obj_instance;
    
    /// DirectInput foCX
    IDirectInputDevice8 * obj_device;
    
protected:
    
    /// foCXf[^擾
    /**
     * foCXXgĂꍇAIɍĎ擾݂܂B
     * G[ꍇ directx_exception O܂B
     */
    void get_device_state ( DWORD size, LPVOID buf );
    
    /// foCXf[^擾
    template < typename data_t >
    void get_device_state ( data_t * dat )
    {
        get_device_state( sizeof(data_t), dat );
    }
    
public:
    
    /// RXgN^
    InputDevice ( IDirectInput8 * dev, DIDEVICEINSTANCE const & inst, DIDATAFORMAT const & format );
    
    /// fXgN^
    virtual ~InputDevice ();
    
    /// C^[tFCX擾
    IDirectInputDevice8 * get_interface ( void )
    {
        return obj_device;
    }
    
    /// CX^Xf[^擾
    DIDEVICEINSTANCE const & get_device_instance ( void ) const
    {
        return obj_instance;
    }
    
};


} /* namespace DirectX */
} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// }EX (DirectX)
/**
 * gpł{^ 5 łB
 *  - 0: {^
 *  - 1: E{^
 *  - 2: zC[ () (+)
 *  - 3: zC[ () (-)
 *  - 4: zC[NbN
 */
class Dx8MouseInput : public MouseInput, public DirectX::InputDevice
{
private:
    
    /// ݂̃}EX̏
    DIMOUSESTATE obj_state;
    
public:
    
    /// RXgN^
    Dx8MouseInput ( IDirectInput8 * dev, DIDEVICEINSTANCE const & inst );
    
    /// fXgN^
    ~Dx8MouseInput ();
    
    /* ---- p\bh ---- */
    
    /// foCX̏ԂXV
    void update ( void );
    
    /// L[̕ωʂ擾
    Point2 get_delta ( void ) const;
    
    /// gpł{^̐擾
    int count_button ( void ) const
    {
        return 5;
    }
    
    /// foCX擾
    const char * get_name ( void ) const;
    
    /// w͈͂̃{^Ԃ擾
    void get_button_states ( int * index, int start, int count ) const;
    
};


/// L[{[h (DirectX)
class Dx8KeyboardInput : public KeyboardInput, public DirectX::InputDevice
{
private:
    
    /// ݂̃L[{[h̏
    char ary_state [ 256 ];
    
public:
    
    /// RXgN^
    Dx8KeyboardInput ( IDirectInput8 * dev, DIDEVICEINSTANCE const & inst );
    
    /// fXgN^
    ~Dx8KeyboardInput ();
    
    /* ---- p\bh ---- */
    
    /// foCX̏ԂXV
    void update ( void );
    
    /// L[̕ωʂ擾
    Point2 get_delta ( void ) const;
    
    /// gpł{^̐擾
    int count_button ( void ) const
    {
        return 256;
    }
    
    /// foCX擾
    const char * get_name ( void ) const;
    
    /// w͈͂̃{^Ԃ擾
    void get_button_states ( int * index, int start, int count ) const;
    
};


/// Q[pbh (DirectX)
class Dx8GamepadInput : public GamepadInput, public DirectX::InputDevice
{
private:
    
    /// ݂̃pbh̏
    DIJOYSTATE obj_state;
    
    /// gpł{^
    int  num_button_count;
    
public:
    
    /// RXgN^
    Dx8GamepadInput ( IDirectInput8 * dev, DIDEVICEINSTANCE const & inst );
    
    /// fXgN^
    ~Dx8GamepadInput ();
    
    /* ---- p\bh ---- */
    
    /// foCX̏ԂXV
    void update ( void );
    
    /// L[̕ωʂ擾
    Point2 get_delta ( void ) const;
    
    /// gpł{^̐擾
    int count_button ( void ) const;
    
    /// foCX擾
    const char * get_name ( void ) const;
    
    /// w͈͂̃{^Ԃ擾
    void get_button_states ( int * index, int start, int count ) const;
    
};


} /* namespace BK */


/*   foCXNX`
------------------------------------------------------------------- */
namespace BK {


/// CvbgfoCX (DirectX)
/**
 * DirectX gp̓foCXłB
 */
class Dx8InputDevice : public InputDevice
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static Dx8InputDevice * singleton_object;
    
public: /* static \bh */
    
    /// \zꂽAvP[VfoCX擾
    static Dx8InputDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
public:
    
    /// foCX
    /**
     * input_object  DirectX::InputDevice ւ̕ϊ݂܂B
     */
    struct device_t
    {
        DIDEVICEINSTANCE  device_instance;
        AbstractInput *   input_object;
        
        /// RXgN^
        device_t ( DIDEVICEINSTANCE const & inst )
                : device_instance (inst),
                  input_object (NULL)
        {
        }
        
        /// RubyObject ւ̕ϊ
        operator RubyObject * ( void )
        {
            return (input_object == NULL) ? NULL : input_object;
        }
    };
    
private:
    
    /// foCXXg^
    typedef std::list < device_t > device_list_t;
    
    /// DirectInput IuWFNg
    IDirectInput8 * ptr_direct_input;
    
    /// foCXXg
    device_list_t ary_device;
    
private:
    
    /// ۗLIuWFNg̉
    /** ׂẴf[^܂B */
    void release_all ( void );
    
    /// w肳ꂽCfNX̃foCX擾
    device_t * device_at ( int index );
    
    /// w肳ꂽCfNX̃foCX擾 (const )
    device_t const * device_at ( int index ) const;
    
    /// DirectInput foCX^Cvϊ
    static AbstractInput::type_t dwDevType_to_type ( DWORD devtype );
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* ServiceDevice C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
public: /* InputDevice p\bh */
    
    /// ڑĂfoCX̐擾
    int count_device ( void ) const;
    
    /// ڑĂfoCX̖̂擾
    std::string get_device_name ( int index ) const;
    
    /// ڑĂfoCX̃^Cv擾
    AbstractInput::type_t get_device_type ( int index ) const;
    
    /// foCX𗘗p\Ԃɂ
    /**
     * x\zfoCX́Ał܂B
     * CvbgfoCX̔jƓɉ܂B(DirectX ̎dlc)
     */
    AbstractInput * setup_device ( int index );
    
    /// foCX̓o^
    void release_device ( int index );
    
public:
    
    /// RXgN^
    Dx8InputDevice ( void );
    
    /// fXgN^
    ~Dx8InputDevice ();
    
    /// DirectInput IuWFNg擾
    IDirectInput8 * get_direct_input ( void )
    {
        return ptr_direct_input;
    }
    
};


} /* namespace BK */


#endif /* _BODY_INPUT_MAIN_H_20030915Mon_184812_ */
