/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - AvP[VfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: AvP[VfoCX
 *
 * AvP[V̊I@\񋟂foCX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/16
 */
#ifndef _SCHEMA_APPLICATION_APPLICATIONDEVICE_H_20031216Tue_075645_
#define _SCHEMA_APPLICATION_APPLICATIONDEVICE_H_20031216Tue_075645_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCX
/**
 * AvP[V𓮍삳邽߂ɕKvȃIuWFNgi[邽߂̃foCXłB
 * Black Kit ̑唼̃foCX́AAvP[VfoCX\złȂΓ삵܂B
 */
class ApplicationDevice : public ServiceDevice
{
public:
    
    /// eNX
    typedef ServiceDevice parent_t;
    
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static ApplicationDevice * singleton_object;
    
    /// ^C}[̏ FPS
    static unsigned int num_initial_fps;
    
    /// AvP[V̏LvV
    static std::string str_initial_caption;
    
    /// AvP[V̏TCY
    static Size2 obj_initial_size;
    
    /// AvP[Ṽt[^C}[ASY
    static std::string str_initial_timer_algorithm;
    
public: /* static \bh */
    
    /// \zꂽAvP[VfoCX擾
    static ApplicationDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
    /// MA̓o^
    /**
     * @see add_gear()
     */
    static void global_add_gear ( Gear & gear )
    {
        if( singleton_object != NULL ) {
            singleton_object->add_gear( gear );
        }
    }
    
    /// MA̍폜
    /**
     * @see erase_gear()
     */
    static Gear * global_erase_gear ( Gear * gear )
    {
        return (singleton_object != NULL) ? singleton_object->erase_gear( gear ) : NULL;
    }
    
    /// ^C}[̏ FPS 擾
    static unsigned int get_initial_fps ( void )
    {
        return num_initial_fps;
    }
    
    /// ^C}[̏ FPS ݒ肷
    static void set_initial_fps ( unsigned int fps )
    {
        num_initial_fps = fps;
    }
    
    /// AvP[V̏LvV擾
    static const char * get_initial_caption ( void )
    {
        return str_initial_caption.c_str();
    }
    
    /// AvP[V̏LvVݒ肷
    static void set_initial_caption ( const char * str )
    {
        str_initial_caption = str;
    }
    
    /// AvP[V̏TCY擾
    static const Size2 & get_initial_size ( void )
    {
        return obj_initial_size;
    }
    
    /// AvP[V̏TCYݒ肷
    static void set_initial_size ( const Size2 & size )
    {
        obj_initial_size = size;
    }
    
    /// AvP[V̏^C}[ASY擾
    static const char * get_initial_timer_algorithm ( void )
    {
        return str_initial_timer_algorithm.c_str();
    }
    
    /// AvP[V̏^C}[ASYݒ肷
    static void set_initial_timer_algorithm ( const char * str )
    {
        str_initial_timer_algorithm = str;
    }
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* ServiceDevice C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// foCX̎擾
    virtual const char * get_device_name ( void ) const;
    
protected: /* ApplicationDevice C^[tFCX */
    
    /// C[vJñCxgnh
    /**
     * e[vJnƂɎsCxgnhłB
     */
    virtual void on_each_loop_beginning ( void ) = 0;
    
public: /* ApplicationDevice C^[tFCX */
    
    /// AvP[V̈̑傫擾
    /**
     * AvP[VgpĂOtBbN̈̑傫擾܂B
     *
     * @return OtBbN̈̃TCY
     */
    virtual Size2 get_application_area_size ( void ) const = 0;
    
public:
    
    /// [v~fpIuWFNg
    /**
     * ApplicationDevice::do_loop() ŎgpA~p̃IuWFNgłB
     */
    class Loop
    {
    public:
        
        /// [v~f
        /**
         * [v~邩ǂ𔻒f邽߂ɗp܂B
         *
         * @retval true [v~
         * @retval false [v𑱍s
         */
        virtual bool operator () ( void ) = 0;
        
    };
    
private:
    
    /// MAXg̃Rei
    GearStorage obj_gears;
    
    /// gp^C}[̃ASY
    std::string str_timer_algorithm;
    
    /// gpt[^C}[
    FrameTimer * ptr_timer;
    
    /// FPS Oɏo͂ (~b)
    /** O INFO xŏo͂܂B */
    FrameTimer::time_t num_fps_logging_interval;
    
public:
    
    /// RXgN^
    ApplicationDevice ( void );
    
    /// fXgN^
    virtual ~ApplicationDevice ();
    
    /// MA̓o^
    /**
     * w肳ꂽMAo^܂B
     *
     * @param gear [in] o^MA
     */
    void add_gear ( Gear & gear );
    
    /// MA̍폜
    /**
     * w肳ꂽMA̓o^܂B
     * X̎Ao^ĂȂMAnĂO͔܂B
     *
     * @param gear [in] 폜MA
     * @return 폜ꂽMA
     * @retval NULL o^ĂȂMA
     */
    Gear * erase_gear ( Gear * gear );
    
    /// t[^C}[gpASY̐ݒ
    /**
     * @param name [in] ASY
     */
    void set_timer_algorithm ( const char * name );
    
    /// FPS ̐ݒ
    /**
     * t[^C}[̎ݒ肵܂B
     *
     * @param fps [in] t[^C}[ɐݒ肷 FPS
     */
    void set_fps ( unsigned int fps );
    
    /// FPS ̎擾
    /**
     * ݐݒ肳Ăt[^C}[̎擾܂B
     *
     * @return t[^C}[ɐݒ肳Ă FPS
     */
    unsigned int get_fps ( void ) const;
    
    /// FPS O֏o͂Ԋu̐ݒ
    /**
     * ݒ肳ꂽԊԊuŁAFPS OfoCXɏo͂܂B
     * Ԃɂ̓~bw肵܂B
     *
     * @param interval [in] Ԋu (~b)
     */
    void set_fps_logging_interval ( FrameTimer::time_t interval );
    
    /// FPS O֏o͂Ԋu̎擾
    /**
     * ݐݒ肳Ă郍Oւ FPS o͊Ԋu擾܂B
     *
     * @return Oւ̏o͊Ԋu
     */
    FrameTimer::time_t get_fps_logging_interval ( void ) const;
    
    /// AvP[V[v̋N
    /**
     * AvP[V[vN܂B
     * [v̋ȉɎ܂B
     *  1. [v̏I (IȂ 6. )
     *  2. MA̎s
     *  3. XN[̃_O
     *  4. t[҂
     *  5. 1. ɖ߂
     *  6. I
     *
     * @param term [in] [v̏IIuWFNg
     */
    void do_loop ( Loop & term );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCX̏
void Init_application_ApplicationDevice ( void );


/// AvP[VfoCX̏I
void Exit_application_ApplicationDevice ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_APPLICATIONDEVICE_H_20031216Tue_075645_ */
