/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - t[^C}[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: t[^C}[
 *
 * AvP[VŎgpt[^C}[̃NX`܂B
 *
 * @author ABE Shigeru
 * @date 2004/03/22
 */
#ifndef _SCHEMA_APPLICATION_FRAMETIMER_H_20040322Mon_222903_
#define _SCHEMA_APPLICATION_FRAMETIMER_H_20040322Mon_222903_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// t[^C}[
/**
 * t[v邽߂̃^C}[IuWFNg`܂B
 */
class FrameTimer
{
public:
    
    /// Ԍ^
    /** Ȃ炸 unsigned long ɒ`܂B */
    typedef unsigned long time_t;
    
public: /* static \bh */
    
    /// Ԃ̍擾
    static time_t get_time_distance ( time_t prev, time_t curr )
    {
        if( prev <= curr ) {
            return curr - prev;
        } else {
            return curr + (std::numeric_limits< time_t >::max() - prev);
        }
    }
    
protected: /* FrameTimer C^[tFCX */
    
    /// t[҂
    /**
     * ̃t[܂őҋ@܂B
     *
     * @return t[
     */
    virtual time_t on_wait_frame ( void ) = 0;
    
private:
    
    /// ^C}[ FPS
    const unsigned int num_fps;
    
    /// t[s̃Xg
    time_t * ary_history;
    
    /// t[s̒
    unsigned int num_history_length;
    
    /// t[š݂݈̏ʒu
    unsigned int num_history_index;
    
public:
    
    /// RXgN^
    /**
     * @param fps [in] ^C}[ FPS
     * @param curr [in] ^C}[̎ (~b)
     */
    FrameTimer ( unsigned int fps, time_t curr );
    
    /// fXgN^
    virtual ~FrameTimer ();
    
    /// t[s̃Xgݒ肷
    /**
     *  1 ͐ݒł܂B
     */
    void set_history_length ( unsigned int len );
    
    /// ^C}[ FPS 擾
    unsigned int get_fps ( void ) const
    {
        return num_fps;
    }
    
    /// t[s̃Xg𓾂
    /**
     * Œł 1 Ԃ鎖͕ۏ؂܂B
     */
    unsigned int get_history_length ( void ) const
    {
        return num_history_length;
    }
    
    /// t[s𓾂
    /**
     * w肳ꂽȑÕt[sꂽ擾܂B
     * ͈͊O̒lw肳ꂽꍇ out_of_range_exception O܂B
     * t[ʒuɂ 1 ȏ̒lw肵܂B
     *
     * @param n [in] 擾t[̈ʒu
     * @return t[sꂽ
     * @exception out_of_range_exception w肳ꂽʒu͈͊O
     */
    time_t get_history ( unsigned int n ) const;
    
    /// t[҂
    /**
     * ̃t[܂őҋ@܂B
     *
     * @return t[
     */
    time_t wait_frame ( void );
    
    /// ݂ FPS l擾
    /**
     * ^C}[̉ғт FPS 擾܂B
     */
    double count_fps ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// t[^C}[̏
void Init_application_FrameTimer ( void );


/// t[^C}[̏I
void Exit_application_FrameTimer ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_FRAMETIMER_H_20040322Mon_222903_ */
