/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - F
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: F
 *
 * Fi[邽߂̃NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_COLOR_H_20031211Thu_090605_
#define _SCHEMA_UTILITY_COLOR_H_20031211Thu_090605_


/*   萔錾
------------------------------------------------------------------- */
namespace BK {


/// Fvf̍ől
const unsigned int COLOR_ELEMENT_MAX = 255;


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// Ff[^
/**
 * F\IuWFNgłB
 * evf 0 ` 255 ܂B
 */
class Color
{
private: /* static ϐ */
    
    /// Ruby NX: Color
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Color * value_to_data ( VALUE obj )
    {
        return ruby_cast< Color >( obj );
    }
    
public:
    
    /// vfp̃f[^^
    typedef unsigned char element_t;
    
private:
    
    /// ԗvf
    element_t  num_red;
    
    /// vf
    element_t  num_blue;
    
    /// Ηvf
    element_t  num_green;
    
public:
    
    /// RXgN^
    Color ( void )
            : num_red (0),
              num_blue (0),
              num_green (0)
    {
    }
    
    /// RXgN^
    Color ( element_t r, element_t g, element_t b );
    
    /// ԗvf擾
    int get_red ( void ) const
    {
        return num_red;
    }
    
    /// vf擾
    int get_blue ( void ) const
    {
        return num_blue;
    }
    
    /// Ηvf擾
    int get_green ( void ) const
    {
        return num_green;
    }
    
    /// ԗvfݒ肷
    /** ͈̓`FbNs܂B */
    void set_red ( element_t r );
    
    /// vfݒ肷
    /** ͈̓`FbNs܂B */
    void set_blue ( element_t b );
    
    /// Ηvfݒ肷
    /** ͈̓`FbNs܂B */
    void set_green ( element_t g );
    
    /// Svf̈ꊇݒ
    void set_color ( element_t r, element_t g, element_t b )
    {
        set_red( r );
        set_green( g );
        set_blue( b );
    }
    
    /// vr
    bool operator == ( Color const & c ) const
    {
        return
            (get_red() == c.get_red()) &&
                (get_green() == c.get_green()) &&
                    (get_blue() == c.get_blue());
    }
    
    /// uh֐
    /**
     * c1:c2  a:b ŃuhJ[f[^擾܂B
     */
    static Color blend ( Color const & c1, Color const & c2, unsigned int a, unsigned int b )
    {
        unsigned int sum = a + b;
        return Color (
            (c1.get_red() * a + c2.get_red() * b) / sum,
            (c1.get_green() * a + c2.get_green() * b) / sum,
            (c1.get_blue() * a + c2.get_blue() * b) / sum
        );
    }
    
    /// ̃IuWFNg\擾 (string )
    std::string to_string ( void ) const;
    
    /// ̃IuWFNg\擾
    /**
     * @param buf [out] ̏o͐
     * @param cap [in] o͐̃obt@e (k܂)
     * @return o͂ꂽ char 
     */
    int get_string ( char * buf, unsigned int cap ) const;
    
    /// ̃IuWFNgQƂ Ruby IuWFNg𐶐
    VALUE create_ruby_reference ( void );
    
    /// ̃IuWFNgRs[ Ruby IuWFNg𐶐
    VALUE create_ruby_object ( void ) const;
    
};


/// x̐Ff[^
/**
 * x𔺂Ff[^łB
 * x 0 ` 255 ̒l܂B
 */
class AlphaColor : public Color
{
private: /* static ϐ */
    
    /// Ruby NX: AlphaColor
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static AlphaColor * value_to_data ( VALUE obj )
    {
        // Color |[tBbN^łȂ̂ reinterpret_cast ɂȂ
        return reinterpret_cast< AlphaColor * >( ruby_cast< Color >( obj ) );
    }
    
private:
    
    /// xvf
    element_t  num_alpha;
    
public:
    
    /// RXgN^
    AlphaColor ( void )
            : num_alpha (COLOR_ELEMENT_MAX)
    {
    }
    
    /// RXgN^
    AlphaColor ( Color const & c, element_t alpha = COLOR_ELEMENT_MAX )
            : Color (c),
              num_alpha (alpha)
    {
    }
    
    /// RXgN^
    AlphaColor ( element_t r, element_t g, element_t b, element_t alpha = COLOR_ELEMENT_MAX )
            : Color (r, g, b),
              num_alpha (alpha)
    {
    }
    
    /// xvf擾
    int get_alpha ( void ) const
    {
        return num_alpha;
    }
    
    /// xvfݒ肷
    /** ͈̓`FbNs܂B */
    void set_alpha ( element_t a );
    
    /// Svf̈ꊇݒ
    void set_alpha_color ( element_t r, element_t g, element_t b, element_t a )
    {
        set_color( r, g, b );
        set_alpha( a );
    }
    
    /// vr
    bool operator == ( AlphaColor const & c ) const
    {
        return
            Color::operator==( c ) &&
                (get_alpha() == c.get_alpha());
    }
    
    /// uh֐
    Color blend ( Color const & target ) const
    {
        return Color::blend( *this, target, get_alpha(), COLOR_ELEMENT_MAX - get_alpha() );
    }
    
    /// ̃IuWFNg\擾 (string )
    std::string to_string ( void ) const;
    
    /// ̃IuWFNg\擾
    /**
     * @param buf [out] ̏o͐
     * @param cap [in] o͐̃obt@e (k܂)
     * @return o͂ꂽ char 
     */
    int get_string ( char * buf, unsigned int cap ) const;
    
    /// Zq
    AlphaColor & operator = ( Color const & c )
    {
        set_color( c.get_red(), c.get_green(), c.get_blue() );
        num_alpha = COLOR_ELEMENT_MAX;
        return *this;
    }
    
    /// ̃IuWFNgQƂ Ruby IuWFNg𐶐
    VALUE create_ruby_reference ( void );
    
    /// ̃IuWFNgRs[ Ruby IuWFNg𐶐
    VALUE create_ruby_object ( void ) const;
    
};


} /* namespace BK */


/*   O[o֐
------------------------------------------------------------------- */
namespace BK {


/// 񂩂 Color ւ̕ϊ
/**
 * "#rrggbb" `̕ŃIuWFNg܂B
 * 󂯕t镶̃tH[}bg͈ȉ̒ʂłB
 *  - RRGGBB (擪 # Ȃ)
 *  - #RRGGBB (擪 # )
 * sȈnꂽꍇ́AO܂B
 */
Color str_to_Color ( const char * src );


/// Ruby IuWFNg Color ւ̕ϊ
/**
 *  Color \zƓlłB
 * C++ O܂B
 */
Color value_to_Color ( VALUE obj );


/// 񂩂 AlphaColor ւ̕ϊ
/**
 * "#rrggbb@aa" `̕ŃIuWFNg܂B
 * sȈnꂽꍇ́AO܂B
 */
AlphaColor str_to_AlphaColor ( const char * src );


/// Ruby IuWFNg AlphaColor ւ̕ϊ
/**
 *  AlphaColor \zƓlłB
 * C++ O܂B
 */
AlphaColor value_to_AlphaColor ( VALUE obj );


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_Color ( void );


/// [eBeB̏I
void Exit_utility_Color ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_COLOR_H_20031211Thu_090605_ */
