/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - `
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: `
 *
 * 񎟌`\̃f[^`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_RECT2_H_20031211Thu_114436_
#define _SCHEMA_UTILITY_RECT2_H_20031211Thu_114436_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// 񎟌Ԃɂ`f[^
/**
 * [A[A[AE[Al̗vff[^łB
 * `̂Au[ < [vu[ < E[v𖞂̂AKꂽ`ƌĂт܂B
 */
class Rect2
{
private: /* static ϐ */
    
    /// Ruby NX: Rect2
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Rect2 * value_to_data ( VALUE obj )
    {
        return ruby_cast< Rect2 >( obj );
    }
    
public:
    
    /// f[^^
    typedef int num_t;
    
private:
    
    /// [
    num_t  num_left;
    
    /// E[
    num_t  num_right;
    
    /// [
    num_t  num_top;
    
    /// [
    num_t  num_bottom;
    
protected:
    
    /// [ƉE[̒lւ
    void swap_horizontal ( void )
    {
        std::swap( num_left, num_right );
    }
    
    /// [Ɖ[̒lւ
    void swap_vertical ( void )
    {
        std::swap( num_top, num_bottom );
    }
    
public:
    
    /// [̈ʒu擾
    const num_t & get_left ( void ) const
    {
        return num_left;
    }
    
    /// [̈ʒuݒ肷
    const num_t & set_left ( const num_t & v )
    {
        return num_left = v;
    }
    
    /// E[̈ʒu擾
    const num_t & get_right ( void ) const
    {
        return num_right;
    }
    
    /// E[̈ʒuݒ肷
    const num_t & set_right ( const num_t & v )
    {
        return num_right = v;
    }
    
    /// [̈ʒu擾
    const num_t & get_top ( void ) const
    {
        return num_top;
    }
    
    /// [̈ʒuݒ肷
    const num_t & set_top ( const num_t & v )
    {
        return num_top = v;
    }
    
    /// [̈ʒu擾
    const num_t & get_bottom ( void ) const
    {
        return num_bottom;
    }
    
    /// [̈ʒuݒ肷
    const num_t & set_bottom ( const num_t & v )
    {
        return num_bottom = v;
    }
    
    /// `ݒ肷
    Rect2 & set_rect ( const num_t & left, const num_t & top, const num_t & right, const num_t & bottom )
    {
        set_left( left );
        set_top( top );
        set_right( right );
        set_bottom( bottom );
        return *this;
    }
    
    /// `ݒ肷
    Rect2 & set_rect ( const Rect2 & r )
    {
        return set_rect( r.get_left(), r.get_top(), r.get_right(), r.get_bottom() );
    }
    
    /// `ݒ肷
    Rect2 & set_rect ( const Size2 & s )
    {
        return set_rect( 0, 0, s.get_width(), s.get_height() );
    }
    
    /// `ݒ肷
    Rect2 & set_rect ( const Point2 & p1, const Point2 & p2 )
    {
        return set_rect( p1.get_x(), p1.get_y(), p2.get_x(), p2.get_y() );
    }
    
    /// `ݒ肷
    Rect2 & set_rect ( const Point2 & p, const Size2 & s )
    {
        return set_rect( p.get_x(), p.get_y(), p.get_x() + s.get_width(), p.get_y() + s.get_height() );
    }
    
    /// RXgN^
    Rect2 ( void )
    {
        set_rect( 0, 0, 0, 0 );
    }
    
    /// RXgN^
    Rect2 ( const Rect2 & r )
    {
        set_rect( r.get_left(), r.get_top(), r.get_right(), r.get_bottom() );
    }
    
    /// RXgN^
    Rect2 ( const num_t & larg, const num_t & targ, const num_t & rarg, const num_t & barg )
    {
        set_rect( larg, targ, rarg, barg );
    }
    
    /// RXgN^
    Rect2 ( const Size2 & s )
    {
        set_rect( s );
    }
    
    /// RXgN^
    Rect2 ( const Point2 & p1, const Point2 & p2 )
    {
        set_rect( p1, p2 );
    }
    
    /// RXgN^
    Rect2 ( const Point2 & p, const Size2 & s )
    {
        set_rect( p, s );
    }
    
    /// 擾
    /** KĂȂꍇ͕̒lԂ邩܂B */
    num_t get_width ( void ) const
    {
        return num_right - num_left;
    }
    
    /// c擾
    /** KĂȂꍇ͕̒lԂ邩܂B */
    num_t get_height ( void ) const
    {
        return num_bottom - num_top;
    }
    
    /// `̍ʒu擾
    /** KĂȂꍇ͍Ƃ͌܂B */
    Point2 get_point ( void ) const
    {
        return Point2( get_left(), get_top() );
    }
    
    /// TCY擾
    Size2 get_size ( void ) const
    {
        return Size2( get_width(), get_height() );
    }
    
    /// `ł邩𒲂ׂ
    bool is_empty ( void ) const
    {
        return get_left() == get_right() || get_top() == get_bottom();
    }
    
    /// KĂ邩𒲂ׂ
    bool is_normalized ( void ) const
    {
        return get_left() <= get_right() && get_top() <= get_bottom();
    }
    
    /// ʐς擾
    unsigned int get_area ( void ) const
    {
        if( get_left() >= get_right() || get_top() >= get_bottom() ) {
            return 0;
        }
        return static_cast< unsigned int >( get_width() * get_height() );
    }
    
    /// K
    /**
     * ̋`̏A
     *  - [ʒu < E[ʒu
     *  - [ʒu < [ʒu
     * 悤ɏC܂B
     */
    Rect2 & normalize ( void )
    {
        if( get_left() > get_right() ) {
            swap_horizontal();
        }
        if( get_top() > get_bottom() ) {
            swap_vertical();
        }
        return *this;
    }
    
    /// Kꂽ`擾
    Rect2 get_normalized ( void ) const
    {
        return Rect2( std::min(get_left(), get_right()),
                      std::min(get_top(), get_bottom()),
                      std::max(get_left(), get_right()),
                      std::max(get_top(), get_bottom()) );
    }
    
    /// NbsO
    /**
     * w肳ꂽ`́uɎ܂悤ɁvA̋`̏܂B
     */
    Rect2 & clipping ( const Rect2 & r )
    {
        if( get_left() < r.get_left() ) {
            set_left( r.get_left() );
        }
        if( get_right() > r.get_right() ) {
            set_right( r.get_right() );
        }
        if( get_top() < r.get_top() ) {
            set_top( r.get_top() );
        }
        if( get_bottom() > r.get_bottom() ) {
            set_bottom( r.get_bottom() );
        }
        return *this;
    }
    
    /// NbsOꂽ`擾
    /**
     * w肳ꂽ`́uɎ܂悤Ɂvݒ肳ꂽ`擾܂B
     */
    Rect2 get_clipped ( const Rect2 & r ) const
    {
        // œKƂ̕@ԑ
        return Rect2(
            std::max(get_left(), r.get_left()),
            std::max(get_top(), r.get_top()),
            std::min(get_right(), r.get_right()),
            std::min(get_bottom(), r.get_bottom()) );
    }
    
    /// w肳ꂽ`SɊ܂ł邩ׂ
    /**
     * ̋`Aw肳ꂽ`SɓĂ邩𒲂ׂ܂B
     * ǂ̋`AKĂȂ΂Ȃ܂B
     */
    bool is_include ( const Rect2 & r ) const
    {
        return
            get_left() <= r.get_left() && r.get_right() <= get_right() &&
            get_top() <= r.get_top() && r.get_bottom() <= get_bottom();
    }
    
    /// w肳ꂽ_܂ł邩ׂ
    /**
     * gKĂȂ΂Ȃ܂B
     */
    bool is_include ( const Point2 & p ) const
    {
        return
            get_left() <= p.get_x() && p.get_x() < get_right() &&
            get_top() <= p.get_y()&& p.get_y() < get_bottom();
    }
    
    /// ʕ݂邩𒲂ׂ
    /**
     * ̋`Ǝw肳ꂽ`ɁAʗ̈悪݂邩𒲂ׂ܂B
     * ǂ̋`AKĂȂ΂Ȃ܂B
     */
    bool is_shared ( const Rect2 & r ) const
    {
        return
            std::max(get_left(), r.get_left()) >= std::min(get_right(), r.get_right()) ||
            std::max(get_top(), r.get_top()) >= std::min(get_bottom(), r.get_bottom());
    }
    
    /// [ʒû݂ړ
    Rect2 & add_left ( const num_t & n )
    {
        set_left( get_left() + n );
        return *this;
    }
    
    /// E[ʒû݂ړ
    Rect2 & add_right ( const num_t & n )
    {
        set_right( get_right() + n );
        return *this;
    }
    
    /// [ʒû݂ړ
    Rect2 & add_top ( const num_t & n )
    {
        set_top( get_top() + n );
        return *this;
    }
    
    /// [ʒû݂ړ
    Rect2 & add_bottom ( const num_t & n )
    {
        set_right( get_bottom() + n );
        return *this;
    }
    
    /// X Ɉړ
    Rect2 & move_x ( const num_t & x )
    {
        return add_left(x).add_right(x);
    }
    
    /// Y Ɉړ
    Rect2 & move_y ( const num_t & y )
    {
        return add_top(y).add_bottom(y);
    }
    
    /// xNgړ
    Rect2 operator + ( const Point2 & p ) const
    {
        return Rect2( get_left() + p.get_x(), get_top() + p.get_y(), get_right() + p.get_x(), get_bottom() + p.get_y() );
    }
    
    /// xNgړ
    Rect2 operator - ( const Point2 & p ) const
    {
        return Rect2( get_left() - p.get_x(), get_top() - p.get_y(), get_right() - p.get_x(), get_bottom() - p.get_y() );
    }
    
    /// xNgړ
    Rect2 & operator += ( const Point2 & p )
    {
        return move_x(p.get_x()).move_y(p.get_y());
    }
    
    /// xNgړ
    Rect2 & operator -= ( const Point2 & p )
    {
        return move_x(-(p.get_x())).move_y(-(p.get_y()));
    }
    
    /// vr
    bool operator == ( const Rect2 & s ) const
    {
        return
            get_left() == s.get_left() && get_right() == s.get_right() &&
            get_top() == s.get_top() && get_bottom() == s.get_bottom();
    }
    
    /// svr
    bool operator != ( const Rect2 & r ) const
    {
        return !operator==( r );
    }
    
    /// ܊֌Wr
    /** @retval true r Ɠ܂ꍇ */
    bool operator <= ( const Rect2 & r ) const
    {
        return r.is_include(*this);
    }
    
    /// ܊֌Wr
    /** @retval true r Ɠ܂ꍇ */
    bool operator >= ( const Rect2 & r ) const
    {
        return is_include(r);
    }
    
    /// ܊֌Wr
    /** @retval r ɕ܂ꍇ */
    bool operator < ( const Rect2 & r ) const
    {
        return r.is_include(*this) && (*this != r);
    }
    
    /// ܊֌Wr
    /** @retval r ܂ꍇ */
    bool operator > ( const Rect2 & r ) const
    {
        return is_include(r) && (*this != r);
    }
    
    /// ̃IuWFNg\擾 (string )
    std::string to_string ( void ) const;
    
    /// ̃IuWFNg\擾
    /**
     * @param buf [out] ̏o͐
     * @param cap [in] o͐̃obt@e (k܂)
     * @return o͂ꂽ char 
     */
    int get_string ( char * buf, unsigned int cap ) const;
    
    /// ̃IuWFNgQƂ Ruby IuWFNg𐶐
    VALUE create_ruby_reference ( void );
    
    /// ̃IuWFNgRs[ Ruby IuWFNg𐶐
    VALUE create_ruby_object ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// 2D NX̏
void Init_utility_Rect2 ( void );


/// 2D NX̏I
void Exit_utility_Rect2 ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_RECT2_H_20031211Thu_114436_ */
