/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - O
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: O
 *
 * C++ O񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2003/08/09
 */
#ifndef _SCHEMA_EXCEPTION_H_20030809Sat_181631_
#define _SCHEMA_EXCEPTION_H_20030809Sat_181631_


/*   CN[h
------------------------------------------------------------------- */
#include <ruby.h>
#include <stdarg.h>
#include <string>


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ONX
/**
 * Black Kit CuŎgpO̊NX`܂B
 * ׂĂ̗ÓÃNXƂĎȂ΂Ȃ܂B
 *
 * ̃NXgƁAObZ[WۗL邱Ƃł܂B
 * bZ[W͊SɃRs[̂ŁAOIuWFNg̓obt@̈Ă\܂B
 */
class exception_base
{
public:
    /// O^̎擾
    virtual const char * get_type ( void ) const = 0;
    
private:
    /// ObZ[W
    std::string  what_str;
    
protected:
    
    /// RXgN^
    exception_base ( void )
    {
    }
    
    /// ݒ肷
    void set_string ( const char * str, va_list arg );
    
    /// ݒ肷
    void set_string ( const std::string & s );
    
    /// IuWFNg擾
    /**
     * Ԃ镶ύXƁAObZ[Wς܂B
     */
    std::string & the_string ( void )
    {
        return what_str;
    }
    
public:
    
    /// Rs[RXgN^
    /** w肳ꂽObZ[WRs[č\z܂B */
    exception_base ( const exception_base & e )
    {
        set_string( e.get_string() );
    }
    
    /// 
    /** bZ[W̃Rs[݂̂s܂B */
    exception_base & operator = ( const exception_base & e )
    {
        set_string( e.get_string() );
        return *this;
    }
    
    /// fXgN^
    virtual ~exception_base ()
    {
    }
    
    /// G[bZ[W̎擾
    const char * what ( void ) const
    {
        return what_str.c_str();
    }
    
    /// ւ̃LXg
    operator const char * ( void ) const
    {
        return what();
    }
    
    /// IuWFNg̎擾
    const std::string & get_string ( void ) const
    {
        return what_str;
    }
};


/// IbZ[W
/**
 * Windows bZ[WȂǂɂAVXeIKvꍇɔOłB
 * EopɎg܂A܂gȂ悤ɂĂB
 */
class system_exit : public exception_base
{
public:
    const char * get_type ( void ) const
    {
        return "system_exit";
    }
    
protected:
    system_exit ( void )
    {
    }
    
public:
    explicit system_exit ( const char * format, ... );
    
};


/// ʃG[
/**
 * sɔAWIȃG[\܂B
 */
class standard_exception : public exception_base
{
public:
    const char * get_type ( void ) const
    {
        return "standard_exception";
    }
    
protected:
    standard_exception ( void )
    {
    }
    
public:
    explicit standard_exception ( const char * format, ... );
    
};


/// sG[
/**
 * sɔAʓIȃG[\܂B
 */
class runtime_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "runtime_exception";
    }
    
protected:
    runtime_exception ( void )
    {
    }
    
public:
    explicit runtime_exception ( const char * format, ... );
    
};


/// vOG[
/**
 * 炩ɃvOĂꍇ̎sG[\܂B
 */
class logic_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "logic_exception";
    }
    
protected:
    logic_exception ( void )
    {
    }
    
public:
    explicit logic_exception ( const char * format, ... );
    
};


/// G[
/**
 * ɓnꂽlsȂ߂ɔĂG[\܂B
 */
class argument_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "argument_exception";
    }
    
protected:
    argument_exception ( void )
    {
    }
    
public:
    explicit argument_exception ( const char * format, ... );
    
};


/// sG[
/**
 * s߂ɔG[܂B
 */
class no_memory_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "no_memory_exception";
    }
    
protected:
    no_memory_exception ( void )
    {
    }
    
public:
    explicit no_memory_exception ( const char * format, ... );
    
};


/// T|[gG[
/**
 * @\T|[gĂȂ߂ɔOłB
 */
class unsupported_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "unsupported_exception";
    }
    
protected:
    unsupported_exception ( void )
    {
    }
    
public:
    explicit unsupported_exception ( const char * format, ... );
    
};


/// YG[
/**
 * ͈͊O̓Yw肳ꂽꍇɔOłB
 */
class index_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "index_exception";
    }
    
protected:
    index_exception ( void )
    {
    }
    
public:
    explicit index_exception ( const char * format, ... );
    
};


/// ͈͊Op[^wG[
/**
 * w肳ꂽp[^lOłƂɔOłB
 */
class out_of_range_exception : public standard_exception
{
public:
    const char * get_type ( void ) const
    {
        return "out_of_range_exception";
    }
    
protected:
    out_of_range_exception ( void )
    {
    }
    
public:
    explicit out_of_range_exception ( const char * format, ... );
    
};


} /* namespace BK */


/*   BK-Ruby Ag (O)
------------------------------------------------------------------- */
/* ӏœl̗O𔭐ꍇ́A֐ƂĎgpĂB
 * ɂ
 *  - bZ[W̓
 *  - O^̓
 * eՂɂȂ܂BC++ OɊւĂlłB
 * OԂ́ARuby O BK::Ruby ɂȂAC++ O BK ɂȂ܂B
 *
 * ӁFO[oȗOo\bh́AȂׂAȂ悤ɂ܂B
 * łAt@C[JȗOo\bhgĂB
 */
namespace BK {


/// [C++O] IuWFNgɕKvȃIuWFNg݂Ȃ
/**
 * runtime_exception* Oo܂B
 *
 * @param target [in] 悤ƂIuWFNg̖O
 * @param required [in] KvȃIuWFNg̖O
 */
void throw_required_is_not_created ( const char * target, const char * required );


/// [C++O] sŃIuWFNg̐Ɏs
/**
 * no_memory_exception* Oo܂B
 *
 * @param name [in] IuWFNg (NXȂ)
 */
void throw_no_memory_for_object ( const char * name );


/// [C++O] ɎgpłȂf[^^w肳ꂽ
/**
 * argument_exception* Oo܂B
 *
 * @param object [in] IuWFNg
 * @param expected [in] gpƊ҂f[^^
 * @param argtype [in] w肳ꂽf[^̌^
 */
void throw_unusable_type_for_initialize ( const char * object, const char * expected, const char * argtype );


} /* namespace BK */
namespace BK {
namespace Ruby {


/// [RubyO] foCXNĂȂƂɐڑIuWFNgꂽ
/**
 * RuntimeError Oo܂B
 *
 * @param name [in] devname foCX
 */
void raise_cannot_create_connection_to_device ( const char * devname );


/// [RubyO] nꂽp[^̌^IuWFNgւ̒ǉɕsK
/**
 * ArgumentError Oo܂B
 *
 * @param owner [in] ReiIuWFNg
 * @param required [in] ҂^
 * @param param [in] p[^IuWFNg
 */
void raise_invalid_parameter_type_to_register ( const char * owner, const char * required, VALUE param );


/// [RubyO] KvȃIuWFNg\zĂȂ
/**
 * RuntimeError Oo܂B
 *
 * @param object [in] KvƂIuWFNg
 */
void raise_object_is_not_created ( const char * object );


} /* namespace Ruby */
} /* namespace BK */


#endif /* _SCHEMA_EXCEPTION_H_20030809Sat_181631_ */
