/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB
 *
 * vÕ[eBeBvf񋟂܂B
 * f[^ȂǁAIȂ̂߂܂B
 *
 * ׂẴfoCXɗD悵ēǂݍޕKv܂B
 *
 * @author ABE Shigeru
 * @date 2003/09/07
 */
#ifndef _SCHEMA_UTILITY_MAIN_H_20030907Sun_213630_
#define _SCHEMA_UTILITY_MAIN_H_20030907Sun_213630_


/*   ^`
------------------------------------------------------------------- */
namespace BK {


/// 32 rbgl
typedef unsigned int uint32;


/// 16 rbgl
typedef unsigned short uint16;


/// 8 rbgl
typedef unsigned char uint8;


/// 1 oCg
typedef unsigned char byte_t;


} /* namespace BK */


/*   O[o֐
------------------------------------------------------------------- */
namespace BK {


/// std::string Ԃ sprintf
std::string strformat ( const char * format, ... );


/// std::string Ԃ vsprintf
std::string strvformat ( const char * format, va_list arg );


/// ̐؂グ
/**
 * @param n [in] ؂グ̐l
 * @param base [in] E
 */
template < typename num_t >
num_t ceil ( num_t const & n, num_t const & base )
{
    return (n % base == 0) ? n : n + (base - (n % base));
}


/// ̐؂艺
/**
 * @param n [in] ؂グ̐l
 * @param base [in] E
 */
template < typename num_t >
num_t floor ( num_t const & n, num_t const & base )
{
    return (n % base == 0) ? n : n - (n % base);
}


/// Shift-JIS ̑oCg
/**
 * SȎ蔲Ă܂B
 */
inline bool is_sjis_lead_char ( char const & c )
{
    return (c & 0x80) != 0;
}


/// EUC ̑oCg
/**
 * EUC ͂ł̂ȁH@蔲ƎvǁcB
 */
inline bool is_euc_lead_char ( char const & c )
{
    return (c & 0x80) != 0;
}


/// ̕ϊ
/**
 * w肳ꂽ񒆂ɑ݂镶ϊ܂B
 * ϊɂāARuby ɐݒ肳ꂽR[hgp܂B
 * }`oCgR[h (R[h) ̓XLbv邽߁AR[h̕ῗł܂B
 *
 * @param str [in/out] ϊ镶
 * @param from [in] ϊ镶
 * @param to [in] ϊ̕
 * @return ϊꂽ̌
 */
unsigned int str_translate_char ( char * str, char from, char to );


/// ̈ʒu擾
/**
 * w肳ꂽ񒆂ɑ݂镶̈ʒu擾܂B
 * 擾ɂāARuby ɐݒ肳ꂽR[hgp܂B
 *
 * @param str [in] Ώە
 * @param ch [in] 镶
 * @return ̈ʒu
 * @retval -1 Ȃ
 */
int str_index_char ( const char * str, char ch );


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// z̃I[g|C^
/**
 * zɑ΂ std::auto_ptr łB
 * IuWFNg̍\z@ std::auto_ptr ƈقȂ܂B
 * auto_ary ł́Az񒷂w肵č\z܂B
 */
template < typename template_t >
class auto_ary
{
public:
    
    /// gp^
    typedef template_t element_type;
    
private:
    
    /// |C^f[^
    template_t * ptr_ary;
    
public:
    
    /// RXgN^
    auto_ary ( void )
            : ptr_ary (NULL)
    {
    }
    
    /// RXgN^
    explicit auto_ary ( unsigned int cap )
            : ptr_ary (new template_t [ cap ])
    {
    }
    
    /// RXgN^
    auto_ary ( auto_ary < template_t > & arg )
            : ptr_ary (arg.release())
    {
    }
    
    /// fXgN^
    ~auto_ary ()
    {
        delete[] ptr_ary;
    }
    
    /// |C^̎擾
    template_t * get ( void ) const
    {
        return ptr_ary;
    }
    
    /// |C^̏L
    template_t * release ( void )
    {
        template_t * ret = get();
        ptr_ary = NULL;
        return ret;
    }
    
    /// Rs[Zq
    auto_ary < template_t > & operator = ( auto_ary < template_t > & arg )
    {
        if( ptr_ary != arg.get() ) {
            delete[] ptr_ary;
        }
        ptr_ary = arg.release();
        return *this;
    }
    
};


/// map ̃f[^l (mapped_type)  delete ֐IuWFNg
/**
 * std::map ɑ΂ std::for_each Ŏgp܂B
 */
template < typename map_t >
class MapValueDeleter
{
public:
    
    void operator () ( map_t::value_type & val )
    {
        delete val.second;
    }
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "bk_exception.h"
#include "bk_ruby.h"
#include "bk_StringBuffer.h"
#include "bk_CriticalSection.h"
#include "bk_Event.h"
#include "bk_OnOffObject.h"
#include "bk_ServiceDevice.h"
#include "bk_Size2.h"
#include "bk_Point2.h"
#include "bk_Rect2.h"
#include "bk_AspectRect2.h"
#include "bk_Color.h"
#include "bk_ProjectionInfo.h"
#include "bk_Layout.h"

#include "bk_ArgScanner.h"


/*   O[o֐
------------------------------------------------------------------- */
namespace BK {


/// Ruby IuWFNg Size2 ւ̕ϊ
/**
 *  Size2 \zƓlłB
 * C++ O܂B
 */
Size2 value_to_Size2 ( VALUE obj );


/// Ruby IuWFNg Point2 ւ̕ϊ
/**
 *  Point2 \zƓlłB
 * C++ O܂B
 */
Point2 value_to_Point2 ( VALUE obj );


/// Ruby IuWFNg Rect2 ւ̕ϊ
/**
 *  Rect2 \zƓlłB
 * C++ O܂B
 */
Rect2 value_to_Rect2 ( VALUE obj );


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB֘ANX̏
void Init_utility ( void );


/// [eBeB֘ANX̏I
void Exit_utility ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_MAIN_H_20030907Sun_213630_ */
