/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - Ruby g
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: Ruby g
 *
 * Ruby  C++ pABlack Kit pɊg邽߂̋@\񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2003/08/09
 */
#ifndef _SCHEMA_EXRUBY_H_20030809Sat_184434_
#define _SCHEMA_EXRUBY_H_20030809Sat_184434_


/*   CN[h
------------------------------------------------------------------- */
#include <ruby.h>
#include "bk_exception.h"


/*   O[o֐ (Ruby \bh錾)
------------------------------------------------------------------- */


/// Ruby ̃R[obN^
typedef VALUE (* ruby_callback_t) ( ... );


/// Ruby NX̃\bh`
template < typename callback_t >
void xrb_define_method ( VALUE c, const char * name, callback_t function, int args )
{
    rb_define_method( c, name, reinterpret_cast< ruby_callback_t >(function), args );
}


/// Ruby NX̃\bh` (Ȃ)
inline void xrb_define_0arg_method ( VALUE c, const char * name, VALUE (* function) ( VALUE ) )
{
    xrb_define_method( c, name, function, 0 );
}


/// Ruby NX̃\bh` (1 )
inline void xrb_define_1arg_method ( VALUE c, const char * name, VALUE (* function) ( VALUE, VALUE ) )
{
    xrb_define_method( c, name, function, 1u );
}


/// Ruby NX̃\bh` (2 )
inline void xrb_define_2arg_method ( VALUE c, const char * name, VALUE (* function) ( VALUE, VALUE, VALUE ) )
{
    xrb_define_method( c, name, function, 2 );
}


/// Ruby NX̃\bh` (n )
inline void xrb_define_narg_method ( VALUE c, const char * name, VALUE (* function) ( int, VALUE *, VALUE ) )
{
    xrb_define_method( c, name, function, -1 );
}


/// Ruby NX̃\bh` (z)
inline void xrb_define_larg_method ( VALUE c, const char * name, VALUE (* function) ( VALUE, VALUE ) )
{
    xrb_define_method( c, name, function, -2 );
}


/// Ruby NX̓ك\bh`
template < typename callback_t >
void xrb_define_singleton_method ( VALUE c, const char * name, callback_t function, int args )
{
    rb_define_singleton_method( c, name, reinterpret_cast<ruby_callback_t>(function), args );
}


/// Ruby NX̓ك\bh` (Ȃ)
inline void xrb_define_0arg_singleton_method ( VALUE c, const char * name, VALUE (* function) ( VALUE ) )
{
    xrb_define_singleton_method( c, name, function, 0 );
}


/// Ruby NX̓ك\bh` (1 )
inline void xrb_define_1arg_singleton_method ( VALUE c, const char * name, VALUE (* function) ( VALUE, VALUE ) )
{
    xrb_define_singleton_method( c, name, function, 1 );
}


/// Ruby NX̓ك\bh` (2 )
inline void xrb_define_2arg_singleton_method ( VALUE c, const char * name, VALUE (* function) ( VALUE, VALUE, VALUE ) )
{
    xrb_define_singleton_method( c, name, function, 2 );
}


/// Ruby NX̓ك\bh` (n )
inline void xrb_define_narg_singleton_method ( VALUE c, const char * name, VALUE (* function) ( int, VALUE *, VALUE ) )
{
    xrb_define_singleton_method( c, name, function, -1 );
}


/// Ruby NX̓ك\bh` (z)
inline void xrb_define_larg_singleton_method ( VALUE c, const char * name, VALUE (* function) ( VALUE, VALUE ) )
{
    xrb_define_singleton_method( c, name, function, -2 );
}


/// Ruby NX̃W[֐`
template < typename callback_t >
void xrb_define_module_function ( VALUE c, const char * name, callback_t function, int args )
{
    rb_define_module_function( c, name, reinterpret_cast<ruby_callback_t>(function), args );
}


/// Ruby O[o֐`
template < typename callback_t >
void xrb_define_global_function ( const char * name, callback_t function, int args )
{
    rb_define_global_function( name, reinterpret_cast<ruby_callback_t>(function), args );
}


/// Ruby O[o֐` (Ȃ)
inline void xrb_define_0arg_global_function ( const char * name, VALUE (* function) ( VALUE ) )
{
    xrb_define_global_function( name, function, 0 );
}


/// Ruby O[o֐` (1 )
inline void xrb_define_1arg_global_function ( const char * name, VALUE (* function) ( VALUE, VALUE ) )
{
    xrb_define_global_function( name, function, 1 );
}


/// Ruby O[o֐` (2 )
inline void xrb_define_2arg_global_function ( const char * name, VALUE (* function) ( VALUE, VALUE, VALUE ) )
{
    xrb_define_global_function( name, function, 2 );
}


/// Ruby O[o֐` (n )
inline void xrb_define_narg_global_function ( const char * name, VALUE (* function) ( int, VALUE *, VALUE ) )
{
    xrb_define_global_function( name, function, -1 );
}


/// Ruby O[o֐` (z)
inline void xrb_define_larg_global_function ( const char * name, VALUE (* function) ( VALUE, VALUE ) )
{
    xrb_define_global_function( name, function, -2 );
}


/// tbNp getter ̃R[obN^
typedef VALUE (* ruby_gv_getter_t) ( ... );

/// tbNp setter ̃R[obN^
typedef void (* ruby_gv_setter_t) ( ... );


/// tbNtO[oϐ`
template < typename getter_t, typename setter_t >
void xrb_define_hooked_variable ( const char * name, VALUE * vptr, getter_t getter, setter_t setter )
{
    rb_define_hooked_variable( name, vptr, reinterpret_cast<ruby_gv_getter_t>(getter), reinterpret_cast<ruby_gv_setter_t>(setter) );
}


/// O[o萔`
inline void xrb_define_global_const ( const char * name, VALUE val )
{
    rb_define_const( rb_cObject, name, val );
}


/// ensure ̎s
template < typename callback_t >
VALUE xrb_ensure ( callback_t func1, VALUE arg1, callback_t func2, VALUE arg2 )
{
    return rb_ensure( reinterpret_cast< ruby_callback_t >(func1), arg1, reinterpret_cast<ruby_callback_t>(func2), arg2 );
}


/// Proc IuWFNg̍쐬
template < typename callback_t >
VALUE xrb_proc_new ( callback_t func, VALUE self )
{
    return rb_proc_new( reinterpret_cast< ruby_callback_t >(func), self );
}


/*   O[o֐ (Ruby f[^ϊ)
------------------------------------------------------------------- */


/// IuWFNg freeze Ă邩𒲂ׂ
inline bool xrb_is_frozen ( VALUE val )
{
    return (OBJ_FROZEN(val)) ? true : false;
}

/// String IuWFNg̕擾
/**
 * @param val [in] String IuWFNg
 */
inline const char * xrb_str_ptr ( VALUE val )
{
    return RSTRING(val)->ptr;
}

/// String IuWFNg̕񒷂擾
/**
 * @param val [in] String IuWFNg
 */
inline long xrb_str_len ( VALUE val )
{
    return RSTRING(val)->len;
}

/// Array IuWFNg̒擾
/**
 * @param val [in] Array IuWFNg
 */
inline long xrb_ary_length ( VALUE val )
{
    return RARRAY(val)->len;
}

/// Array IuWFNg̎wʒuvf擾
/**
 * @param val [in] Array IuWFNg
 */
inline VALUE xrb_ary_at ( VALUE val, unsigned int i )
{
    return RARRAY(val)->ptr[ i ];
}

/// IuWFNg̃NXw肵NX̃TuNXł邩𔻒肷
/**
 * C++  bool Ԃ̂ŁAC++ ł͂g悤ɂĂB
 */
inline bool xrb_is_kind_of ( VALUE obj, VALUE clsobj )
{
    return RTEST( rb_obj_is_kind_of( obj, clsobj ) );
}

/// IuWFNg̃NXw肵NXQ̃TuNXł邩𔻒肷
/**
 * obj Aȍ~ɓnꂽNXꂩ̃TuNXłƂA^Ԃ܂B
 * NX̃Xg nil ŏI܂B
 */
bool xrb_is_kind_of_any ( VALUE obj, ... );

/// Ruby IuWFNgp̃LXg
/**
 * ̃`FbN͈؍s܂B
 * Data IuWFNgȊOnꍇAԈႢȂ܂B
 */
template < typename type_t >
type_t * ruby_cast ( VALUE obj )
{
    //Check_Type( obj, T_DATA );
    return reinterpret_cast< type_t * >( DATA_PTR(obj) );
}

/// Ruby IuWFNgp̃LXg
/**
 * Ruby IuWFNgɊ{NXi[ĂA
 * TuNXւ̓ILXgKvȏꍇɎgp܂B
 * |[tBbNȌ^ɂKpł܂B
 */
template < typename sub_t, typename base_t >
sub_t * ruby_basecast ( VALUE obj )
{
    return dynamic_cast< sub_t * >( ruby_cast< base_t >( obj ) );
}


/*   O[o֐ (Ruby )
------------------------------------------------------------------- */


/// w肳ꂽNX̃IuWFNg\z
/**
 * NX RubyObject pĂȂ΂Ȃ炸A
 * ̃RXgN^ĂȂ΂Ȃ܂B
 *
 * @param ptr [out] VɐꂽIuWFNg (ւ̃|C^) i[obt@
 * @return Vɐꂽ Ruby IuWFNg
 */
template < typename type_t >
VALUE xrb_new_object_safe ( type_t * & ptr )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        ptr = new type_t();
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}


/// Data IuWFNgɐݒ肳ꂽ|C^
/**
 * initialize_copy \bh̎Ŏgp܂B
 *
 * @param obj [in] Data IuWFNg (`FbN)
 * @param markfunc [in] IuWFNg̃}[NɎg֐
 * @param freefunc [in] IuWFNg̉Ɏg֐
 * @param data [in] IuWFNg̎̂ƂĎgpf[^
 */
template < typename mark_t, typename free_t >
void xrb_update_Data ( VALUE obj, mark_t mf, free_t ff, void * data )
{
    RDATA(obj)->dmark = reinterpret_cast< RUBY_DATA_FUNC >( mf );
    RDATA(obj)->dfree = reinterpret_cast< RUBY_DATA_FUNC >( ff );
    RDATA(obj)->data = data;
}


/*   O[o֐ (BK-Ruby Ag)
------------------------------------------------------------------- */
namespace BK {


/// BK O Ruby Oɕϊ
/**
 * w肳ꂽO e ́Å֐ delete ܂B
 * gpƂ́A\ɒӂĎgpĂB
 *
 * ܂Å֐̓ł Ruby ̗O܂B
 * ̓_ɂӂĂB
 *
 * @param e [in] OIuWFNg ( delete )
 */
void ruby_throw ( BK::exception_base * e );


/// BK W[擾
/**
 * "BK" W[擾܂B
 * BK CuŒ`邷ׂĂ Ruby IuWFNg BK W[Ɏ߂܂B
 */
VALUE get_ruby_bk_module ( void );


/// BK W[ɃNX`
/**
 * "BK" W[ȉɃNX`܂B
 *
 * @return NXIuWFNg
 */
VALUE define_ruby_bk_class ( const char * name, VALUE superclass );


/// Ruby IuWFNg int ւ̕ϊ
/**
 * ϊ Ruby O argument_exception Oo܂B
 */
int value_to_int ( VALUE val );


/// Ruby IuWFNg unsigned int ւ̕ϊ
/**
 * ϊ Ruby O argument_exception Oo܂B
 */
unsigned int value_to_uint ( VALUE val );


/// Ruby IuWFNg double ւ̕ϊ
/**
 * ϊ Ruby O argument_exception Oo܂B
 */
double value_to_double ( VALUE val );


/// Ruby C^v^Vbg_E𒲂ׂ
/**
 * Ruby C^v^̎sIAruby_cleanup() ĂяoƁAVbg_EƂ݂Ȃ܂B
 * ȑOł́A܂삵ĂƂ݂Ȃ܂B
 *
 * ӁF̂ bk_init.cpp Œ`Ă܂B
 */
bool is_rubysys_closed ( void );


/// Ruby C^v^쒆ł邩𒲂ׂ
/**
 * is_rubysys_shutdowned() ̋tłB
 */
inline bool is_rubysys_running ( void )
{
    return !is_rubysys_closed();
}


} /* namespace BK */


/*   NX錾
------------------------------------------------------------------- */
namespace BK {


/// Ruby O
/**
 * Ruby ŗOƂ߂̗OłB
 * Ruby ̗OIuWFNgێ܂B
 */
class ruby_exception : public runtime_exception
{
public:
    const char * get_type ( void ) const
    {
        return "ruby_exception";
    }
    
private:
    
    /// Ruby OIuWFNg
    VALUE obj_error;
    
protected:
    
    void initialize ( VALUE obj, const char * format, va_list arg );
    
public:
    /// RXgN^
    /**
     * OIuWFNg𐶐܂B
     *
     * @param obj [in] OIuWFNg
     * @param format [in] G[bZ[W
     */
    explicit ruby_exception ( VALUE obj, const char * format, ... );
    
    /// RXgN^
    /** ruby_errinfo gAOIuWFNg𐶐܂B */
    explicit ruby_exception ( const char * format, ... );
    
    /// fXgN^
    virtual ~ruby_exception ();
    
    /// OIuWFNg̎擾
    VALUE get_object ( void ) const
    {
        return this->obj_error;
    }
    
};


/// Ruby ̂IuWFNg̃x[X
class RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: RubyObject
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static RubyObject * value_to_data ( VALUE obj )
    {
        return ruby_cast< RubyObject >( obj );
    }
    
private:
    
    /// Ruby IuWFNg
    VALUE  obj_ruby_body;
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return ruby_class_object;
    }
    
    /// }[Np֐擾
    /**
     * ftHgł́Ag (RubyObject) }[N܂B
     */
    virtual void * get_ruby_mark_function ( void );
    
    /// p֐擾
    /**
     * ftHgł́Ag (RubyObject) ܂B
     */
    virtual void * get_ruby_free_function ( void );
    
    /// bsOɎgp|C^̎擾
    virtual void * get_wrapped_address ( void )
    {
        return this;
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void )
    {
    }
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    /**
     * Kx[WRN^ɂ Ruby IuWFNgƂɃOo͂邩
     * ǂ擾܂B
     * ftHgł͐^ibZ[WójԂ܂B
     */
    virtual bool is_ruby_gc_log_enabled ( void ) const
    {
        return true;
    }
    
    /// Ruby inspect \bh
    /**
     * IuWFNg̏ڍ׏Ԃ߂̃\bhłB
     * nobt@̃TCY 4KB ȏł邱Ƃۏ؂Ă܂B
     *
     * obt@sꍇAnew obt@Ԃ܂B
     * gpAԂꂽobt@ buf ȊÖ̗Ăꍇ delete ܂B
     *
     * NULL ԂꍇAinspect \bh`ĂȂ܂B
     *
     * @param buf [in] obt@
     * @param cap [in] obt@̃TCY (k܂)
     * @return obt@
     * @retval NULL inspect \bh`ĂȂ
     */
    virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    /**
     * ruby_wrap() ŌĂяoCxgnhłB
     * ̃IuWFNg̃bsOIɌĂяo܂B
     * oƂĕۗLIuWFNg̃bsOs܂B
     */
    virtual void on_ruby_wrap ( void )
    {
    }
    
public:
    
    /// RXgN^
    RubyObject ( void )
            : obj_ruby_body (Qnil)
    {
    }
    
    /// fXgN^
    virtual ~RubyObject ()
    {
    }
    
    /// Ruby IuWFNgݒ肷
    /**
     * xݒł܂B
     * ݒ肳ĂԂōēxݒsƁAO܂B
     */
    void set_ruby_object ( VALUE obj );
    
    /// Ruby IuWFNg擾
    /**
     * IuWFNgɐݒ肳Ă Ruby IuWFNgݒ肷B
     */
    VALUE get_ruby_object ( void ) const
    {
        return this->obj_ruby_body;
    }
    
    /// Ruby IuWFNgۗLĂ邩ׂ
    /**
     * ̃IuWFNg Ruby IuWFNgŃbsOĂ邩𒲂ׂ܂B
     */
    bool is_ruby_wrapped ( void ) const
    {
        return !NIL_P(this->obj_ruby_body);
    }
    
    /// g}[N
    /**
     * ̃IuWFNg Ruby IuWFNgŃbsOĂꍇAbsOIuWFNg
     * }[N܂B
     * Ruby IuWFNgŃbsOĂȂꍇAruby_gc_mark() \bhĂяo܂B
     */
    void gc_mark_self ( void );
    
    /// IuWFNg̃bsO
    /**
     * bsOɂ
     *  - get_ruby_class_object()
     *  - get_ruby_mark_function()
     *  - get_ruby_free_function()
     *  - get_wrapped_address()
     * Ŏ擾񂪎gp܂B
     * łɃbsOĂꍇ́AbsOIuWFNgԂ܂B
     *
     * ̃\bh C++ ŌĂяoȂłB
     * Ruby \bhł̂݁As܂B
     */
    VALUE ruby_wrap ( void );
    
    /// inspect 擾
    /**
     * Ruby  inspect \bhɎgp܂B
     */
    std::string get_ruby_inspect_string ( void ) const;
    
    /// Data IuWFNg̃IuWFNg̃f[^ōXV
    /**
     * nꂽ Ruby IuWFNg̎̃|C^ȂǂÃIuWFNgŏ܂B
     */
    void update_Data ( VALUE obj )
    {
        xrb_update_Data( obj,
                         this->get_ruby_mark_function(),
                         this->get_ruby_free_function(),
                         this->get_wrapped_address() );
    }
    
};


/// Ruby IuWFNg̃}[Np֐IuWFNg
/**
 * RubyObject ߂ꂽReiɑ΂ for_each Ŏgp܂B
 * 蓖ĂĂ Ruby IuWFNgɑ΂ rb_gc_mark() s܂B
 */
class RubyObjectMarker
{
public:
    
    /// }[NpZq (RubyObject |C^)
    void operator () ( RubyObject * ptr )
    {
        if( ptr != NULL ) {
            ptr->gc_mark_self();
        }
    }
    
    /// }[NpZq (RubyObject)
    void operator () ( RubyObject & obj )
    {
        obj.gc_mark_self();
    }
    
};


/// Ruby IuWFNg̃bsOp֐IuWFNg
/**
 * RubyObject ߂ꂽReiɑ΂ for_each Ŏgp܂B
 * 蓖ĂĂ Ruby IuWFNgɑ΂ ruby_wrap() s܂B
 */
class RubyObjectWrapper
{
public:
    
    /// }[NpZq (RubyObject |C^)
    void operator () ( RubyObject * ptr )
    {
        if( ptr != NULL ) {
            ptr->ruby_wrap();
        }
    }
    
    /// }[NpZq (RubyObject)
    void operator () ( RubyObject & obj )
    {
        obj.ruby_wrap();
    }
    
};


/// Ruby IuWFNg}bṽ}[Np֐IuWFNg
/**
 * RubyObject ̃f[^ second ɓĂ邱Ƃz肵Ă܂B
 */
template < typename map_t >
class RubyMapMarker : private RubyObjectMarker
{
public:
    
    /// }[NpZq (RubyObject |C^)
    void operator () ( map_t::value_type const & obj )
    {
        RubyObjectMarker::operator()( obj.second );
    }
    
};


/// Ruby IuWFNg}bṽbsOp֐IuWFNg
/**
 * RubyObject ̃f[^ second ɓĂ邱Ƃz肵Ă܂B
 */
template < typename map_t >
class RubyMapWrapper : private RubyObjectWrapper
{
public:
    
    /// }[NpZq (RubyObject |C^)
    void operator () ( map_t::value_type const & obj )
    {
        RubyObjectWrapper::operator()( obj.second );
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// Ruby W[̏
void Init_ruby ( void );


/// Ruby W[̏I
void Exit_ruby ( void );


} /* namespace BK */


#endif /* _SCHEMA_EXRUBY_H_20030809Sat_184434_ */
