/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - LoX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: LoX
 *
 * LoXNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/17
 */
#ifndef _SCHEMA_GRAPHIC_CANVAS_H_20031217Wed_204715_
#define _SCHEMA_GRAPHIC_CANVAS_H_20031217Wed_204715_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// LoXIuWFNg
/**
 * ANZX\ȁÃrbg}bv܂B
 *  (rbg}bv̓]Ȃ) T|[g܂B
 *
 * LoXgpf[^̈́AO^̂łB
 * ̃f[^LoXɉĂ͂Ȃ܂B
 * LoX̍쐬́A쐬LoX̊Ǘs܂B
 * vO}[ӂĎgpKv܂B
 */
class Canvas : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Canvas
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Canvas * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Canvas, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public:
    
    /// sNZtH[}bg̗񋓌^
    /**
     * 󂾂 DirectX 玝ĂĂ邾ȂcB
     */
    enum pixel_t
    {
        PX_Unknown,
        PX32_A2B10G10R10,
        PX32_A8R8G8B8,
        PX32_X8R8G8B8,
        PX32_A8B8G8R8,
        PX32_X8B8G8R8,
        PX24_R8G8B8,
        PX16_R5G6B5,
        PX16_X1R5G5B5,
        PX16_A1R5G5B5,
        PX16_A4R4G4B4,
        PX16_X4R4G4B4,
    };
    
    /// sNZtH[}bg𕶎ɂ
    /**
     * @return w肳ꂽtH[}bgɑΉ镶
     */
    static const char * pixel_to_string ( pixel_t p );
    
    /// sNZtH[}bgf[^TCY擾
    /**
     * @return w肳ꂽsNZf[^߂̂ɕKvȃoCg
     */
    static unsigned int get_pixel_bytes ( pixel_t p );
    
public: /* Canvas C^[tFCX */
    
    /// LoX̃N[Y
    /**
     * LoX̗pI܂B
     * ĨLoXɂ̓ANZXłȂȂ܂B
     *
     * I[o[Chۂɂ́Ae\bȟĂяoYȂ悤ɂKv܂B
     */
    virtual void close_canvas ( void );
    
public:
    
    /// LoX̎C^[tFCX
    /**
     * LoX̃sNZtH[}bgɂAς܂B
     */
    class implement_t
    {
    private:
        
        /// LoẌ̗ (P: sNZ)
        const Rect2 obj_rect;
        
        /// LoX̃TCY (P: sNZ)
        const Size2 obj_size;
        
        /// LoX̃sNZtH[}bg
        const pixel_t num_pixel_format;
        
        /// LoXC[W̃AhX
        void * const ptr_image;
        
        /// Csb`
        const unsigned int num_pitch;
        
    public:
        
        /// RXgN^
        implement_t ( const Rect2 & rect, pixel_t pxfmt, void * image, unsigned int pitch )
                : obj_rect (rect),
                  obj_size (rect.get_size()),
                  num_pixel_format (pxfmt),
                  ptr_image (image),
                  num_pitch (pitch)
        {
        }
        
        /// fXgN^
        virtual ~implement_t ()
        {
        }
        
        /// LoẌ̗擾
        const Rect2 & get_rect ( void ) const
        {
            return obj_rect;
        }
        
        /// LoX̃TCY擾
        const Size2 & get_size ( void ) const
        {
            return obj_size;
        }
        
        /// LoX̃sNZtH[}bg擾
        pixel_t get_pixel_info ( void ) const
        {
            return num_pixel_format;
        }
        
        /// LoX̃sNZtH[}bg\擾
        const char * get_pixel_string ( void ) const
        {
            return Canvas::pixel_to_string( num_pixel_format );
        }
        
        /// LoX擾
        void * get_image ( void )
        {
            return ptr_image;
        }
        
        /// Csb`擾
        unsigned int get_pitch ( void ) const
        {
            return num_pitch;
        }
        
        /// draw_film() RA
        /**
         * tB̒lɂAt@ufBOsB
         *
         * @param canvas [in] `ݐLoX
         * @param dst [in] `ݐ̗̈
         * @param color [in] tBF
         * @param film [in] tBIuWFNg
         * @param src [in] ]tB̗̈
         */
        virtual void draw_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src ) = 0;
        
        /// draw_film() RA
        /**
         * tB̒lAt@lƂĐݒ肷B
         *
         * @param canvas [in] `ݐLoX
         * @param dst [in] `ݐ̗̈
         * @param color [in] tBF
         * @param film [in] tBIuWFNg
         * @param src [in] ]tB̗̈
         */
        virtual void blit_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src ) = 0;
        
        /// fill_rect() RA
        /**
         * @param canvas [in] `ݐLoX
         * @param color [in] hԂF
         * @param dst [in] hԂ̈
         */
        virtual void fill_rect ( const AlphaColor & color, const Rect2 & dst ) = 0;
    };
    
private:
    
    /// gpLoX
    implement_t * ptr_implement;
    
    /// I[i[ƂȂ Ruby IuWFNg
    /**
     * LoX񋟂 Ruby IuWFNg܂B
     * ݂Ȃꍇ NULL ݒ肵܂B
     */
    RubyObject * const ptr_owner;
    
    /// LoẌ (LbV)
    Rect2 rect_canvas;
    
    /// LoXTCY (LbV)
    Size2 size_canvas;
    
    /// LoX̃sNZtH[}bg (LbV)
    pixel_t num_pixel_format;
    
    /// LoX̃Csb` (LbV)
    unsigned int num_pitch;
    
public:
    
    /// RXgN^
    /**
     * VLoX̃Ƀ}bsO܂B
     * LoX̎̂́Ap[^ɂė^܂B
     *
     * @param rect [in] LoẌ
     * @param pxfmt [in] sNZtH[}bg
     * @param src [in] ̈
     * @param pitch [in] Csb`
     */
    Canvas ( RubyObject * owner, const Rect2 & rect, pixel_t pxfmt, void * src, unsigned int pitch );
    
    /// fXgN^
    /**
     * jO close_canvas() sĂKv܂B
     */
    virtual ~Canvas ();
    
    /// LoXĂ邩𒲂ׂ
    bool is_canvas_closed ( void ) const
    {
        return ptr_implement == NULL;
    }
    
    /// LoẌ̗擾
    const Rect2 & get_rect ( void ) const
    {
        return rect_canvas;
    }
    
    /// LoX̃TCY擾
    const Size2 & get_size ( void ) const
    {
        return size_canvas;
    }
    
    /// LoX̃sNZtH[}bg擾
    pixel_t get_pixel_info ( void ) const
    {
        return num_pixel_format;
    }
    
    /// LoX̃sNZtH[}bg\擾
    const char * get_pixel_string ( void ) const
    {
        return Canvas::pixel_to_string( num_pixel_format );
    }
    
    /// Csb`擾
    unsigned int get_pitch ( void ) const
    {
        return num_pitch;
    }
    
    /// LoX擾
    void * get_image ( void );
    
    /// tB`悷
    /**
     * w肳ꂽtBA`FɂALoXɕ`悵܂B
     *
     * ] (F) = LoXFƕ`FA`At@ɂAt@uhB
     * ] () = LoXAt@B
     *
     * Ff[^̃At@ufBOs܂B
     * At@]ꍇ blit_film() gp܂B
     *
     * @param p [in] `ʒu
     * @param color [in] tB̕`F
     * @param film [in] `悷tB
     * @param rect [in] `悷tB̗̈
     */
    void draw_film ( const Point2 & p, const Color & color, const Film & film, const Rect2 & rect );
    
    /// tB]
    /**
     * w肳ꂽtBA`FɂALoXɓ]܂B
     *
     * i]ɃAt@݂ꍇj
     * ] (F) = `FB
     * ] () = tBAt@B
     *
     * i]ɃAt@݂Ȃꍇj
     * ] (F) = LoXFƕ`FA`At@ɂAt@uhB
     * ] () = LoXAt@B
     *
     * At@ufBO͍sꂸAtBf[^Sɓ]܂B
     * AAt@ 0 ̃sNZ͓]܂B
     *
     * @param p [in] `ʒu
     * @param color [in] tB̕`F
     * @param film [in] ]tB
     * @param rect [in] ]tB̗̈
     */
    void blit_film ( const Point2 & p, const Color & color, const Film & film, const Rect2 & rect );
    
    /// LoXhԂ
    /**
     * w肳ꂽ̈Aw肳ꂽFœhԂ܂B
     * At@Rs[܂B
     *
     * LoX̃sNZɂA኱A@قȂ܂B
     *  * At@L  At@ɎwF̃At@ݒ肳
     *  * At@  At@ 0xff  0x00 ȊȌꍇ̓sNZƃAt@ufBOs
     *
     * @param rect [in] hԂ̈
     * @param color [in] hԂF
     */
    void fill_rect ( const AlphaColor & color, const Rect2 & rect );
    
    /// IuWFNg̎擾
    std::string inspect ( void ) const
    {
        return get_ruby_inspect_string();
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbN̏
void Init_graphic_Canvas ( void );


/// OtBbN̏I
void Exit_graphic_Canvas ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_CANVAS_H_20031217Wed_204715_ */
