/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - C[ - C[z
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: C[: C[z
 *
 * C[Ǘ邽߂̃ReiNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/22
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_LAYERARRAY_H_20031222Mon_190953_
#define _SCHEMA_GRAPHIC_LAYER_LAYERARRAY_H_20031222Mon_190953_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// C[Xg
/**
 * C[̃Xgێ邽߂̃ReiIuWFNgłB
 * OɂǗsƂł܂B
 */
class LayerArray : public Layer
{
public:
    
    /// eNX
    typedef Layer parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: LayerArray
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static LayerArray * value_to_data ( VALUE obj )
    {
        return ruby_basecast< LayerArray, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev );
    
public:
    
    /// XgɊi[f[^
    class data_t
    {
    private:
        
        /// C[
        const std::string str_name;
        
        /// C[IuWFNg
        Layer * ptr_layer;
        
    public:
        
        /// RXgN^
        /**
         * name w̓Rs[܂B
         */
        data_t ( const char * name, Layer * layer )
                : str_name (name),
                  ptr_layer (layer)
        {
        }
        
        /// C[̎擾
        const char * get_name ( void ) const
        {
            return str_name.c_str();
        }
        
        /// C[̎擾
        const std::string & get_name_string ( void ) const
        {
            return str_name;
        }
        
        /// C[IuWFNg̎擾
        Layer * get_layer ( void ) const
        {
            return ptr_layer;
        }
        
        /// C[IuWFNg̐ݒ
        void set_layer ( Layer * layer )
        {
            ptr_layer = layer;
        }
        
        /// rZq
        bool operator == ( const char * s ) const
        {
            return str_name == s;
        }
        
        /// rZq
        bool operator == ( const data_t & rhs ) const
        {
            return get_name_string() == rhs.get_name_string();
        }
        
        /// rZq
        bool operator < ( const data_t & rhs ) const
        {
            return get_name_string() < rhs.get_name_string();
        }
        
        /// rZq
        bool operator > ( const data_t & rhs ) const
        {
            return get_name_string() > rhs.get_name_string();
        }
        
        /// LXg (RubyObject *)
        operator RubyObject * ( void ) const
        {
            return ptr_layer;
        }
    };
    
    /// Xg^
    typedef std::list < data_t > list_t;
    
private:
    
    /// C[Xg
    /**
     * 擪ułṽC[ŁAułOṽC[łB
     * ł̃C[珇ԂɁAXN[֓]܂B
     */
    list_t ary_list;
    
private:
    
    /// ̃f[^
    data_t * find_data ( const char * name );
    
    /// ̃f[^ (const )
    const data_t * find_data ( const char * name ) const;
    
public:
    
    /// RXgN^
    LayerArray ( void );
    
    /// fXgN^
    ~LayerArray ();
    
    /// C[̓o^
    /**
     * C[̃Xgo^܂B
     * ȉ̏𖞂悤ɁAXg^܂B
     *  - Xg̖ NULL
     *  - ݂Ȃ
     *  - Xg̐擪ułṽC[
     * ݒOƐݒœ̃C[݂ĂꍇA͈p܂B
     *
     * ̃\bhł́ACӂ̖Oݒł܂B
     *
     * @param names [in] ݒ肷郌C[̃Xg
     * @exception argument_exception G[
     */
    void set_names ( const char * const * names );
    
    /// C[̎擾
    /**
     * C[̃Xg擾܂B
     * 擾́A\܂BIɎgpȂłB
     *
     * @param names [out] C[̏ݐ
     * @param cap [in] obt@TCY
     * @return ܂ꂽC[̐
     */
    unsigned int get_names ( const char * * names, unsigned int cap ) const;
    
    /// C[ݒ肷
    /**
     * w肳ꂽOɃC[ݒ肵܂B
     *
     * @param name [in] C[
     * @param layer [in] ݒ肷郌C[
     * @exception argument_exception w肳ꂽO݂Ȃ
     */
    void set_layer ( const char * name, Layer * layer );
    
    /// C[擾
    /**
     * w肳ꂽÕC[擾܂B
     *
     * @param name [in] C[
     * @return w肳ꂽÕC[
     * @exception argument_exception w肳ꂽO݂Ȃ
     */
    Layer * get_layer ( const char * name ) const;
    
    /// CfNX烌C[擾
    /**
     * CfNXw肵ăC[擾܂B
     * index ɂ size() - 1 ܂ł̐w肵܂B
     *
     * @param index [in] CfNX
     */
    Layer * at ( unsigned int index ) const;
    
    /// wCfNXɃC[ݒ肷
    /**
     * @param index [in] CfNX
     * @param layer [in] ݒ肷郌C[IuWFNg
     */
    void set_at ( unsigned int index, Layer * layer );
    
    /// O
    /**
     * w肳ꂽOC[AC猟܂B
     * ptr ɂ NULL w肷邱Ƃł܂B
     *
     * @param name [in] C[
     * @param ptr [out] C[̃CfNX
     * @retval true C[ACɌ
     * @retval false w肳ꂽO݂Ȃ
     */
    bool find_name ( const char * name, unsigned int * ptr = NULL ) const;
    
    /// ÕCfNX擾
    /**
     * w肳ꂽOɑΉAC[AC̃CfNX擾܂B
     *
     * @param name [in] C[
     * @return CfNX
     */
    unsigned int get_index ( const char * name ) const;
    
    /// O̒ǉ
    /**
     * w肳ꂽOAw肳ꂽʒuɑ}܂B
     * index Ŏw肳ꂽʒu name ܂B
     *
     * @param index [in] }ʒu
     * @param name [in] C[
     * @param layer [in] ݒ肷郌C[
     * @exception argument_exception w肳ꂽ index  name s
     */
    void insert_at ( unsigned int index, const char * name, Layer * layer = NULL );
    
    /// O̍폜
    /**
     * w肳ꂽʒu̖O폜܂B
     *
     * @param index [in] 폜ʒu
     * @exception argument_exception w肳ꂽ index s
     */
    void erase_at ( unsigned int index );
    
    /// O̍폜
    /**
     * w肳ꂽO폜܂B
     *
     * @param name [in] 폜閼O
     * @exception argument_exception w肳ꂽ name s
     */
    void erase_name ( const char * name )
    {
        erase_at( get_index(name) );
    }
    
    /// C[̐擾
    /**
     * get_names() Ŏ擾ł閼O̍ő吔ɂȂ܂B
     */
    unsigned int size ( void ) const
    {
        return ary_list.size();
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_LayerArray ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_LayerArray ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_LAYERARRAY_H_20031222Mon_190953_ */
