/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - XvCg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: XvCg
 *
 * XvCgɊ֘ANX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/11/11
 */
#ifndef _SCHEMA_GRAPHIC_SPRITE_H_20031111Tue_214830_
#define _SCHEMA_GRAPHIC_SPRITE_H_20031111Tue_214830_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// XvCgf[^
/**
 * XvCg̏\ (C++ p) IuWFNgłB
 */
class SpriteData
{
private:
    
    /// Qƌ PictureData
    PictureData * const ptr_picture;
    
    /// Qƌ̈
    const Rect2 rect_sprite;
    
    /// S_
    const Point2 point_center;
    
public:
    
    /// RXgN^
    /**
     * @param bmp [in] QƂsN`[f[^ ( NULL)
     * @param rect [in] QƗ̈
     * @param center [in] XvCg̒S_
     * @exception argument_exception IuWFNg̐Ɏs
     */
    SpriteData ( PictureData * bmp, const Rect2 & rect, const Point2 & center );
    
    /// fXgN^
    ~SpriteData ();
    
    /// XvCggpĂ PictureData 擾
    PictureData * const & get_picture ( void ) const
    {
        return ptr_picture;
    }
    
    /// XvCgQƂĂ̈擾
    const Rect2 & get_rect ( void ) const
    {
        return rect_sprite;
    }
    
    /// XvCgQƂĂ̈̑傫擾
    Size2 get_size ( void ) const
    {
        return rect_sprite.get_size();
    }
    
    /// XvCgQƂĂ̈̍̓_擾
    Point2 get_point ( void ) const
    {
        return rect_sprite.get_point();
    }
    
    /// XvCg̒S_擾
    const Point2 & get_center ( void ) const
    {
        return point_center;
    }
    
};


/// XvCg
/**
 * C[ɓ]ĎgpAXvCg̃\[Xf[^łB
 * QƗ̈ PictureData ̍Wnŕ\܂B
 *
 * XvCgւ̖Ot́AXvCgQƂIuWFNgɂčs܂B
 * (̃IuWFNg狤L邽...XvCg͂܂Łuf[^v
 *  ǂ邩͋ǖʂ߂)
 */
class Sprite : public RubyObject, public SpriteData
{
private: /* static ϐ */
    
    /// Ruby NX: Sprite
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Sprite * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Sprite, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    virtual bool is_ruby_gc_log_enabled ( void ) const
    {
        return false;
    }
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public:
    
    /// RXgN^
    /**
     * @param src [in] Rs[f[^
     */
    Sprite ( const SpriteData & dat );
    
    /// RXgN^
    /**
     * @param bmp [in] QƂsN`[f[^
     * @param rect [in] QƗ̈
     * @param center [in] XvCg̒S_
     * @exception argument_exception IuWFNg̐Ɏs
     */
    Sprite ( PictureData * bmp, const Rect2 & rect, const Point2 & center );
    
    /// fXgN^
    virtual ~Sprite ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEXvCg̏
void Init_graphic_Sprite ( void );


/// OtBbNfoCXEXvCg̏I
void Exit_graphic_Sprite ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_SPRITE_H_20031111Tue_214830_ */
