/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OfoCX
 *
 * Oo͂s߂̃foCX`܂B
 *
 * @author ABE Shigeru
 * @date 2004/01/31
 */
#ifndef _SCHEMA_LOG_LOGDEVICE_H_20040131Sat_134347_
#define _SCHEMA_LOG_LOGDEVICE_H_20040131Sat_134347_


/*   foCXNX`
------------------------------------------------------------------- */
namespace BK {


/// OxEVXeg[X
const int LOG_TRACE = -4;

/// OxEVXeRg
const int LOG_COMMENT = -3;

/// OxEVXe
const int LOG_INFO = -2;

/// OxE[U[ (fobO)
const int LOG_DEBUG = -1;

/// OxE[U[
const int LOG_USER = 0;

/// OxEx
const int LOG_WARN = 0x7ffffffe;

/// OxEG[
const int LOG_ERROR = 0x7fffffff;


/// OfoCX
/**
 * vOs̃OL^邽߂̃foCXłB
 * t@CȂǂւ̏o͂T|[g܂B
 *
 * Singleton IuWFNgłB
 */
class LogDevice : public ServiceDevice
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static LogDevice * singleton_object;
    
public: /* static \bh */
    
    /// \zꂽOfoCX擾
    static LogDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
    /// w肳ꂽIuWFNgOIuWFNgɎgpł邩𒲂ׂ
    static bool is_log_available ( VALUE obj );
    
public:
    
    /// Oo͐Xg[̌^
    typedef std::ostream ostream_t;
    
private:
    
    /// bZ[WtB^
    /** tB^ݒl̃bZ[W͏o͂܂B */
    int  num_filter_level;
    
    /// Cfgx
    int  num_indent;
    
    /// gp̃OIuWFNg
    VALUE  ptr_current_logger;
    
    /// Ȍo͐Xg[
    /** ̃IuWFNg delete ܂B */
    ostream_t * ptr_ostream;
    
    /// Oo͗p̃NeBJZNV
    CriticalSection * ptr_critical;
    
    /// Ȍo
    void _write ( int level, const char * str, unsigned int len );
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* ServiceDevice C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// foCX̎擾
    virtual const char * get_device_name ( void ) const;
    
public:
    
    /// RXgN^
    LogDevice ( void );
    
    /// fXgN^
    ~LogDevice ();
    
    /// OIuWFNg̐ݒ
    /**
     * o͐̃OIuWFNgݒ肵܂B
     *
     * @return ȑOɐݒ肳ĂOIuWFNg
     */
    VALUE set_logger ( VALUE logger );
    
    /// OIuWFNg̎擾
    VALUE get_logger ( void ) const
    {
        return ptr_current_logger;
    }
    
    /// Ȍo͐Xg[̐ݒ
    /**
     * Ȍo͐ƂȂXg[ݒ肵܂B
     * ԂXg[gpȂꍇ́A擾 delete Ȃ΂Ȃ܂B
     *
     * @return ȑOɐݒ肳ĂXg[
     */
    ostream_t * set_logger_stream ( ostream_t * ptr );
    
    /// Ȍo͐Xg[擾
    /**
     * @retval NULL Xg[͐ݒ肳ĂȂ
     */
    ostream_t * get_logger_stream ( void ) const
    {
        return ptr_ostream;
    }
    
    /// OIuWFNg̃tB^lݒ肷
    /**
     * ʏ͎gpȂłB
     * ꕔ̃V[PXɂăȌڍדxύXꍇȂǂɎgp܂B
     *
     * w肳ꂽtB^lȏ̃ObZ[Ŵ݂o͂悤ɂȂ܂B
     *
     * @param level [in] ݒ肷tB^l
     * @return ݒ肳ꂽtB^l
     */
    int set_filter ( int level )
    {
        return num_filter_level = level;
    }
    
    /// W̃tB^lɖ߂
    /**
     * set_filter() ɂĕύXꂽtB^lW̃tB^l (0) ɖ߂܂B
     */
    void reset_filter ( void )
    {
        set_filter( 0 );
    }
    
    /// ݂̃tB^l擾
    int get_filter ( void ) const
    {
        return num_filter_level;
    }
    
    /// w肳ꂽx̃ObZ[Wo͂邩𒲂ׂ
    bool is_level ( int level ) const
    {
        return level >= num_filter_level;
    }
    
    /// Cfgxグ
    /** XR[vOŎgp܂B */
    void increment_indent ( void )
    {
        ++num_indent;
    }
    
    /// Cfgx
    /** XR[vOŎgp܂B */
    void decrement_indent ( void )
    {
        --num_indent;
    }
    
    /// Ȍo͂\ł邩𒲂ׂ
    /**
     * ݁AfoCXo͉\ȏԂɂȂĂ邩𒲂ׂ܂B
     */
    bool is_writable ( int level ) const
    {
        //return is_level(level) && is_started();
        return is_level(level);
    }
    
    /// o͂
    void write ( int level, const std::string & string )
    {
        if( is_writable(level) ) {
            _write( level, string.c_str(), string.length() );
        }
    }
    
    /// o͂
    void write ( int level, const char * string )
    {
        if( is_writable(level) ) {
            _write( level, string, strlen(string) );
        }
    }
    
    /// tH[}bgςݕo͂
    void vprintf ( int level, const char * format, va_list arg )
    {
        if( is_writable(level) ) {
            std::string str = strvformat(format, arg);
            _write( level, str.c_str(), str.length() );
        }
    }
    
    /// ϒgtH[}bgςݕo͂
    void printf ( int level, const char * format, ... )
    {
        if( is_writable(level) ) {
            va_list arg;
            va_start( arg, format );
            std::string str = strvformat(format, arg);
            _write( level, str.c_str(), str.length() );
            va_end( arg );
        }
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OfoCX̏
void Init_log_LogDevice ( void );


/// OfoCX̏I
void Exit_log_LogDevice ( void );


} /* namespace BK */


#endif /* _SCHEMA_LOGDEVICE_H_20040131Sat_134347_ */
