/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OfoCX
 *
 * Oo͂邽߂̋@\񋟂foCX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/08/09
 */
#ifndef _SCHEMA_LOG_MAIN_H_20030810Sun_000904_
#define _SCHEMA_LOG_MAIN_H_20030810Sun_000904_


/*   CN[h
------------------------------------------------------------------- */
#include "ld_LogDevice.h"


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// XR[vO
/**
 * XR[vƘAOo͂T|[gIuWFNgłB
 * IuWFNg̐єjɁAOo͂܂B
 */
class ScopeLog
{
private:
    
    /// ^Cg
    const char * const str_log;
    
    /// Ox
    int const num_level;
    
public:
    
    /// RXgN^
    ScopeLog ( int level, const char * string )
            : num_level (level),
              str_log (string)
    {
        LogDevice * const dev = LogDevice::get_instance();
        
        if( dev && str_log != NULL ) {
            if( dev->is_level(num_level) ) {
                dev->printf(num_level, ">> %s", str_log);
                dev->increment_indent();
            }
        }
    }
    
    /// fXgN^
    ~ScopeLog ()
    {
        LogDevice * const dev = LogDevice::get_instance();
        
        if( dev && str_log != NULL ) {
            if( dev->is_level(num_level) ) {
                dev->decrement_indent();
                dev->printf(num_level, "<< %s", str_log);
            }
        }
    }
};


/// xÓIɎw肷XR[vO
template < int Level >
class LeveledScopeLog : public ScopeLog
{
public:
    
    /// RXgN^
    LeveledScopeLog ( const char * string )
            : ScopeLog (Level, string)
    {
    }
    
};


/// TRACE x̃Oo͂XR[vO
typedef LeveledScopeLog < LOG_TRACE > TraceScopeLog;

/// COMMENT x̃Oo͂XR[vO
typedef LeveledScopeLog < LOG_COMMENT > CommentScopeLog;

/// INFO x̃Oo͂XR[vO
typedef LeveledScopeLog < LOG_INFO > InfoScopeLog;

/// DEBUG x̃Oo͂XR[vO
typedef LeveledScopeLog < LOG_DEBUG > DebugScopeLog;

/// USER x̃Oo͂XR[vO
typedef LeveledScopeLog < LOG_USER > UserScopeLog;


} /* namespace BK */


/*   O[o֐
------------------------------------------------------------------- */
namespace BK {


/// OfoCXɕo͂
/**
 * @param level [in] Ox
 * @param string [in] o͂镶
 * @see log_write()
 * @see LogDeivce.write()
 */
inline void log_write ( int level, const char * string )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        dev->write( level, string );
    }
}

/// OfoCXɕo͂
/**
 * @param level [in] Ox
 * @param string [in] o͂镶
 * @see log_write()
 * @see LogDeivce.write()
 */
inline void log_write ( int level, const std::string & string )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        dev->write( level, string );
    }
}

/// OfoCXɏtbZ[Wo͂ (xw肠)
/**
 * @param level [in] Ox
 * @param format [in] o͂鏑
 * @see log_printf()
 * @see LogDevice.printf()
 */
inline void log_printf ( int level, const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list  arg;
        va_start( arg, format );
        dev->vprintf( level, format, arg );
        va_end( arg );
    }
}

/// OfoCXŃbZ[Wo͂邩ǂ𒲂ׂ
/**
 * w肳ꂽx̃bZ[Wo͂邩𒲂ׂ܂B
 *
 * @param level [in] Ox
 * @retval true w肳ꂽx̃bZ[W͏o͂
 * @retval false bZ[W͏o͂Ȃ
 * @see LogDevice.is_level()
 */
inline bool log_level ( int level = 0 )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    return (dev == NULL) ? false : dev->is_level( level );
}


///  ERROR xŃOo͂
inline void log_write_error ( const char * string )
{
    log_write( LOG_ERROR, string );
}


///  ERROR xŃOo͂
inline void log_write_error ( const std::string & string )
{
    log_write( LOG_ERROR, string );
}


/// ERROR x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_error ( void )
{
    return log_level( LOG_ERROR );
}


/// ERROR x̃ObZ[Wo͂
inline void log_error ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_ERROR, format, arg );
        va_end( arg );
    }
}

///  WARN xŃOo͂
inline void log_write_warn ( const char * string )
{
    log_write( LOG_WARN, string );
}


///  WARN xŃOo͂
inline void log_write_warn ( const std::string & string )
{
    log_write( LOG_WARN, string );
}


/// WARN x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_warn ( void )
{
    return log_level( LOG_WARN );
}


/// WARN x̃ObZ[Wo͂
inline void log_warn ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_WARN, format, arg );
        va_end( arg );
    }
}

///  TRACE xŃOo͂
inline void log_write_trace ( const char * string )
{
    log_write( LOG_TRACE, string );
}


///  TRACE xŃOo͂
inline void log_write_trace ( const std::string & string )
{
    log_write( LOG_TRACE, string );
}


/// TRACE x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_trace ( void )
{
    return log_level( LOG_TRACE );
}


/// TRACE x̃ObZ[Wo͂
inline void log_trace ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_TRACE, format, arg );
        va_end( arg );
    }
}

///  COMMENT xŃOo͂
inline void log_write_comment ( const char * string )
{
    log_write( LOG_COMMENT, string );
}


///  COMMENT xŃOo͂
inline void log_write_comment ( const std::string & string )
{
    log_write( LOG_COMMENT, string );
}


/// COMMENT x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_comment ( void )
{
    return log_level( LOG_COMMENT );
}


/// COMMENT x̃ObZ[Wo͂
inline void log_comment ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_COMMENT, format, arg );
        va_end( arg );
    }
}

///  INFO xŃOo͂
inline void log_write_info ( const char * string )
{
    log_write( LOG_INFO, string );
}


///  INFO xŃOo͂
inline void log_write_info ( const std::string & string )
{
    log_write( LOG_INFO, string );
}


/// INFO x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_info ( void )
{
    return log_level( LOG_INFO );
}


/// INFO x̃ObZ[Wo͂
inline void log_info ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_INFO, format, arg );
        va_end( arg );
    }
}

///  DEBUG xŃOo͂
inline void log_write_debug ( const char * string )
{
    log_write( LOG_DEBUG, string );
}


///  DEBUG xŃOo͂
inline void log_write_debug ( const std::string & string )
{
    log_write( LOG_DEBUG, string );
}


/// DEBUG x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_debug ( void )
{
    return log_level( LOG_DEBUG );
}


/// DEBUG x̃ObZ[Wo͂
inline void log_debug ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_DEBUG, format, arg );
        va_end( arg );
    }
}

///  USER xŃOo͂
inline void log_write_user ( const char * string )
{
    log_write( LOG_USER, string );
}


///  USER xŃOo͂
inline void log_write_user ( const std::string & string )
{
    log_write( LOG_USER, string );
}


/// USER x̃ObZ[Wo͂邩ǂ𒲂ׂ
inline bool log_is_user ( void )
{
    return log_level( LOG_USER );
}


/// USER x̃ObZ[Wo͂
inline void log_user ( const char * format, ... )
{
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev != NULL ) {
        va_list arg;
        va_start( arg, format );
        dev->vprintf( LOG_USER, format, arg );
        va_end( arg );
    }
}

} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OfoCX̏
void Init_log ( void );


/// OfoCX̏I
void Exit_log ( void );


} /* namespace BK */


#endif /* _SCHEMA_LOG_MAIN_H_20030810Sun_000904_ */
