#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  萔`
//

/// gp^C}[̎
/**
 * 0 ... MultiThreadTimer
 * 1 ... SingleThreadTimer
 */
#define FRAMETIMER_TYPE 0

namespace {

const int MAINWND_DEFAULT_WIDTH = 640;
const int MAINWND_DEFAULT_HEIGHT = 480;
const char * const MAINWND_DEFAULT_CAPTION = "Black Kit";

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::W32ApplicationDevice
//
namespace {

/// EBhEvV[W
LRESULT CALLBACK Win32_AppWindow_wndproc ( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
    BK::Win32::WindowProcedure * wndproc =
        reinterpret_cast< BK::Win32::WindowProcedure * >( GetWindowLong( hwnd, GWL_USERDATA ) );
    
    if( wndproc == NULL )
    {
        switch( msg ) {
        case WM_CREATE:
            {
                CREATESTRUCT * cs = reinterpret_cast< CREATESTRUCT * >( lparam );
                wndproc = reinterpret_cast< BK::Win32::WindowProcedure * >( cs->lpCreateParams );
                return wndproc->dispatch_message( hwnd, msg, wparam, lparam );
            }
            break;
        }
        return DefWindowProc( hwnd, msg, wparam, lparam );
    }
    return wndproc->dispatch_message( hwnd, msg, wparam, lparam );
}

/// EBhENX̓o^
void register_window_class ( WNDCLASSEX * obj, HINSTANCE inst )
{
    using namespace BK;
    
    obj->cbSize = sizeof(WNDCLASSEX);
    obj->hInstance = inst;
    obj->lpfnWndProc = &Win32_AppWindow_wndproc;
    obj->lpszClassName = "BlackKit_MainWindow";
    obj->style = CS_CLASSDC | CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
    
    if( RegisterClassEx( obj ) == 0 ) {
        log_error("[BK::W32ApplicationDevice::ApplicationDevice()] "
                  "CEBhEp̃EBhENXo^Ɏs.");
        throw new windows_exception("EBhENX̓o^Ɏs܂.");
    }
}

/// LvV̎擾
const char * get_window_caption ( void )
{
    return BK::ApplicationDevice::get_initial_caption();
}

/// EBhEX^C̎擾
DWORD get_window_style ( void )
{
    return WS_BORDER | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE;
}

/// {[_[܂ރEBhETCY̎擾
BK::Size2 get_window_size ( DWORD style, bool has_menu )
{
    using namespace BK;
    
    const Size2 initsize = ApplicationDevice::get_initial_size();
    RECT r;
    
    r.left = 0;
    r.top = 0;
    r.right = initsize.get_width();
    r.bottom = initsize.get_height();
    
    if( !AdjustWindowRect( &r, style, has_menu ) ) {
        throw new windows_exception(
            "(%d,%d)-(%d,%d) ɑ΂EBhETCY̌vZɎs܂. (X^C: %08X, j[: %s)",
            r.left, r.top, r.right, r.bottom, style, (has_menu) ? "" : "Ȃ" );
    }
    
    return toRect2(r).get_size();
}

/// EBhȄʒu擾 (TCY܂)
BK::Rect2 get_window_position ( DWORD style, bool has_menu )
{
    using namespace BK;
    
    BK::Size2 wsize = get_window_size(style, has_menu);
    int x, y;
    
    HWND desktop = GetDesktopWindow();
    RECT r;
    
    if( !GetWindowRect( desktop, &r ) ) {
        throw new windows_exception("fXNgbṽTCY擾Ɏs܂.");
    }
    
    Rect2 r2 = toRect2( r );
    
    x = (r2.get_width() - wsize.get_width()) / 2;
    y = (r2.get_height() - wsize.get_height()) / 2;
    
    return Rect2( x, y, x + wsize.get_width(), y + wsize.get_height() );
}

/// EBhE𐶐
HWND create_window ( const WNDCLASSEX & wndclass, BK::Win32::WindowProcedure * wndproc )
{
    using namespace BK;
    
    const char * caption = get_window_caption();
    DWORD style = get_window_style();
    Rect2 r = get_window_position( style, false );
    
    HWND wnd = CreateWindow(
        wndclass.lpszClassName ,    // class name
        caption ,                   // window name
        style ,                     // style
        r.get_left() ,              // x
        r.get_top() ,               // y
        r.get_width() ,             // width
        r.get_height() ,            // height
        NULL ,                      // parent window
        NULL ,                      // menu
        wndclass.hInstance ,        // instance
        wndproc                     // pointer for WM_CREATE
        );
    
    if( wnd == NULL ) {
        throw new windows_exception("CEBhE̍쐬Ɏs܂.");
    }
    log_trace("CEBhE𐶐܂. (HWND: %p)", wnd);
    
    SetLastError(0);
    //SetWindowLongPtr();
    SetWindowLong( wnd, GWL_USERDATA, reinterpret_cast<LONG>(wndproc) );
    if( GetLastError() != 0 ) {
        throw new windows_exception("EBhE %p ɑ΂EBhEvV[W̐ݒɎs܂.", wnd);
    }
    
    return wnd;
}

} /* namespace */

BK::W32ApplicationDevice * BK::W32ApplicationDevice::singleton_object = NULL;

BK::W32ApplicationDevice::W32ApplicationDevice ( void )
        : handle_instance (NULL),
          num_systimer_precision (0),
          handle_window (NULL)
{
    singleton_object = this;
    
    ZeroMemory( &obj_window_class, sizeof(WNDCLASSEX) );
    try {
        // f[^̐ݒ
        handle_instance = Win32::get_current_instance_handle();
        log_comment("Windows CX^Xnh: [%p]", handle_instance);
        
        num_systimer_precision = Win32::initialize_system_timer();
        log_comment("Windows VXe^C}[x: %d msec", num_systimer_precision);
        
        // EBhENX̓o^
        register_window_class( &obj_window_class, handle_instance );
        log_comment("CEBhEp̃EBhENX (%s) o^.", obj_window_class.lpszClassName);
    }
    catch ( exception_base * ) {
        finalize_object();
        throw;
    }
}

void BK::W32ApplicationDevice::finalize_object ( void )
{
    if( num_systimer_precision != 0 ) {
        if( !Win32::finalize_system_timer(num_systimer_precision) ) {
            log_error("[BK::W32ApplicationDevice::finalize_object()] "
                      "VXe^C}[̉Ɏs܂. (x: %d msec)", num_systimer_precision);
        }
    }
    if( obj_window_class.hInstance != NULL ) {
        {
            BOOL result = UnregisterClass( obj_window_class.lpszClassName, obj_window_class.hInstance );
            if( result == 0 ) {
                log_error("[BK::W32ApplicationDevice::finalize_object()] "
                          "EBhENX̓o^Ɏs܂. (%s)", Win32::get_lasterror_message().c_str());
            }
        }
    }
}

BK::W32ApplicationDevice::~W32ApplicationDevice ()
{
    singleton_object = NULL;
    finalize_object();
}

void BK::W32ApplicationDevice::_start ( void )
{
    ApplicationDevice::_start();
    
    try {
        // CEBhE̐
        handle_window = create_window( obj_window_class, this );
        log_comment("CEBhE̐ɐ.");
    }
    catch ( exception_base * ) {
        _stop();
        throw;
    }
}

void BK::W32ApplicationDevice::_stop ( void )
{
    if( handle_window != NULL ) {
        if( IsWindow(handle_window) ) {
            log_trace("[BK::W32ApplicationDevice::finalize_object()] "
                      "CEBhE̔jJn.");
            if( !DestroyWindow(handle_window) ) {
                log_error("[BK::W32ApplicationDevice::finalize_object()] "
                          "CEBhE̔jɎs. (%s)\n", Win32::get_lasterror_message().c_str());
            }
        }
    }
    
    ApplicationDevice::_stop();
}

BK::Size2 BK::W32ApplicationDevice::get_application_area_size ( void ) const
{
    RECT r;
    
    if( handle_window == NULL ) {
        return Size2(0, 0);
    }
    
    if( GetClientRect( handle_window, &r ) == 0 ) {
        throw new windows_exception("EBhEnh <%p> ̃NCAg̈TCY擾Ɏs.", handle_window);
    }
    
    return toRect2( r ).get_size();
}

void BK::W32ApplicationDevice::on_each_loop_beginning ( void )
{
    MSG msg;
    
    while( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != 0 ) {
        TranslateMessage(&msg);
        dispatch_message(msg.hwnd, msg.message, msg.wParam, msg.lParam);
    }
}

//LRESULT BK::W32ApplicationDevice::on_windows_message ( HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam )
//{
//    return WindowProcedure::on_windows_message(wnd, msg, wparam, lparam);
//}

//////////////////////////////////////////////////////////////////////
