#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::Win32::WindowProcedure
//

LRESULT BK::Win32::WindowProcedure::dispatch_message ( HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
    switch( msg ) {
    case WM_CREATE:
        {
            CREATESTRUCT * cs = reinterpret_cast<CREATESTRUCT *>( lparam );
            return (on_create(*cs)) ? 0 : -1;
        }
        
    case WM_CLOSE:
        log_trace("BK::Win32::WindowProcedure: WM_CLOSE M.");
        if( on_close() ) {
            DestroyWindow( wnd );
        }
        return 0;
        
    case WM_QUIT:
        log_trace("BK::Win32::WindowProcedure: WM_QUIT M.");
        on_quit();
        return 0;
        
    case WM_DESTROY:
        log_trace("BK::Win32::WindowProcedure: WM_DESTROY M.");
        PostQuitMessage(0);
        return 0;
    }
    return on_windows_message( wnd, msg, wparam, lparam );
}

void BK::Win32::WindowProcedure::on_quit ( void )
{
    throw new system_exit("AvP[VI܂.");
}

//////////////////////////////////////////////////////////////////////
