#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::Win32::windows_exception
//

BK::windows_exception::windows_exception ( const char * format, ... )
{
    const int buffer_capacity = 64 * 1024 - 1;
    char buffer [ buffer_capacity + 1 ];
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    
    err_code = GetLastError();
    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, NULL, err_code, 0, buffer, buffer_capacity, NULL );
    
    std::string winmes = BK::strformat(" [WindowsG[: %s]", buffer);
    
    this->the_string().append( winmes );
    
    va_end( arg );
}

BK::directx_exception::directx_exception ( HRESULT code, const char * format, ... )
{
    const char * mes;
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    
    err_code = code;
    mes = BK::DirectX::result_to_message( code );
    
    std::string dxmes = BK::strformat(" [DirectXG[: %s]", mes);
    
    this->the_string().append( dxmes );
    
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
