#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  Win32 API ֐`
//

HINSTANCE BK::Win32::get_current_instance_handle ( void )
{
    return GetModuleHandle(NULL);
}

HANDLE BK::Win32::get_current_process_handle ( void )
{
    return GetCurrentProcess();
}

HWND BK::Win32::get_active_window_handle ( void )
{
    return GetActiveWindow();
}

DWORD BK::Win32::get_current_thread_id ( void )
{
    return GetCurrentThreadId();
}

UINT BK::Win32::initialize_system_timer ( void )
{
    TIMECAPS caps;
    UINT period;
    
    if( timeGetDevCaps(&caps, sizeof(caps)) == TIMERR_NOERROR )
        period = caps.wPeriodMin;
    else
        period = 1;
    
    while( timeBeginPeriod(period) != TIMERR_NOERROR )
        ++period;
    
    return period;
}

bool BK::Win32::finalize_system_timer ( UINT prec )
{
    if( timeEndPeriod( prec ) == TIMERR_NOCANDO ) {
        return false;
    }
    return true;
}

std::string BK::Win32::get_message ( DWORD code )
{
    const int buffer_capacity = 64 * 1024 - 1;
    char buffer [ buffer_capacity + 1 ];
    
    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, NULL, code, 0, buffer, buffer_capacity, NULL );
    
    return std::string(buffer);
}

std::string BK::Win32::GUID_to_str ( GUID const & guid )
{
    const int BufferSize = 256;
    WCHAR wbuf [ BufferSize ];
    char buf [ BufferSize ];
    
    StringFromGUID2( guid, wbuf, BufferSize );
    if( WideCharToMultiByte( CP_ACP, 0, wbuf, -1, buf, BufferSize, NULL, FALSE ) == 0 ) {
        throw new windows_exception("Ch񂩂}`oCgւ̕ϊɎs.");
    }
    
    return std::string(buf);
}

//////////////////////////////////////////////////////////////////////
