#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  obNobt@LoX
//
namespace BK {

class Dx9BackBufferCanvas : public Canvas
{
public: /* Canvas C^[tFCX */
    
    /// LoX̃N[Y
    virtual void close_canvas ( void );
    
private:
    
    /// LoXpT[tFX
    Dx9Surface * ptr_surface;
    
public:
    
    /// RXgN^
    /**
     * nꂽT[tFXIuWFNǵÃLoXƂɔj܂B
     * ܂AT[tFX̓VXeɍ쐬ĂȂ΂Ȃ܂B
     */
    Dx9BackBufferCanvas ( Dx9Surface * surface, const D3DLOCKED_RECT & lock, const Rect2 & area );
    
    /// fXgN^
    /**
     * obNobt@Ƀf[^Rs[Aj܂B
     */
    ~Dx9BackBufferCanvas ();
    
};

} /* namespace BK */

BK::Dx9BackBufferCanvas::Dx9BackBufferCanvas ( Dx9Surface * surface, const D3DLOCKED_RECT & lock, const Rect2 & area )
        : Canvas (NULL, area, surface->get_pixel_info(), lock.pBits, lock.Pitch),
          ptr_surface (surface)
{
}

BK::Dx9BackBufferCanvas::~Dx9BackBufferCanvas ()
{
    try {
        if( !is_canvas_closed() ) {
            close_canvas();
        }
    }
    catch ( exception_base * ) {
        delete ptr_surface;
        throw;
    }
    delete ptr_surface;
}

void BK::Dx9BackBufferCanvas::close_canvas ( void )
{
    Dx9GraphicDevice * const gdev = Dx9GraphicDevice::get_instance();
    IDirect3DDevice9 * const dev = gdev->get_direct_graphics_device();
    HRESULT result;
    RECT r;
    POINT p;
    
    ptr_surface->unlock_surface();
    
    r = toRECT( get_rect() );
    p = toPOINT( get_rect().get_point() );
    result = dev->UpdateSurface( ptr_surface->get_interface(), &r, gdev->get_backbuffer()->get_interface(), &p );
    if( result != D3D_OK ) {
        throw new directx_exception(result, "T[tFXobNobt@ւ̓]Ɏs.");
    }
    delete ptr_surface;
    ptr_surface = NULL;
    
    Canvas::close_canvas();
}

//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace BK {

Dx9BackBufferCanvas * create_Dx9BackBufferCanvas ( Dx9GraphicDevice * gdev, BK::Rect2 const * areaptr )
{
    IDirect3DDevice9 * const dev = gdev->get_direct_graphics_device();
    Dx9Surface * const backsurface = gdev->get_backbuffer();
    
    const D3DFORMAT format = backsurface->get_d3d_format();
    const Size2 backsize = backsurface->get_size();
    IDirect3DSurface9 * surf;
    Dx9Surface * surface;
    HRESULT result;
    Rect2  area;
    RECT * pwr;
    RECT   wr;
    
    if( areaptr == NULL ) {
        area = Rect2( backsize );
        pwr = NULL;
    }
    else {
        area = *areaptr;
        wr = toRECT(area);
        pwr = &wr;
    }
    
    result = gdev->CreateOffscreenPlainSurface( backsize, format, D3DPOOL_SYSTEMMEM, &surf );
    if( result != D3D_OK ) {
        throw new directx_exception(result, "obNobt@pT[tFXɎs.");
    }
    
    try {
        result = dev->GetRenderTargetData( backsurface->get_interface(), surf );
        if( result != D3D_OK ) {
            throw new directx_exception(result, "obNobt@烁T[tFXւ̓]Ɏs.");
        }
        
        surface = new Dx9Surface( surf );
    } catch ( exception_base * ) {
        surf->Release();
        throw;
    }
    
    try {
        D3DLOCKED_RECT lock = surface->lock_surface(pwr);
        try {
            return new Dx9BackBufferCanvas( surface, lock, area );
        } catch ( exception_base * ) {
            surface->unlock_surface();
            throw;
        }
    } catch ( exception_base * ) {
        delete surface;
        throw;
    }
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

IDirect3D9 * create_d3d9_graphics ( void )
{
    using namespace BK;
    
    IDirect3D9 * const ret = Direct3DCreate9( D3D_SDK_VERSION );
    
    if( !ret ) {
        throw new runtime_exception("DirectGraphics IuWFNg̐Ɏs.");
    }
    log_comment("DirectGraphics IuWFNg <%p> ̐ɐ.", ret);
    
    return ret;
}

IDirect3DDevice9 * create_d3d9_graphics_device ( IDirect3D9 * graphics )
{
    using namespace BK;
    //TraceScopeLog methodname ("create_d3d9_graphics_device()");
    
    W32ApplicationDevice * const app = W32ApplicationDevice::get_instance();
    const HWND wnd = app->get_window_handle();
    
    D3DPRESENT_PARAMETERS pres;
    HRESULT result;
    int i;
    
    if( wnd == NULL ) {
        throw new logic_exception("W32ApplicationDevice EBhEnh擾邱Ƃł܂.");
    }
    
    const bool fullscreen = GraphicDevice::is_initial_fullscreen();
    
    ZeroMemory( &pres, sizeof(D3DPRESENT_PARAMETERS) );
    pres.Windowed = (fullscreen) ? FALSE : TRUE;
    pres.SwapEffect = D3DSWAPEFFECT_DISCARD;
    pres.hDeviceWindow = wnd;
    pres.BackBufferFormat = D3DFMT_UNKNOWN;
    
    IDirect3DDevice9 * graphics_device = NULL;
    struct
    {
        D3DDEVTYPE type;
        DWORD flag;
    }
    const cparam [] =
    {
        { D3DDEVTYPE_HAL, D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_PUREDEVICE },
        { D3DDEVTYPE_HAL, D3DCREATE_HARDWARE_VERTEXPROCESSING },
        { D3DDEVTYPE_HAL, D3DCREATE_SOFTWARE_VERTEXPROCESSING },
        { D3DDEVTYPE_REF, D3DCREATE_SOFTWARE_VERTEXPROCESSING },
        { D3DDEVTYPE_REF, 0 },
    };
    
    for( i = 0; graphics_device == NULL && cparam[i].flag != 0; ++i ) {
        result = graphics->CreateDevice(
            D3DADAPTER_DEFAULT,
            cparam[i].type,
            wnd,
            cparam[i].flag,
            &pres,
            &graphics_device
            );
        if( result == D3D_OK )
            break;
        graphics_device = NULL;
    }
    if( graphics_device == NULL ) {
        log_error("[create_d3d9_graphics_device()] DirectGraphics foCX̐Ɏs܂.");
        throw new directx_exception(result, "DirectGraphics foCX̐Ɏs.");
    }
    log_comment("DirectGraphics foCX <%p> ̐ɐ.", graphics_device);
    
    // _O̐ݒ
    graphics_device->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE ); // At@uhL
    graphics_device->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );
    graphics_device->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
    
    // eNX`_O̐ݒ
    graphics_device->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE ); // fBt[YL
    graphics_device->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
    graphics_device->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
    
    return graphics_device;
}

D3DFORMAT get_best_texture_format ( IDirect3D9 * obj, IDirect3DDevice9 * dev )
{
    using namespace BK;
    
    D3DCAPS9 devdesc;
    D3DDISPLAYMODE dspdesc;
    
    DirectX::get_d3d_device_desc( dev, &devdesc );
    DirectX::get_primary_display_desc( obj, &dspdesc );
    
    static const D3DFORMAT formats [] = {
        D3DFMT_A8R8G8B8,
        D3DFMT_A4R4G4B4,
        D3DFMT_UNKNOWN
    };
    const D3DFORMAT * format;
    HRESULT result;
    
    for( format = formats; *format != D3DFMT_UNKNOWN; ++format ) {
        result = obj->CheckDeviceFormat(
            D3DADAPTER_DEFAULT,
            devdesc.DeviceType,
            dspdesc.Format,
            0,
            D3DRTYPE_TEXTURE,
            *format);
        if( result == D3D_OK ) {
            break;
        }
        if( result != D3DERR_NOTAVAILABLE ) {
            throw new directx_exception(result, "eNX`T|[gsNZtH[}bǧɎs.");
        }
    }
    
    return *format;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Dx9GraphicDevice
//

BK::Dx9GraphicDevice * BK::Dx9GraphicDevice::singleton_object = NULL;

BK::Dx9GraphicDevice::Dx9GraphicDevice ( void )
        : ptr_graphics (NULL),
          ptr_graphics_device (NULL),
          ptr_back_surface (NULL),
          num_texture_format (D3DFMT_UNKNOWN)
{
    //TraceScopeLog methodname ("BK::Dx9GraphicDevice::Dx9GraphicDevice()");
    
    if( ApplicationDevice::get_instance() == NULL ) {
        throw new logic_exception("AvP[VfoCX\zOɃOtBbNfoCX͍\zł܂.");
    }
    singleton_object = this;
}

BK::Dx9GraphicDevice::~Dx9GraphicDevice ()
{
    //TraceScopeLog methodname ("BK::Dx9GraphicDevice::~Dx9GraphicDevice()");
    release_all();
    singleton_object = NULL;
}

void BK::Dx9GraphicDevice::release_all ( void )
{
    //TraceScopeLog methodname ("BK::Dx9GraphicDevice::release_all()");
    if( ptr_back_surface ) {
        delete ptr_back_surface;
        log_trace("obNobt@ <%p> ̎QƂ܂.", ptr_back_surface);
        ptr_back_surface = NULL;
    }
    if( ptr_graphics_device ) {
        DirectX::Release( ptr_graphics_device );
        log_comment("DirectGraphics foCX <%p> ܂.", ptr_graphics_device);
        ptr_graphics_device = NULL;
    }
    if( ptr_graphics ) {
        DirectX::Release( ptr_graphics );
        log_comment("DirectGraphics IuWFNg <%p> ܂.", ptr_graphics);
        ptr_graphics = NULL;
    }
}

void BK::Dx9GraphicDevice::_start ( void )
{
    //TraceScopeLog methodname ("BK::Dx9GraphicDevice::_start()");
    GraphicDevice::_start();
    
    try {
        ptr_graphics = create_d3d9_graphics();
        log_trace("DirectGraphics IuWFNg擾܂.");
        
        ptr_graphics_device = create_d3d9_graphics_device( ptr_graphics );
        if( ptr_graphics_device == NULL ) {
            throw new runtime_exception("擾 DirectGraphics foCX NULL ł.");
        }
        if( log_is_info() ) {
            log_trace("DirectGraphics foCX擾܂.");
            log_write_info( DirectX::inspect_d3d_device(ptr_graphics_device) );
        }
        
        IDirect3DSurface9 * surface;
        HRESULT result;
        
        result = ptr_graphics_device->GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, &surface);
        if( result != D3D_OK ) {
            throw new directx_exception(result, "obNobt@̎擾Ɏs܂.");
        }
        ptr_back_surface = new Dx9Surface( surface );
        if( log_is_trace() ) {
            log_trace("obNobt@̎擾ɐ܂.");
            log_write_trace( DirectX::inspect_d3d_surface(ptr_back_surface->get_interface()) );
        }
        
        num_texture_format = get_best_texture_format( ptr_graphics, ptr_graphics_device );
        if( num_texture_format == D3DFMT_UNKNOWN ) {
            throw new runtime_exception("Direct3D foCXAt@t̃eNX`T|[gĂ܂.");
        }
        log_info("eNX`ɍœKȃsNZtH[}bg: %s", DirectX::D3DFORMAT_to_string(num_texture_format));
    } catch ( exception_base * ) {
        release_all();
        throw;
    }
}

void BK::Dx9GraphicDevice::_stop ( void )
{
    //TraceScopeLog methodname ("BK::Dx9GraphicDevice::_stop()");
    release_all();
    GraphicDevice::_stop();
}

void BK::Dx9GraphicDevice::update_screen ( void )
{
    GraphicDevice::update_screen();
    
    W32ApplicationDevice * const app = W32ApplicationDevice::get_instance();
    HRESULT result;
    
    if( app ) {
        if( app->is_window_visible() ) {
            result = ptr_graphics_device->Present( NULL, NULL, NULL, NULL );
            if( result != D3D_OK ) {
                throw new directx_exception(result, "obNobt@XN[ւ̓]Ɏs.");
            }
        }
    }
}

void BK::Dx9GraphicDevice::clear_screen ( D3DCOLOR color )
{
    HRESULT result;
    
    result = ptr_graphics_device->Clear( 0, NULL, D3DCLEAR_TARGET, color, 1.0, 0 );
    if( result != D3D_OK ) {
        throw new directx_exception(result, "obNobt@̃NAɎs.");
    }
}

void BK::Dx9GraphicDevice::clear_screen ( BK::Rect2 const & r, D3DCOLOR color )
{
    HRESULT result;
    D3DRECT rect;
    
    rect = DirectX::toD3DRECT( r );
    result = ptr_graphics_device->Clear( 1, &rect, D3DCLEAR_TARGET, color, 1.0, 0 );
    if( result != D3D_OK ) {
        throw new directx_exception(result, "obNobt@̎ẅNAɎs.");
    }
}

void BK::Dx9GraphicDevice::fill_screen ( BK::Color const & color )
{
    clear_screen( DirectX::Color_to_D3DCOLOR(color) );
}

void BK::Dx9GraphicDevice::fill_screen ( BK::Rect2 const & r, BK::Color const & color )
{
    clear_screen( r, DirectX::Color_to_D3DCOLOR(color) );
}

void BK::Dx9GraphicDevice::copy_surface ( BK::Point2 const & p, BK::Dx9Surface & surface, const Rect2 * rect )
{
    HRESULT result;
    RECT dr;
    RECT sr;
    
    // HRESULT D3DXLoadSurfaceFromSurface(
    //     LPDIRECT3DSURFACE9 pDestSurface,
    //     CONST PALETTEENTRY *pDestPalette,
    //     CONST RECT *pDestRect,
    //     LPDIRECT3DSURFACE9 pSrcSurface,
    //     CONST PALETTEENTRY *pSrcPalette,
    //     CONST RECT *pSrcRect,
    //     DWORD Filter,
    //     D3DCOLOR ColorKey
    // );
    if( rect == NULL ) {
        dr = toRECT( Rect2(p, surface.get_size()) );
    } else {
        dr = toRECT( Rect2(p, rect->get_size()) );
        sr = toRECT( *rect );
    }
    result = D3DXLoadSurfaceFromSurface(
        ptr_back_surface->get_interface(),
        NULL,
        &dr,
        surface.get_interface(),
        NULL,
        (rect == NULL) ? NULL : &sr,
        D3DX_FILTER_NONE,
        0 );
    if( result != D3D_OK ) {
        throw new directx_exception(result, "sN`̓]Ɏs܂.");
    }
}

void BK::Dx9GraphicDevice::blit_picture ( Point2 const & p, Picture * pict, const Rect2 * rect )
{
    if( pict == NULL ) {
        throw new argument_exception("GraphicDevice.blit_picture()  NULL n܂.");
    }
    
    Dx9Surface * surface = dynamic_cast< Dx9Surface * >( pict );
    
    if( surface != NULL ) {
        copy_surface( p, *surface, rect );
    }
    else {
        throw new unsupported_exception("OtBbNfoCX̃T|[gĂȂsN`n܂.");
    }
}

BK::Picture * BK::Dx9GraphicDevice::create_picture ( const BK::Size2 & size )
{
    Dx9Surface * surface;
    D3DFORMAT format = ptr_back_surface->get_d3d_format();
    
    surface = new Dx9Surface( size, format, false );
    
    return surface;
}

BK::Picture * BK::Dx9GraphicDevice::load_picture_from_file ( const char * filename )
{
    const D3DFORMAT format = ptr_back_surface->get_d3d_format();
    D3DXIMAGE_INFO info;
    HRESULT result;
    
    DirectX::get_imagefile_info( filename, &info );
    
    Dx9Surface * const surface = new Dx9Surface( Size2(info.Width, info.Height), format, false );
    
    try {
        IDirect3DSurface9 * const ds = surface->get_interface();
        
        result = D3DXLoadSurfaceFromFile(ds, NULL, NULL, filename, NULL, D3DX_DEFAULT, 0, NULL);
        if( result != D3D_OK ) {
            throw new directx_exception(result, "t@C %s ̓ǂݍ݂Ɏs.", filename);
        }
    } catch ( exception_base * ) {
        delete surface;
        throw;
    }
    log_trace("t@C '%s'  Picture \z.", filename);
    
    return surface;
}

BK::Picture * BK::Dx9GraphicDevice::load_picture_from_memory ( void const * src, unsigned int cap )
{
    const D3DFORMAT format = ptr_back_surface->get_d3d_format();
    D3DXIMAGE_INFO info;
    HRESULT result;
    
    DirectX::get_imagefile_info( src, cap, &info );
    
    Dx9Surface * const surface = new Dx9Surface( Size2(info.Width, info.Height), format, false );
    
    try {
        IDirect3DSurface9 * const ds = surface->get_interface();
        
        result = D3DXLoadSurfaceFromFileInMemory(ds, NULL, NULL, src, cap, NULL, D3DX_DEFAULT, 0, NULL);
        if( result != D3D_OK ) {
            throw new directx_exception(result, "t@C (AhX %p) ̓ǂݍ݂Ɏs.", src);
        }
    } catch ( exception_base * ) {
        delete surface;
        throw;
    }
    log_trace("t@C Picture \z.");
    
    return surface;
}

BK::Image * BK::Dx9GraphicDevice::create_image ( const Size2 & size )
{
    Dx9Texture * const texture = new Dx9Texture( size, num_texture_format, true );
    
    return texture;
}

BK::Image * BK::Dx9GraphicDevice::load_image_from_file ( const char * filename )
{
    IDirect3DTexture9 * texture;
    HRESULT result;
    
    result = D3DXCreateTextureFromFileEx(
        ptr_graphics_device,
        filename,
        D3DX_DEFAULT,
        D3DX_DEFAULT,
        1,
        0,
        num_texture_format,
        D3DPOOL_MANAGED, // VRAM ɍ쐬
        D3DX_DEFAULT,
        D3DX_DEFAULT,
        0,
        NULL,
        NULL,
        &texture );
    if( result != D3D_OK ) {
        throw new directx_exception(result, "t@C %s ̓ǂݍ݂Ɏs.", filename);
    }
    
    Dx9Texture * const ret = new Dx9Texture( texture );
    log_trace("t@C '%s'  Image \z.", filename);
    
    return ret;
}

BK::Image * BK::Dx9GraphicDevice::load_image_from_memory ( void const * src, unsigned int cap )
{
    IDirect3DTexture9 * texture;
    HRESULT result;
    
    result = D3DXCreateTextureFromFileInMemoryEx(
        ptr_graphics_device,
        src,
        cap,
        D3DX_DEFAULT,
        D3DX_DEFAULT,
        1,
        0,
        num_texture_format,
        D3DPOOL_MANAGED, // VRAM ɍ쐬
        D3DX_DEFAULT,
        D3DX_DEFAULT,
        0,
        NULL,
        NULL,
        &texture );
    if( result != D3D_OK) {
        throw new directx_exception(result, "̃t@C (AhX: %p) ̓ǂݍ݂Ɏs.", src);
    }
    
    Dx9Texture * const ret = new Dx9Texture( texture );
    log_trace("t@C Image \z.");
    
    return ret;
}

BK::PictureData * BK::Dx9GraphicDevice::create_picture_data ( const BK::Size2 & size )
{
    Dx9SurfaceData * const surface = new Dx9SurfaceData( size );
    
    return surface;
}

BK::PictureData * BK::Dx9GraphicDevice::load_picture_data_from_file ( const char * filename )
{
    D3DXIMAGE_INFO info;
    HRESULT result;
    
    DirectX::get_imagefile_info( filename, &info );
    
    Dx9SurfaceData * const surface = new Dx9SurfaceData( Size2(info.Width, info.Height) );
    
    try {
        IDirect3DSurface9 * const ds = surface->get_surface()->get_interface();
        
        result = D3DXLoadSurfaceFromFile(ds, NULL, NULL, filename, NULL, D3DX_DEFAULT, 0, NULL);
        if( result != D3D_OK ) {
            throw new directx_exception(result, "t@C %s ̓ǂݍ݂Ɏs.", filename);
        }
    } catch ( exception_base * ) {
        delete surface;
        throw;
    }
    log_trace("t@C '%s'  PictureData \z.", filename);
    
    return surface;
}

BK::PictureData * BK::Dx9GraphicDevice::load_picture_data_from_memory ( void const * src, unsigned int cap )
{
    D3DXIMAGE_INFO info;
    HRESULT result;
    
    DirectX::get_imagefile_info( src, cap, &info );
    
    Dx9SurfaceData * const surface = new Dx9SurfaceData( Size2(info.Width, info.Height) );
    
    try {
        IDirect3DSurface9 * const ds = surface->get_surface()->get_interface();
        
        result = D3DXLoadSurfaceFromFileInMemory(ds, NULL, NULL, src, cap, NULL, D3DX_DEFAULT, 0, NULL);
        if( result != D3D_OK ) {
            throw new directx_exception(result, "t@C (AhX %p) ̓ǂݍ݂Ɏs.", src);
        }
    } catch ( exception_base * ) {
        delete surface;
        throw;
    }
    log_trace("t@C PictureData \z.");
    
    return surface;
}

void BK::Dx9GraphicDevice::render_triangle ( BK::Dx9Texture * texture, DWORD fvf, UINT triangles, const void * vptr, UINT vsize )
{
    HRESULT result;
    
    result = ptr_graphics_device->SetFVF( fvf );
    if( result != D3D_OK ) {
        throw directx_exception(result, "_tH[}bg (%08X) ̐ݒɎs.", fvf);
    }
    
    result = ptr_graphics_device->SetTexture( 0, (texture != NULL) ? texture->get_interface() : NULL );
    if( result != D3D_OK ) {
        throw directx_exception(result, "_OeNX`̊蓖ĂɎs.");
    }
    
    if( ptr_graphics_device->BeginScene() == D3D_OK ) {
        result = ptr_graphics_device->DrawPrimitiveUP(D3DPT_TRIANGLELIST, triangles, vptr, vsize);
        ptr_graphics_device->EndScene();
        
        if( result != D3D_OK ) {
            throw directx_exception(
                result, "v~eBũ_OɎs. (triangles=%u, vsize=%u)", triangles, vsize);
        }
    }
}

BK::Canvas * BK::Dx9GraphicDevice::create_canvas ( BK::Rect2 const * area )
{
    return create_Dx9BackBufferCanvas( this, area );
}

HRESULT BK::Dx9GraphicDevice::CreateOffscreenPlainSurface ( const BK::Size2 & size, D3DFORMAT format, D3DPOOL pool, IDirect3DSurface9 * * surface )
{
    IDirect3DDevice9 * const dev = ptr_graphics_device;
    
    return dev->CreateOffscreenPlainSurface(size.get_width(), size.get_height(), format, pool, surface, NULL );
}

HRESULT BK::Dx9GraphicDevice::CreateLv1Texture ( const BK::Size2 & size, D3DFORMAT format, D3DPOOL pool, IDirect3DTexture9 * * texture )
{
    IDirect3DDevice9 * const dev = ptr_graphics_device;
    
    return dev->CreateTexture(size.get_width(), size.get_height(), 1, 0, format, pool, texture, NULL );
}

//////////////////////////////////////////////////////////////////////
