#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {


/// ]̈obt@̏TCY
const int INITIAL_INFO_CAPACITY = 128;

/// _obt@̏TCY
const int INITIAL_VERTEX_CAPACITY = INITIAL_INFO_CAPACITY * 6;


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Dx9ImageLayer::info_t
//

BK::Dx9ImageLayer::info_t::info_t ( BK::Image & image )
        : obj_image    (image),
          rect_aspect  (0, 0, 0, 0)
{
    if( Dx9GraphicDevice::get_instance() == NULL ) {
        throw_required_is_not_created("DirectXC[WC[", "DirectXOtBbNfoCX");
    }
}

void BK::Dx9ImageLayer::info_t::ruby_gc_mark ( void )
{
    info_parent_t::ruby_gc_mark();
    this->obj_image.gc_mark_self();
}

void BK::Dx9ImageLayer::info_t::on_ruby_wrap ( void )
{
    info_parent_t::on_ruby_wrap();
    this->obj_image.ruby_wrap();
}

void BK::Dx9ImageLayer::info_t::set_source ( BK::Rect2 const & r )
{
    info_parent_t::set_source( r );
    this->rect_aspect.set_rect( r, this->obj_image.get_size() );
}

void BK::Dx9ImageLayer::info_t::set_source ( const BK::SpriteFieldData & sprite )
{
    info_parent_t::set_source( sprite );
    this->rect_aspect = sprite.get_aspect();
}

unsigned int BK::Dx9ImageLayer::info_t::initialize_vertex ( BK::Dx9ImageLayer::vertex_t * vbuf )
{
    return DirectX::write_points_trilist( vbuf, this->get_destination(), this->get_aspect(), this->get_diffuse() );
}

//////////////////////////////////////////////////////////////////////
////  BK::Dx9ImageLayer
//

BK::Dx9ImageLayer::Dx9ImageLayer ( BK::Image & image )
        : ImageLayer  (image),
          ptr_image   (dynamic_cast< Dx9Texture * >(&image)),
          obj_list    (INITIAL_INFO_CAPACITY, INITIAL_VERTEX_CAPACITY)
{
    if( ptr_image == NULL ) {
        throw_unusable_type_for_initialize("Dx9ImageLayer", "Dx9Texture", typeid(image).name());
    }
}

BK::Dx9ImageLayer::~Dx9ImageLayer ()
{
}

void BK::Dx9ImageLayer::execute ( BK::GraphicDevice * dev )
{
    Dx9GraphicDevice * const nativedev = Dx9GraphicDevice::get_instance();
    
    // _O
    nativedev->render_triangle(ptr_image, obj_list);
}

BK::ProjectionInfo * BK::Dx9ImageLayer::register_projection ( void )
{
    info_t * const info = new info_t ( *ptr_image );
    
    if( info == NULL ) {
        throw_no_memory_for_object("Dx9ImageLayer::info_t");
    }
    
    return obj_list.add( *info );
}

void BK::Dx9ImageLayer::delete_projection ( BK::ProjectionInfo * ptr )
{
    info_t * const info = dynamic_cast< info_t * >( ptr );
    
    if( info == NULL ) {
        throw new argument_exception("قȂ^̓]̈ <%s> w肳܂.", typeid(*ptr).name());
    }
    
    if( !obj_list.erase( *info ) ) {
        throw new argument_exception("w肳ꂽ]̈ <%p> ̓C[WC[ɑ݂܂.", ptr);
    }
}

unsigned int BK::Dx9ImageLayer::count_projection ( void ) const
{
    return obj_list.size();
}

void BK::Dx9ImageLayer::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    ptr_image->gc_mark_self();
    obj_list.ruby_gc_mark();
}

void BK::Dx9ImageLayer::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    ptr_image->ruby_wrap();
    obj_list.on_ruby_wrap();
}

//////////////////////////////////////////////////////////////////////
