#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::Dx9SurfaceData
//

BK::Dx9SurfaceData::Dx9SurfaceData ( BK::Size2 const & size )
        : ptr_surface (new Dx9Surface(size, D3DFMT_A8R8G8B8, false))
{
}

BK::Dx9SurfaceData::Dx9SurfaceData ( IDirect3DSurface9 * surface )
        : ptr_surface (new Dx9Surface(surface))
{
}

BK::Dx9SurfaceData::~Dx9SurfaceData ()
{
    delete ptr_surface;
}

BK::Size2 BK::Dx9SurfaceData::get_size ( void )
{
    return ptr_surface->get_size();
}

void BK::Dx9SurfaceData::blit ( BK::Point2 const & dest, BK::Bitmap & src, BK::Rect2 const & area )
{
    ptr_surface->blit( dest, src, area );
}

std::string BK::Dx9SurfaceData::inspect ( void ) const
{
    return ptr_surface->inspect();
}

BK::Bitmap::pool_t BK::Dx9SurfaceData::get_pool_info ( void ) const
{
    return ptr_surface->get_pool_info();
}

BK::Canvas::pixel_t BK::Dx9SurfaceData::get_pixel_info ( void ) const
{
    return ptr_surface->get_pixel_info();
}

BK::Canvas * BK::Dx9SurfaceData::create_canvas ( BK::Rect2 const * area )
{
    return ptr_surface->create_canvas(area);
}

void BK::Dx9SurfaceData::write_to_file ( const char * filename )
{
    ptr_surface->write_to_file( filename );
}

//////////////////////////////////////////////////////////////////////
