#include "stdafx.h"
#include "factory/main.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  t@Ng[`
//

BK::CriticalSection * BK::create_CriticalSection ( void )
{
    return new BK::W32CriticalSection();
}

BK::Event * BK::create_Event ( const char * name )
{
    return new BK::W32Event( name );
}

BK::ApplicationDevice * BK::create_ApplicationDevice ( void )
{
    return new BK::W32ApplicationDevice();
}

BK::FPSGear * BK::create_FPSGear ( void )
{
    return new BK::W32FPSGear();
}

BK::GraphicDevice * BK::create_GraphicDevice ( void )
{
    return new BK::Dx9GraphicDevice();
}

BK::LogDevice * BK::create_LogDevice ( void )
{
    return new BK::LogDevice();
}

BK::InputDevice * BK::create_InputDevice ( void )
{
    return new BK::Dx8InputDevice();
}

BK::FillLayer * BK::create_FillLayer ( void )
{
    return new BK::Dx9FillLayer();
}

BK::PictureLayer * BK::create_PictureLayer ( BK::Picture * pict )
{
    return new BK::Dx9PictureLayer( pict );
}

BK::ImageLayer * BK::create_ImageLayer ( BK::Image & img )
{
    return new BK::Dx9ImageLayer( img );
}

BK::FilmLayer * BK::create_FilmLayer ( void )
{
    //return new BK::W32FilmLayer();
    return new BK::FilmLayer();
}

BK::Font * BK::create_Font ( BK::Font::info_t const & info )
{
    return new BK::W32Font( info );
}

BK::FrameTimer * BK::create_FrameTimer ( unsigned int fps, const char * algorithm )
{
    return new BK::W32CPUFrameTimer( fps );
}

//////////////////////////////////////////////////////////////////////
////  ˑ֐
//

char * BK::get_temp_filename ( char * buf, unsigned int cap )
{
    char pathbuf [ MAX_PATH ];
    char filebuf [ MAX_PATH ];
    
    if( cap == 0 ) {
        return "";
    }
    
    if( GetTempPath( MAX_PATH, pathbuf ) == 0 ) {
        throw new windows_exception("e|t@Cp̃pX擾Ɏs.");
    }
    if( GetTempFileName( pathbuf, "bk_", 0, filebuf ) == 0 ) {
        throw new windows_exception("e|t@C̐Ɏs.");
    }
    --cap;
    strncpy( buf, filebuf, cap );
    buf[cap] = '\0';
    
    return buf;
}

void BK::show_message_box ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    std::string str = BK::strvformat( format, arg );
    va_end( arg );
    
    MessageBox(NULL, str.c_str(), "Black Kit", MB_OK );
}

//////////////////////////////////////////////////////////////////////
