#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {

const unsigned int INITIAL_FPS = 60;

const char * const INITIAL_CAPTION = "BlackKit";

const BK::Size2 INITIAL_SIZE ( 640, 480 );

const char * const INITIAL_TIMER_ALGORITHM = "";

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

using namespace BK;

void raise_block_isnot_given_for_apploop ( void )
{
    rb_raise(rb_eRuntimeError, "AvP[V[vɃubN^Ă܂.");
}

void raise_param_isnot_gear ( VALUE paramobj )
{
    rb_raise(rb_eArgError, "MAȊO (%s) ̃IuWFNg͑ҋ@ł܂.", rb_obj_classname(paramobj));
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace {


class GearArrayDeleter
{
public:
    void operator () ( BK::GearArray * ptr )
    {
        delete ptr;
    }
};


class GearArrayMarker
{
public:
    void operator () ( BK::GearArray * ptr )
    {
        ptr->ruby_gc_mark();
    }
};


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace BK {


class RubyApplicationDevice : public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: ApplicationDevice
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static RubyApplicationDevice * value_to_data ( VALUE obj )
    {
        return ruby_basecast< RubyApplicationDevice, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
public:
    
    /// RXgN^
    RubyApplicationDevice ( ApplicationDevice * )
    {
    }
    
    /// fXgN^
    ~RubyApplicationDevice ()
    {
    }
    
};


} /* namespace BK */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::ApplicationDevice
//
namespace {
extern "C" {

/// foCX̊Jn
VALUE ApplicationDevice_start ( VALUE klass )
{
    using namespace BK;
    ApplicationDevice * const dev = ApplicationDevice::get_instance();
    
    try {
        dev->start();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// foCX̏I
VALUE ApplicationDevice_stop ( VALUE klass )
{
    using namespace BK;
    ApplicationDevice * const dev = ApplicationDevice::get_instance();
    
    try {
        dev->stop();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// foCXNĂ邩𒲂ׂ
VALUE ApplicationDevice_is_started ( VALUE klass )
{
    BK::ApplicationDevice * const dev = BK::ApplicationDevice::get_instance();
    
    return (dev->is_started()) ? Qtrue : Qfalse;
}

/// foCX̑IuWFNg쐬
VALUE ApplicationDevice_connect ( VALUE klass )
{
    using namespace BK;
    ApplicationDevice * const dev = ApplicationDevice::get_instance();
    RubyApplicationDevice * ptr;
    VALUE volatile obj;
    
    if( !dev->is_started() ) {
        Ruby::raise_cannot_create_connection_to_device("AvP[VfoCX");
    }
    try {
        ptr = new RubyApplicationDevice( dev );
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// AvP[VfoCX̏ FPS 擾
VALUE ApplicationDevice_get_initial_FPS ( VALUE klass )
{
    return UINT2NUM( BK::ApplicationDevice::get_initial_fps() );
}

/// AvP[VfoCX̏ FPS ݒ
VALUE ApplicationDevice_set_initial_FPS ( VALUE klass, VALUE fpsobj )
{
    using namespace BK;
    try {
        ApplicationDevice::set_initial_fps( NUM2UINT(fpsobj) );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    return fpsobj;
}

/// AvP[VfoCX̏LvV擾
VALUE ApplicationDevice_get_initial_caption ( VALUE klass )
{
    return rb_str_new2( BK::ApplicationDevice::get_initial_caption() );
}

/// AvP[VfoCX̏LvVݒ
VALUE ApplicationDevice_set_initial_caption ( VALUE klass, VALUE strobj )
{
    using namespace BK;
    const char * str = StringValuePtr( strobj );
    try {
        ApplicationDevice::set_initial_caption( str );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    return strobj;
}

/// AvP[VfoCX̏TCY擾
VALUE ApplicationDevice_get_initial_size ( VALUE klass )
{
    return BK::ApplicationDevice::get_initial_size().create_ruby_object();
}

/// AvP[VfoCX̏TCYݒ
VALUE ApplicationDevice_set_initial_size ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    Size2 size;
    
    try {
        Ruby::ArgScanner scanner("ApplicationDevice.initial_size=", argc, argv);
        
        size = scanner.fetch_Size2("AvP[VTCY");
        
        scanner.finish();
        
        ApplicationDevice::set_initial_size( size );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return size.create_ruby_object();
}

/// AvP[V̏t[^C}[ASY擾
VALUE ApplicationDevice_get_initial_timer_algorithm ( VALUE klass )
{
    return rb_str_new2( BK::ApplicationDevice::get_initial_timer_algorithm() );
}

/// AvP[V̏t[^C}[ASYݒ
VALUE ApplicationDevice_set_initial_timer_algorithm ( VALUE klass, VALUE strobj )
{
    using namespace BK;
    const char * str = StringValuePtr( strobj );
    try {
        ApplicationDevice::set_initial_timer_algorithm( str );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    return strobj;
}

class RubyBlockLoop_while : public BK::ApplicationDevice::Loop
{
public:
    
    bool operator () ( void )
    {
        return RTEST(rb_yield(Qnil));
    }
    
};

class RubyBlockLoop_until : public BK::ApplicationDevice::Loop
{
public:
    
    bool operator () ( void )
    {
        return !RTEST(rb_yield(Qnil));
    }
    
};

class GearLoop : public BK::ApplicationDevice::Loop
{
private:
    
    BK::Gear * const ptr_gear;
    
public:
    
    GearLoop ( BK::Gear * gear )
            : ptr_gear (gear)
    {
    }
    
    bool operator () ( void )
    {
        return ptr_gear->is_terminated();
    }
    
};

class GearsLoop : public BK::ApplicationDevice::Loop
{
public:
    
    typedef std::vector < BK::Gear * > list_t;
    
private:
    
    list_t ary_gear;
    
public:
    
    GearsLoop ( void )
    {
    }
    
    void add ( BK::Gear * gear )
    {
        ary_gear.push_back( gear );
    }
    
    bool is_any ( void )
    {
        const list_t::const_iterator e = ary_gear.end();
        list_t::iterator i;
        
        for( i = ary_gear.begin(); i != e; ++i ) {
            BK::Gear * const ptr = *i;
            if( ptr->is_terminated() ) {
                return true;
            }
        }
        return false;
    }
    
    bool is_all ( void )
    {
        const list_t::const_iterator e = ary_gear.end();
        list_t::iterator i;
        
        for( i = ary_gear.begin(); i != e; ++i ) {
            BK::Gear * const ptr = *i;
            if( !ptr->is_terminated() ) {
                return false;
            }
        }
        return true;
    }
    
};

class GearsLoopAny : public GearsLoop
{
public:
    
    bool operator () ( void )
    {
        return is_any();
    }
    
};

class GearsLoopAll : public GearsLoop
{
public:
    
    bool operator () ( void )
    {
        return is_all();
    }
    
};

VALUE ApplicationDevice_loop_while ( VALUE self )
{
    using namespace BK;
    
    if( !rb_block_given_p() ) {
        raise_block_isnot_given_for_apploop();
    }
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    RubyBlockLoop_while term;
    
    app->do_loop( term );
    
    return Qtrue;
}

VALUE ApplicationDevice_loop_until ( VALUE self )
{
    using namespace BK;
    
    if( !rb_block_given_p() ) {
        raise_block_isnot_given_for_apploop();
    }
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    RubyBlockLoop_until term;
    
    app->do_loop( term );
    
    return Qtrue;
}

VALUE ApplicationDevice_wait ( VALUE self, VALUE gearobj )
{
    using namespace BK;
    
    if( !Gear::is_kind_of( gearobj ) ) {
        raise_param_isnot_gear( gearobj );
    }
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    GearLoop term ( Gear::value_to_data(gearobj) );
    
    app->do_loop( term );
    
    return Qtrue;
}

VALUE ApplicationDevice_wait_all ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    GearsLoopAll term;
    int i;
    
    for( i = 0; i < argc; ++i ) {
        VALUE gearobj = argv[i];
        
        if( !Gear::is_kind_of( gearobj ) ) {
            raise_param_isnot_gear( gearobj );
        }
        term.add( Gear::value_to_data(gearobj) );
    }
    
    app->do_loop( term );
    
    return Qtrue;
}

VALUE ApplicationDevice_wait_any ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    GearsLoopAny term;
    int i;
    
    for( i = 0; i < argc; ++i ) {
        VALUE gearobj = argv[i];
        
        if( !Gear::is_kind_of( gearobj ) ) {
            raise_param_isnot_gear( gearobj );
        }
        term.add( Gear::value_to_data(gearobj) );
    }
    
    app->do_loop( term );
    
    return Qtrue;
}

VALUE ApplicationDevice_set_timer_algorithm ( VALUE self, VALUE nameobj )
{
    using namespace BK;
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    const char * name = StringValuePtr( nameobj );
    
    try {
        app->set_timer_algorithm( name );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

VALUE ApplicationDevice_get_timer_fps ( VALUE self )
{
    using namespace BK;
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    
    return UINT2NUM(app->get_fps());
}

VALUE ApplicationDevice_set_timer_fps ( VALUE self, VALUE numobj )
{
    using namespace BK;
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    
    try {
        app->set_fps( NUM2UINT(numobj) );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return numobj;
}

VALUE ApplicationDevice_get_fps_logging_interval ( VALUE self )
{
    using namespace BK;
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    
    return ULONG2NUM(app->get_fps_logging_interval());
}

VALUE ApplicationDevice_set_fps_logging_interval ( VALUE self, VALUE numobj )
{
    using namespace BK;
    ApplicationDevice * const app = ApplicationDevice::get_instance();
    
    try {
        app->set_fps_logging_interval(NUM2ULONG(numobj));
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return numobj;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::RubyApplicationDevice
//

VALUE BK::RubyApplicationDevice::ruby_class_object = Qnil;

VALUE BK::RubyApplicationDevice::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "ApplicationDevice", BK::RubyObject::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "start", ApplicationDevice_start );
    xrb_define_0arg_singleton_method( c, "started?", ApplicationDevice_is_started );
    xrb_define_0arg_singleton_method( c, "stop", ApplicationDevice_stop );
    xrb_define_0arg_singleton_method( c, "connect", ApplicationDevice_connect );
    xrb_define_0arg_singleton_method( c, "new", ApplicationDevice_connect );
    xrb_define_0arg_singleton_method( c, "initial_FPS", ApplicationDevice_get_initial_FPS );
    xrb_define_1arg_singleton_method( c, "initial_FPS=", ApplicationDevice_set_initial_FPS );
    xrb_define_0arg_singleton_method( c, "initial_caption", ApplicationDevice_get_initial_caption );
    xrb_define_1arg_singleton_method( c, "initial_caption=", ApplicationDevice_set_initial_caption );
    xrb_define_0arg_singleton_method( c, "initial_size", ApplicationDevice_get_initial_size );
    xrb_define_narg_singleton_method( c, "initial_size=", ApplicationDevice_set_initial_size );
    xrb_define_0arg_singleton_method( c, "initial_timer_algorithm", ApplicationDevice_get_initial_timer_algorithm );
    xrb_define_1arg_singleton_method( c, "initial_timer_algorithm=", ApplicationDevice_set_initial_timer_algorithm );
    
    xrb_define_0arg_method( c, "loop", ApplicationDevice_loop_while );
    xrb_define_0arg_method( c, "loop_while", ApplicationDevice_loop_while );
    xrb_define_0arg_method( c, "loop_until", ApplicationDevice_loop_until );
    xrb_define_1arg_method( c, "wait", ApplicationDevice_wait );
    xrb_define_narg_method( c, "wait_all", ApplicationDevice_wait_all );
    xrb_define_narg_method( c, "wait_any", ApplicationDevice_wait_any );
    xrb_define_1arg_method( c, "timer_algorithm=", ApplicationDevice_set_timer_algorithm );
    xrb_define_0arg_method( c, "fps", ApplicationDevice_get_timer_fps );
    xrb_define_1arg_method( c, "fps=", ApplicationDevice_set_timer_fps );
    xrb_define_0arg_method( c, "fps_logging_interval", ApplicationDevice_get_fps_logging_interval );
    xrb_define_1arg_method( c, "fps_logging_interval=", ApplicationDevice_set_fps_logging_interval );
    
    return ruby_class_object;
}

// ɃO[oŃ}[NĂ
//void BK::RubyApplicationDevice::ruby_gc_mark ( void )
//{
//    ApplicationDevice::get_instance()->ruby_gc_mark();
//}

//////////////////////////////////////////////////////////////////////
////  BK::ApplicationDevice
//

BK::ApplicationDevice * BK::ApplicationDevice::singleton_object = NULL;

unsigned int BK::ApplicationDevice::num_initial_fps = INITIAL_FPS;

std::string BK::ApplicationDevice::str_initial_caption = INITIAL_CAPTION;

BK::Size2 BK::ApplicationDevice::obj_initial_size = INITIAL_SIZE;

std::string BK::ApplicationDevice::str_initial_timer_algorithm = INITIAL_TIMER_ALGORITHM;

BK::ApplicationDevice::ApplicationDevice ( void )
        : str_timer_algorithm       (""),
          ptr_timer                 (NULL),
          num_fps_logging_interval  (0)
{
    if( singleton_object != NULL ) {
        throw new logic_exception("ApplicationDevice ̍č\zs܂.");
    }
    singleton_object = this;
    
    if( log_is_comment() ) {
        log_comment("AvP[VfoCX <%p> ̍\zJn܂.", this);
    }
}

BK::ApplicationDevice::~ApplicationDevice ()
{
    if( log_is_comment() ) {
        log_comment("AvP[VfoCX <%p> ̔jJn܂.", this);
    }
    
    // jI
    if( singleton_object != this ) {
        throw new logic_exception("s ApplicationDevice o܂.");
    }
    singleton_object = NULL;
}

void BK::ApplicationDevice::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    //if( ptr_timer != NULL ) {
    //    ptr_timer->ruby_gc_mark(); // KvȂ
    //}
    this->obj_gears.ruby_gc_mark(); // obj_gears  RubyObject łȂ̂Œ
}

const char * BK::ApplicationDevice::get_device_name ( void ) const
{
    return "AvP[VT[rX";
}

void BK::ApplicationDevice::_start ( void )
{
    this->set_timer_algorithm( ApplicationDevice::get_initial_timer_algorithm() );
}

void BK::ApplicationDevice::_stop ( void )
{
    obj_gears.clear();
    
    if( log_is_info() ) {
        log_info("FPS: %.2f", this->ptr_timer->count_fps());
    }
    delete this->ptr_timer;
    this->ptr_timer = NULL;
}

void BK::ApplicationDevice::set_timer_algorithm ( const char * name )
{
    FrameTimer * const timer = this->ptr_timer;
    unsigned int fps;
    
    if( timer != NULL ) {
        fps = timer->get_fps();
        delete timer;
    } else {
        fps = ApplicationDevice::get_initial_fps();
    }
    this->ptr_timer = create_FrameTimer( fps, name );
    this->str_timer_algorithm = name;
}

void BK::ApplicationDevice::set_fps ( unsigned int fps )
{
    const char * const name = str_timer_algorithm.c_str();
    
    delete this->ptr_timer;
    
    this->ptr_timer = create_FrameTimer( fps, name );
}

unsigned int BK::ApplicationDevice::get_fps ( void ) const
{
    return this->ptr_timer->get_fps();
}

void BK::ApplicationDevice::set_fps_logging_interval ( BK::FrameTimer::time_t interval )
{
    this->num_fps_logging_interval = interval;
}

BK::FrameTimer::time_t BK::ApplicationDevice::get_fps_logging_interval ( void ) const
{
    return this->num_fps_logging_interval;
}

void BK::ApplicationDevice::do_loop ( BK::ApplicationDevice::Loop & term )
{
    FrameTimer * const timer = this->ptr_timer;
    
    if( timer == NULL ) {
        throw new runtime_exception("t[^C}[\z̃AvP[VfoCXs܂.");
    }
    
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    FrameTimer::time_t currtime = timer->get_history( 1 );
    FrameTimer::time_t nexttime;
    
    while( !term() ) {
        this->on_each_loop_beginning();
        this->obj_gears.broadcast( currtime );
        if( gdev != NULL ) {
            gdev->broadcast();
        }
        nexttime = timer->wait_frame();
        if( gdev != NULL ) {
            gdev->update_screen();
        }
        if( this->num_fps_logging_interval > 0 ) {
            if( FrameTimer::get_time_distance(currtime, nexttime) > this->num_fps_logging_interval ) {
                if( log_is_info() ) {
                    log_info("FPS: %.2f", timer->count_fps());
                }
            }
        }
        currtime = nexttime;
    }
}

void BK::ApplicationDevice::add_gear ( BK::Gear & gear )
{
    this->obj_gears.add_gear( gear );
}

BK::Gear * BK::ApplicationDevice::erase_gear ( BK::Gear * gear )
{
    return obj_gears.erase_gear( gear );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_ApplicationDevice ( void )
{
    {
        ApplicationDevice * const dev = create_ApplicationDevice();
        if( dev == NULL ) {
            throw new logic_exception("AvP[VfoCX̐Ɏs܂.");
        }
    }
    
    RubyApplicationDevice::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_ApplicationDevice ( void )
{
    {
        ApplicationDevice * const dev = ApplicationDevice::get_instance();
        if( dev->is_started() ) {
            dev->stop();
        }
        delete dev;
    }
}

//////////////////////////////////////////////////////////////////////
