#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::Character
//
namespace {
extern "C" {

/// XNvg̐ݒ
VALUE Character_add_script ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    Character * const ptr = Character::value_to_data( self );
    int i;
    
    for( i = 0; i < argc; ++i ) {
        VALUE scrobj = argv[i];
        
        if( !CharacterScript::is_kind_of(scrobj) ) {
            rb_raise(rb_eArgError, "LN^[XNvg CharacterScript ȊO (%s) ͐ݒł܂.", rb_obj_classname(scrobj));
        }
        try {
            CharacterScript * const script = CharacterScript::value_to_data(scrobj);
            CharacterScript::Agent * const agent = script->create_agent();
            
            ptr->add_agent( agent );
        }
        catch ( exception_base * e ) {
            ruby_throw( e );
        }
    }
    
    return self;
}

/// LN^[̊Ԃ擾
VALUE Character_is_active ( VALUE self )
{
    BK::Character * const ptr = BK::Character::value_to_data( self );
    
    return BK::OnOffObject_is_active( ptr );
}

/// LN^[Ԃɐݒ肷
VALUE Character_activate ( VALUE self )
{
    BK::Character * const ptr = BK::Character::value_to_data( self );
    
    BK::OnOffObject_activate( ptr );
    
    return self;
}

/// LN^[񊈐Ԃɐݒ肷
VALUE Character_deactivate ( VALUE self )
{
    BK::Character * const ptr = BK::Character::value_to_data( self );
    
    BK::OnOffObject_deactivate( ptr );
    
    return self;
}

/// LN^[~Ԃɐݒ肷
VALUE Character_terminate ( VALUE self )
{
    BK::Character * const ptr = BK::Character::value_to_data( self );
    
    BK::OnOffObject_terminate( ptr );
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Character
//

VALUE BK::Character::ruby_class_object = Qnil;

BK::Character::Character ( void )
        : OnOffObject         (STAT_ACTIVE),
          ary_agent           (ary_agent_builtin),
          num_agent           (0),
          num_agent_capacity  (CHARACTER_AGENT_MAX)
{
}

BK::Character::~Character ()
{
    if( ary_agent != ary_agent_builtin ) {
        delete[] ary_agent;
    }
}

VALUE BK::Character::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Character", BK::RubyObject::get_ruby_class() );
    
    xrb_define_narg_method( c, "add_script", Character_add_script );
    xrb_define_narg_method( c, "<<", Character_add_script );
    xrb_define_0arg_method( c, "active?", Character_is_active );
    xrb_define_0arg_method( c, "activate", Character_activate );
    xrb_define_0arg_method( c, "deactivate", Character_deactivate );
    xrb_define_0arg_method( c, "terminate", Character_terminate );
    
    return ruby_class_object;
}

void BK::Character::ruby_gc_mark ( void )
{
    RubyObject::ruby_gc_mark();
    
    // 擪 num_script ͔ NULL l܂ĂƂO
    unsigned int i;
    for( i = 0; i < num_agent; ++i ) {
        ary_agent[i]->get_script()->gc_mark_self();
    }
}

void BK::Character::add_agent ( BK::Character::agent_t * agent )
{
    if( num_agent >= num_agent_capacity ) {
        unsigned int newcap = num_agent_capacity * 2;
        agent_t * * newbuf;
        
        newbuf = new agent_t * [ newcap ];
        memcpy( newbuf, ary_agent, sizeof(agent_t *) * num_agent_capacity );
        if( ary_agent != ary_agent_builtin ) {
            delete[] ary_agent;
        }
        ary_agent = newbuf;
        num_agent_capacity = newcap;
    }
    ary_agent[ num_agent++ ] = agent;
}

void BK::Character::execute ( void )
{
    unsigned int i = 0;
    
    while( i < num_agent ) {
        agent_t * const agent = ary_agent[i];
        
        if( agent->is_terminated() ) {
            --num_agent;
            if( i < num_agent ) {
                ary_agent[i] = ary_agent[num_agent];
            }
        } else {
            if( agent->is_active() ) {
                agent->execute();
            }
            ++i;
        }
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_character_Character ( void )
{
    Character::get_ruby_class();
    
    Init_application_character_SpriteCharacter();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_character_Character ( void )
{
    Exit_application_character_SpriteCharacter();
}

//////////////////////////////////////////////////////////////////////
