#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FadeInGear
//
namespace {
extern "C" {

/// MA̐
VALUE FadeInGear_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    FadeInGear * ptr;
    
    try {
        ptr = new FadeInGear();
        if( ptr == NULL ) {
            throw_no_memory_for_object("FadeInGear");
        }
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, argc, argv );
    
    try {
        ApplicationDevice::global_add_gear( *ptr );
        if( log_is_trace() ) {
            log_trace("tF[hCMA <%p:%s> 𐶐܂.", ptr, typeid(*ptr).name());
        }
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// MȀ
VALUE FadeInGear_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FadeInGear
//

VALUE BK::FadeInGear::ruby_class_object = Qnil;

BK::FadeInGear::FadeInGear ( void )
{
}

BK::FadeInGear::~FadeInGear ()
{
}

VALUE BK::FadeInGear::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "FadeInGear", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", FadeInGear_new );
    
    xrb_define_narg_method( c, "initialize", FadeInGear_initialize );
    
    return ruby_class_object;
}

void BK::FadeInGear::execute ( void )
{
    const FrameTimer::time_t total = get_length();
    const FrameTimer::time_t current = total - get_clipped_active_time();
    AlphaColor c = get_fill_color();
    
    c.set_alpha( static_cast< AlphaColor::element_t >( current * COLOR_ELEMENT_MAX / total ) );
    set_fill_color( c );
    
    parent_t::execute();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_gear_FadeInGear ( void )
{
    BK::FadeInGear::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_gear_FadeInGear ( void )
{
}

//////////////////////////////////////////////////////////////////////
