#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FadeOutGear
//
namespace {
extern "C" {

/// MA̐
VALUE FadeOutGear_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    FadeOutGear * ptr;
    
    try {
        ptr = new FadeOutGear();
        if( ptr == NULL ) {
            throw_no_memory_for_object("FadeOutGear");
        }
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, argc, argv );
    
    try {
        ApplicationDevice::global_add_gear( *ptr );
        if( log_is_trace() ) {
            log_trace("tF[hAEgMA <%p:%s> 𐶐܂.", ptr, typeid(*ptr).name());
        }
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// MȀ
VALUE FadeOutGear_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FadeOutGear
//

VALUE BK::FadeOutGear::ruby_class_object = Qnil;

BK::FadeOutGear::FadeOutGear ( void )
{
}

BK::FadeOutGear::~FadeOutGear ()
{
}

VALUE BK::FadeOutGear::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "FadeOutGear", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", FadeOutGear_new );
    
    xrb_define_narg_method( c, "initialize", FadeOutGear_initialize );
    
    return ruby_class_object;
}

void BK::FadeOutGear::execute ( void )
{
    const FrameTimer::time_t total = get_length();
    const FrameTimer::time_t current = get_clipped_active_time();
    AlphaColor c = get_fill_color();
    
    c.set_alpha( static_cast< AlphaColor::element_t >( current * COLOR_ELEMENT_MAX / total ) );
    set_fill_color( c );
    
    parent_t::execute();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_gear_FadeOutGear ( void )
{
    BK::FadeOutGear::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_gear_FadeOutGear ( void )
{
}

//////////////////////////////////////////////////////////////////////
