#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {

const unsigned int INITIAL_HISTORY_LENGTH = 128;

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FrameTimer
//

BK::FrameTimer::FrameTimer ( unsigned int fps, BK::FrameTimer::time_t curr )
        : num_fps             (fps),
          ary_history         (new time_t [INITIAL_HISTORY_LENGTH]),
          num_history_length  (INITIAL_HISTORY_LENGTH),
          num_history_index   (0)
{
    unsigned int i;
    
    for( i = 0; i < num_history_length; ++i ) {
        this->ary_history[i] = curr;
    }
}

BK::FrameTimer::~FrameTimer ()
{
}

void BK::FrameTimer::set_history_length ( unsigned int len )
{
    throw new unsupported_exception("FrameTimer::set_history_length() ͖T|[gł.");
}

BK::FrameTimer::time_t BK::FrameTimer::get_history ( unsigned int n ) const
{
    if( n == 0 || n > num_history_length ) {
        throw new out_of_range_exception("t[͈̔͊O (1..%u) ̒l (%u) w肳܂.", num_history_length, n);
    }
    
    if( n <= num_history_index ) {
        return ary_history[ num_history_index - n ];
    } else {
        return ary_history[ num_history_length - (n - num_history_index) ];
    }
}

double BK::FrameTimer::count_fps ( void ) const
{
    unsigned int index = this->num_history_index;
    
    const time_t oldest = this->ary_history[index];
    
    if( index == 0 ) {
        index = this->num_history_length;
    } else {
        index -= 1;
    }
    
    const time_t newest = this->ary_history[index];
    
    if( oldest == newest ) {
        return 0.0;
    }
    
    const time_t diff = (oldest < newest) ? newest - oldest: newest + (std::numeric_limits<time_t>::max() - oldest);
    
    return static_cast<double>(num_history_length * 1000) / diff;
}

BK::FrameTimer::time_t BK::FrameTimer::wait_frame ( void )
{
    const time_t t = on_wait_frame();
    
    unsigned int index = this->num_history_index;
    
    this->ary_history[ index++ ] = t;
    
    if( index >= this->num_history_length ) {
        index = 0;
    }
    this->num_history_index = index;
    
    return t;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_FrameTimer ( void )
{
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_FrameTimer ( void )
{
}

//////////////////////////////////////////////////////////////////////
