#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: ScriptSequence
//
namespace {
extern "C" {

/// XNvgV[PX̐
VALUE ScriptSequence_new ( VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    ScriptSequence * ptr;
    
    try {
        ptr = new ScriptSequence ();
        if( ptr == NULL ) {
            throw_no_memory_for_object("ScriptSequence");
        }
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, 0, NULL );
    
    return obj;
}

/// XNvgV[PX̏
VALUE ScriptSequence_initialize ( VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::ScriptSequence::Agent
//

BK::ScriptSequence::Agent::Agent ( ScriptSequence & script )
        : agent_parent_t      (script),
          ptr_script          (&script),
          num_current_index   (0),
          ptr_current_script  (NULL),
          ptr_current_agent   (NULL)
{
}

BK::ScriptSequence::Agent::~Agent ()
{
}

//bool BK::ScriptSequence::Agent::connect_character ( BK::Character * chr )
//{
//    // ڑ`FbN͊eXNvgɐڑƂs
//    return agent_parent_t::connect_character( chr );
//}

void BK::ScriptSequence::Agent::execute ( void )
{
    ScriptSequence * const script = this->ptr_script;
    
    if( this->ptr_current_script == NULL ) {
        this->ptr_current_script = script->at( this->num_current_index );
        if( this->ptr_current_script == NULL ) {
            terminate();
            return;
        }
    }
    
    CharacterScript::Agent * agent = this->ptr_current_agent;
    
    if( agent == NULL ) {
        agent = this->ptr_current_script->create_agent();
        if( !agent->connect_character(get_character()) ) {
            delete agent;
            throw new runtime_exception(
                "G[WFg <%s> ɃLN^[ <%s> o^ł܂.",
                typeid(*agent).name(), typeid(*get_character()).name());
        }
        this->ptr_current_agent = agent;
    }
    
    if( agent->is_active() ) {
        agent->execute();
    }
    
    if( agent->is_terminated() ) {
        delete agent;
        this->ptr_current_agent = NULL;
        this->ptr_current_script = script->at( ++(this->num_current_index) );
        if( this->ptr_current_script == NULL ) {
            terminate();
            return;
        }
    }
}

//////////////////////////////////////////////////////////////////////
////  BK::ScriptSequence
//

VALUE BK::ScriptSequence::ruby_class_object = Qnil;

BK::ScriptSequence::ScriptSequence ( void )
{
}

BK::ScriptSequence::~ScriptSequence ()
{
}

VALUE BK::ScriptSequence::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "ScriptSequence", parent_t::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "new", ScriptSequence_new );
    
    xrb_define_0arg_method( c, "initialize", ScriptSequence_initialize );
    
    return ruby_class_object;
}

void BK::ScriptSequence::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    std::for_each( this->ary_script.begin(), this->ary_script.end(), RubyObjectMarker() );
}

void BK::ScriptSequence::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    std::for_each( this->ary_script.begin(), this->ary_script.end(), RubyObjectWrapper() );
}

BK::CharacterScript::Agent * BK::ScriptSequence::create_agent ( void )
{
    return new Agent( *this );
}

void BK::ScriptSequence::add ( BK::CharacterScript * script )
{
    if( script == NULL ) {
        throw new argument_exception("XNvgV[PX NULL ǉ܂.");
    }
    this->ary_script.push_back( script );
}

void BK::ScriptSequence::erase ( BK::CharacterScript * script )
{
    if( script == NULL ) {
        throw new argument_exception("XNvgV[PX NULL 폜悤Ƃ܂.");
    }
    list_t::iterator const i = std::find( this->ary_script.begin(), this->ary_script.end(), script );
    
    if( i == this->ary_script.end() ) {
        throw new argument_exception(
            "XNvgV[PXɑ݂ȂXNvg <%s> ̍폜s܂.",
            typeid(*script).name());
    }
    this->ary_script.erase( i );
}

BK::CharacterScript * BK::ScriptSequence::at ( unsigned int n )
{
    if( n >= this->ary_script.size() ) {
        return NULL;
    }
    return this->ary_script[ n ];
}

unsigned int BK::ScriptSequence::size ( void ) const
{
    return static_cast< unsigned int >( this->ary_script.size() );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_character_ScriptSequence ( void )
{
    ScriptSequence::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_character_ScriptSequence ( void )
{
}

//////////////////////////////////////////////////////////////////////
