#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::TimerGear
//
namespace {
extern "C" {

/// VMAIuWFNg𐶐
VALUE TimerGear_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    TimerGear * ptr;
    
    try {
        Ruby::ArgScanner scanner("TimerGear.new", argc, argv);
        FrameTimer::time_t len;
        
        if( scanner.is_empty() ) {
            len = 0;
        } else {
            len = NUM2ULONG(scanner.fetch_value("ҋ@"));
        }
        scanner.finish();
        
        ptr = new TimerGear();
        if( ptr == NULL ) {
            throw_no_memory_for_object("TimerGear");
        }
        ptr->set_length( len );
        
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, argc, argv );
    
    try {
        ApplicationDevice::global_add_gear( *ptr );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// MȀ
VALUE TimerGear_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// ҋ@t[ݒ肷
VALUE TimerGear_set_length ( VALUE self, VALUE numobj )
{
    using namespace BK;
    rb_check_frozen( self );
    
    TimerGear * const ptr = TimerGear::value_to_data( self );
    
    try {
        ptr->set_length( NUM2ULONG( numobj ) );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return numobj;
}

/// ҋ@t[擾
VALUE TimerGear_get_length ( VALUE self )
{
    using namespace BK;
    TimerGear * const ptr = TimerGear::value_to_data( self );
    
    return ULONG2NUM(ptr->get_length());
}

/// ݂̃t[JEgZbg
VALUE TimerGear_rewind ( VALUE self )
{
    using namespace BK;
    rb_check_frozen( self );
    
    TimerGear * const ptr = TimerGear::value_to_data( self );
    
    try {
        ptr->set_active_time( 0 );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

/// ݂̃t[JEgŏIlɐݒ肷
VALUE TimerGear_close ( VALUE self )
{
    using namespace BK;
    rb_check_frozen( self );
    
    TimerGear * const ptr = TimerGear::value_to_data( self );
    
    try {
        ptr->set_active_time( ptr->get_length() );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::TimerGear
//

VALUE BK::TimerGear::ruby_class_object = Qnil;

BK::TimerGear::TimerGear ( void )
        : num_length (0)
{
}

BK::TimerGear::~TimerGear ()
{
}

VALUE BK::TimerGear::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "TimerGear", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", TimerGear_new );
    
    xrb_define_narg_method( c, "initialize", TimerGear_initialize );
    xrb_define_0arg_method( c, "close", TimerGear_close );
    xrb_define_0arg_method( c, "rewind", TimerGear_rewind );
    xrb_define_0arg_method( c, "length", TimerGear_get_length );
    xrb_define_1arg_method( c, "length=", TimerGear_set_length );
    
    return ruby_class_object;
}

void BK::TimerGear::set_length ( BK::FrameTimer::time_t n )
{
    num_length = n;
    if( log_is_trace() ) {
        log_trace("TimerGear <%p> ̑ҋ@Ԃ %u ~bɐݒ肳܂.", this, n);
    }
}

void BK::TimerGear::execute ( void )
{
    if( get_active_time() >= get_length() ) {
        if( log_is_trace() ) {
            log_trace("TimerGear <%p> ̑ҋ@܂.", this);
        }
        terminate();
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_gear_TimerGear ( void )
{
    TimerGear::get_ruby_class();
    
    Init_application_gear_FillScreenGear();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_gear_TimerGear ( void )
{
    Exit_application_gear_FillScreenGear();
}

//////////////////////////////////////////////////////////////////////
