#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

class value_int_converter_t
{
public:
    
    /// ϊ
    int operator () ( VALUE v ) const
    {
        return BK::value_to_int( v );
    }
    
};

class value_double_converter_t
{
public:
    
    /// ϊ
    double operator () ( VALUE v ) const
    {
        return BK::value_to_double( v );
    }
    
};

class value_converter_t
{
private:
    
    /// IuWFNg
    const char * const ptr_name;
    
    /// vf̃Xg
    const char * ptr_element_names [ 8 ];
    
    /// vf
    unsigned int num_count;
    
public:
    
    /// RXgN^
    value_converter_t ( const char * name, ... )
            : ptr_name (name)
    {
        va_list arg;
        
        va_start( arg, name );
        num_count = 0;
        while( (ptr_element_names[num_count] = va_arg(arg, const char *)) != NULL ) {
            ++num_count;
        }
        va_end( arg );
    }
    
    /// ϊ
    template < typename element_t, typename converter_t >
    void execute ( element_t * buf, VALUE * val, converter_t & converter ) const
    {
        for( unsigned int i = 0; i < num_count; ++i ) {
            VALUE const v = val[i];
            try {
                buf[i] = converter(v);
            } catch ( BK::exception_base * e ) {
                BK::argument_exception * ne = new BK::argument_exception(
                    "%s%s %s ͓Kpł܂. (%s)",
                    ptr_name, ptr_element_names[i], rb_obj_classname(v), e->what());
                delete e;
                throw ne;
            }
        }
    }
    
};

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Ruby::ArgScanner
//

BK::Ruby::ArgScanner::ArgScanner ( const char * target, int argc, VALUE * argv )
        : str_target       (target),
          num_arg          (argc),
          num_initial_arg  (argc),
          ptr_arg          (argv)
{
}

BK::Ruby::ArgScanner::~ArgScanner ()
{
}

void BK::Ruby::ArgScanner::finish ( void )
{
    if( num_arg > 0 ) {
        throw new argument_exception(
            "%s ɓnꂽp[^ (%d ) sł.", str_target, num_initial_arg);
    }
}

VALUE BK::Ruby::ArgScanner::current ( void ) const
{
    if( num_arg <= 0 ) {
        throw new argument_exception(
            "%s ɓnꂽp[^ (%d ) sł.", str_target, num_initial_arg);
    }
    return ptr_arg[0];
}

VALUE BK::Ruby::ArgScanner::fetch_value ( const char * name )
{
    VALUE ret;
    
    if( is_empty() ) {
        if( name == NULL ) {
            throw new argument_exception(
                "%s ɓnꂽp[^ (%d ) sł.", str_target, num_initial_arg);
        } else {
            throw new argument_exception("%sw肳Ă܂.", name);
        }
    }
    ret = *ptr_arg;
    --num_arg;
    ++ptr_arg;
    return ret;
}

BK::Color BK::Ruby::ArgScanner::fetch_Color ( const char * name )
{
    VALUE val [3];
    VALUE v;
    
    if( name == NULL ) {
        name = "Ff[^";
    }
    
    // 1 
    if( is_empty() ) {
        throw new argument_exception("%s̍\zɃp[^w肳Ă܂.", name);
    }
    v = fetch_value();
    
    if( Color::is_kind_of(v) ) {
        return *Color::value_to_data(v);
    }
    
    if( TYPE(v) == T_STRING ) {
        {
            const char * str = StringValuePtr(v);
            return str_to_Color(str);
        }
    }
    
    if( TYPE(v) == T_ARRAY ) {
        if( xrb_ary_length(v) != 3 ) {
            throw new argument_exception(
                "%s̍\zɂ͒ 3  Array Kvł. (: %d)", name, xrb_ary_length(v));
        }
        val[0] = xrb_ary_at(v, 0);
        val[1] = xrb_ary_at(v, 1);
        val[2] = xrb_ary_at(v, 2);
    }
    else {
        val[0] = v;
        
        if( is_empty() ) {
            throw new argument_exception("%s̍\zɗΗvfw肳Ă܂.", name);
        }
        val[1] = fetch_value();
        
        if( is_empty() ) {
            throw new argument_exception("%s̍\zɐvfw肳Ă܂.", name);
        }
        val[2] = fetch_value();
    }
    
    static const value_converter_t converter (name, "ԗvf", "Ηvf", "vf", NULL);
    Color::element_t num [3];
    
    converter.execute( num, val, value_int_converter_t() );
    
    return Color( num[0], num[1], num[2] );
}

BK::AlphaColor BK::Ruby::ArgScanner::fetch_AlphaColor ( const char * name )
{
    VALUE val [4];
    VALUE v;
    
    if( name == NULL ) {
        name = "xtFf[^";
    }
    
    // 1 
    if( is_empty() ) {
        throw new argument_exception("%s̍\zɃp[^w肳Ă܂.", name);
    }
    v = fetch_value();
    
    if( AlphaColor::is_kind_of(v) ) {
        return *AlphaColor::value_to_data(v);
    }
    if( Color::is_kind_of(v) ) {
        return AlphaColor( *Color::value_to_data(v) );
    }
    
    if( TYPE(v) == T_STRING ) {
        {
            const char * str = StringValuePtr(v);
            return str_to_AlphaColor(str);
        }
    }
    
    if( TYPE(v) == T_ARRAY ) {
        if( xrb_ary_length(v) != 3 && xrb_ary_length(v) != 4 ) {
            throw new argument_exception(
                "%s̍\zɂ͒ 3 ܂ 4  Array Kvł. (: %d)", name, xrb_ary_length(v));
        }
        val[0] = xrb_ary_at(v, 0);
        val[1] = xrb_ary_at(v, 1);
        val[2] = xrb_ary_at(v, 2);
        if( xrb_ary_length(v) == 4 ) {
            val[3] = xrb_ary_at(v, 3);
        } else {
            val[3] = rb_fix_new(COLOR_ELEMENT_MAX);
        }
    }
    else {
        val[0] = v;
        
        if( is_empty() ) {
            throw new argument_exception("%s̍\zɗΗvfw肳Ă܂.", name);
        }
        val[1] = fetch_value();
        
        if( is_empty() ) {
            throw new argument_exception("%s̍\zɐvfw肳Ă܂.", name);
        }
        val[2] = fetch_value();
        
        if( is_empty() ) {
            //throw new argument_exception("%s̍\zɓxvfw肳Ă܂.", name);
            // x͏ȗł悤
            val[3] = rb_fix_new(COLOR_ELEMENT_MAX);
        } else {
            val[3] = fetch_value();
        }
    }
    
    static const value_converter_t converter (name, "ԗvf", "Ηvf", "vf", "xvf", NULL);
    Color::element_t num [4];
    
    converter.execute( num, val, value_int_converter_t() );
    
    return AlphaColor( num[0], num[1], num[2], num[3] );
}

BK::Size2 BK::Ruby::ArgScanner::fetch_Size2 ( const char * name )
{
    VALUE val [2];
    VALUE v;
    
    if( name == NULL ) {
        name = "TCY";
    }
    
    // 1 
    if( is_empty() ) {
        throw new argument_exception("%s̍\zɃp[^w肳Ă܂.", name);
    }
    v = fetch_value();
    
    if( Size2::is_kind_of(v) ) {
        return *Size2::value_to_data(v);
    }
    if( Rect2::is_kind_of(v) ) {
        return Rect2::value_to_data(v)->get_size();
    }
    
    if( TYPE(v) == T_ARRAY ) {
        if( xrb_ary_length(v) != 2 ) {
            throw new argument_exception("%s̍\zɂ͒ 2  Array Kvł. (: %d)",
                                         name, xrb_ary_length(v));
        }
        val[0] = xrb_ary_at(v, 0);
        val[1] = xrb_ary_at(v, 1);
    }
    else {
        val[0] = v;
        
        if( is_empty() ) {
            throw new argument_exception("%s̍\zɏcw肳Ă܂.", name);
        }
        val[1] = fetch_value();
    }
    
    static const value_converter_t converter (name, "", "c", NULL);
    Size2::num_t num [2];
    
    converter.execute( num, val, value_int_converter_t() );
    
    return Size2( num[0], num[1] );
}

BK::Point2 BK::Ruby::ArgScanner::fetch_Point2 ( const char * name )
{
    VALUE val [2];
    VALUE v;
    
    if( name == NULL ) {
        name = "W";
    }
    
    // 1 
    if( is_empty() ) {
        throw new argument_exception("%s̍\zɃp[^w肳Ă܂.", name);
    }
    v = fetch_value();
    
    if( Point2::is_kind_of(v) ) {
        return *Point2::value_to_data(v);
    }
    
    if( TYPE(v) == T_ARRAY ) {
        if( xrb_ary_length(v) != 2 ) {
            throw new argument_exception(
                "%s̍\zɂ͒ 2  Array Kvł. (: %d)", name, xrb_ary_length(v));
        }
        val[0] = xrb_ary_at(v, 0);
        val[1] = xrb_ary_at(v, 1);
    }
    else {
        val[0] = v;
        
        if( is_empty() ) {
            throw new argument_exception("%s̍\z YWw肳Ă܂.", name);
        }
        val[1] = fetch_value();
    }
    
    static const value_converter_t converter (name, " XW", " YW", NULL);
    Point2::num_t num [2];
    
    converter.execute( num, val, value_int_converter_t() );
    
    return Point2( num[0], num[1] );
}

BK::Rect2 BK::Ruby::ArgScanner::fetch_Rect2 ( const char * name )
{
    VALUE val [4];
    VALUE v;
    int count = 0;
    
    if( name == NULL ) {
        name = "`";
    }
    
    // 1 
    if( is_empty() ) {
        throw new argument_exception("%s̍\zɃp[^w肳Ă܂.", name);
    }
    v = fetch_value();
    
    if( Rect2::is_kind_of(v) ) {
        return *Rect2::value_to_data(v);
    }
    
    if( Size2::is_kind_of(v) ) {
        Size2 const * size = Size2::value_to_data(v);
        return Rect2( *size );
    }
    
    if( TYPE(v) == T_ARRAY ) {
        if( xrb_ary_length(v) == 2 ) {
            val[0] = xrb_ary_at(v, 0);
            val[1] = xrb_ary_at(v, 1);
            count = 2;
        }
        else {
            if( xrb_ary_length(v) != 4 ) {
                throw new argument_exception(
                    "%s̍\zɂ͒ 4  Array Kvł. (: %d)", name, xrb_ary_length(v));
            }
            val[0] = xrb_ary_at(v, 0);
            val[1] = xrb_ary_at(v, 1);
            val[2] = xrb_ary_at(v, 2);
            val[3] = xrb_ary_at(v, 3);
            count = 4;
        }
    }
    else {
        if( Point2::is_kind_of(v) ) {
            val[0] = v;
            if( is_empty() ) {
                throw new argument_exception("%s̍\zɏI_w肳Ă܂.", name);
            }
            val[1] = fetch_value();
            
            count = 2;
        }
        else {
            val[0] = v;
            
            if( is_empty() ) {
                throw new argument_exception("%s̍\zɏ[ʒuw肳Ă܂.", name);
            }
            val[1] = fetch_value();
            
            if( is_empty() ) {
                throw new argument_exception("%s̍\zɉE[ʒuw肳Ă܂.", name);
            }
            val[2] = fetch_value();
            
            if( is_empty() ) {
                throw new argument_exception("%s̍\zɉ[ʒuw肳Ă܂.", name);
            }
            val[3] = fetch_value();
            
            count = 4;
        }
    }
    
    if( count == 2 ) {
        {
            v = val[0];
            
            Point2 const * point = Point2::value_to_data(v);
            
            v = val[1];
            
            if( Point2::is_kind_of(v) ) {
                Point2 const * endpoint = Point2::value_to_data(v);
                return Rect2( *point, *endpoint );
            }
            if( Size2::is_kind_of(v) ) {
                Size2 const * size = Size2::value_to_data(v);
                return Rect2( *point, *size );
            }
            throw new argument_exception("%s̍\zŏI_ %s ͎wł܂.", name, rb_obj_classname(v));
        }
    }
    
    static const value_converter_t converter (name, "[", "[", "E[", "[", NULL);
    Rect2::num_t num [4];
    
    converter.execute( num, val, value_int_converter_t() );
    
    return Rect2( num[0], num[1], num[2], num[3] );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_ArgScanner ( void )
{
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_ArgScanner ( void )
{
}

//////////////////////////////////////////////////////////////////////
