#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::AspectRect2
//
namespace {
extern "C" {

/// IuWFNg̉ (QƔ)
void AspectRect2_ref_free ( BK::AspectRect2 * ptr )
{
}

/// IuWFNg̉
void AspectRect2_free ( BK::AspectRect2 * ptr )
{
    delete ptr;
}

/// AspectRect2 𐶐
VALUE AspectRect2_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj;
    AspectRect2 * ptr;
    
    try {
        switch( argc ) {
        case 1:
            {
                AspectRect2 const * const src = AspectRect2::value_to_data(argv[0]);
                
                ptr = new AspectRect2 ( *src );
            }
            break;
            
        case 2:
            {
                if( !Rect2::is_kind_of(argv[0]) ) {
                    rb_raise(rb_eArgError, "` Rect2 ȊO (%s) ͎ws.",
                             rb_obj_classname(argv[0]));
                }
                Rect2 const * const r = Rect2::value_to_data(argv[0]);
                
                if( !Size2::is_kind_of(argv[1]) ) {
                    rb_raise(rb_eArgError, "̈TCY Size2 ȊO (%s) ͎ws.",
                             rb_obj_classname(argv[1]));
                }
                Size2 const * const s = Size2::value_to_data(argv[1]);
                
                ptr = new AspectRect2 ( *r, *s );
            }
            break;
            
        case 4:
            {
                ptr = new AspectRect2 (
                    static_cast< AspectRect2::num_t >( NUM2DBL(argv[0]) ),
                    static_cast< AspectRect2::num_t >( NUM2DBL(argv[1]) ),
                    static_cast< AspectRect2::num_t >( NUM2DBL(argv[2]) ),
                    static_cast< AspectRect2::num_t >( NUM2DBL(argv[3]) ) );
            }
            break;
            
        default:
            rb_raise(rb_eArgError, "AspectRect.new() ɓnꂽ̐ (%d ) sł.", argc);
            return Qnil; // dummy
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    // AspectRect2  RubyObject pĂȂ̂ ruby_wrap() gȂ
    obj = Data_Wrap_Struct( klass, NULL, AspectRect2_free, ptr );
    
    rb_obj_call_init( obj, argc, argv );
    
    return obj;
}

/// 
VALUE AspectRect2_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE AspectRect2_initialize_copy ( VALUE self, VALUE obj )
{
    using namespace BK;
    
    if( !AspectRect2::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  AspectRect2 ɃRs[ł܂.", rb_obj_classname(obj));
    }
    const AspectRect2 * const src = AspectRect2::value_to_data( obj );
    
    if( !AspectRect2::is_kind_of(self) ) {
        rb_raise(rb_eTypeError, "%s  AspectRect2.initialize_copy Kp܂.", rb_obj_classname(self));
    }
    xrb_update_Data( self, NULL, AspectRect2_free, new AspectRect2( *src ) );
    
    return self;
}

/// `̍[ʒu擾
VALUE AspectRect2_get_left ( VALUE self )
{
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    return rb_float_new( rect->get_left() );
}

/// `̉E[ʒu擾
VALUE AspectRect2_get_right ( VALUE self )
{
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    return rb_float_new( rect->get_right() );
}

/// `̏[ʒu擾
VALUE AspectRect2_get_top ( VALUE self )
{
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    return rb_float_new( rect->get_top() );
}

/// `̉[ʒu擾
VALUE AspectRect2_get_bottom ( VALUE self )
{
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    return rb_float_new( rect->get_bottom() );
}

/// `̍[ʒuݒ肷
VALUE AspectRect2_set_left ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    rect->set_left( static_cast< BK::AspectRect2::num_t >( NUM2DBL( numobj ) ) );
    
    return numobj;
}

/// `̉E[ʒuݒ肷
VALUE AspectRect2_set_right ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    rect->set_right( static_cast< BK::AspectRect2::num_t >( NUM2DBL( numobj ) ) );
    
    return numobj;
}

/// `̏[ʒuݒ肷
VALUE AspectRect2_set_top ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    rect->set_top( static_cast< BK::AspectRect2::num_t >( NUM2DBL( numobj ) ) );
    
    return numobj;
}

/// `̉[ʒuݒ肷
VALUE AspectRect2_set_bottom ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    
    rect->set_bottom( static_cast< BK::AspectRect2::num_t >( NUM2DBL( numobj ) ) );
    
    return numobj;
}

/// `𕶎ɕϊ
VALUE AspectRect2_to_s ( VALUE self )
{
    BK::AspectRect2 * rect = BK::AspectRect2::value_to_data( self );
    char buf [256];
    int len;
    
    len = rect->get_string( buf, 64 );
    
    return rb_str_new(buf, len);
}

/// `IuWFNg̔r
VALUE AspectRect2_p_eql ( VALUE self, VALUE obj )
{
    BK::AspectRect2 * r = BK::AspectRect2::value_to_data( self );
    
    if( !BK::AspectRect2::is_kind_of(obj) ) {
        return Qfalse;
    }
    BK::AspectRect2 * rhs = BK::AspectRect2::value_to_data( obj );
    
    return (*r == *rhs) ? Qtrue : Qfalse;
}

/// `IuWFNg̃nbVl擾
VALUE AspectRect2_get_hash ( VALUE self )
{
    BK::AspectRect2 * r = BK::AspectRect2::value_to_data( self );
    
    // TODO: ǂČ߂H
    return rb_fix_new( 0 );
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::AspectRect2
//

VALUE BK::AspectRect2::ruby_class_object = Qnil;

VALUE BK::AspectRect2::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "AspectRect2", rb_cData );
    
    xrb_define_narg_singleton_method( c, "new", AspectRect2_new );
    
    xrb_define_narg_method( c, "initialize", AspectRect2_initialize );
    xrb_define_1arg_method( c, "initialize_copy", AspectRect2_initialize_copy );
    xrb_define_0arg_method( c, "left", AspectRect2_get_left );
    xrb_define_0arg_method( c, "right", AspectRect2_get_right );
    xrb_define_0arg_method( c, "top", AspectRect2_get_top );
    xrb_define_0arg_method( c, "bottom", AspectRect2_get_bottom );
    xrb_define_1arg_method( c, "left=", AspectRect2_set_left );
    xrb_define_1arg_method( c, "right=", AspectRect2_set_right );
    xrb_define_1arg_method( c, "top=", AspectRect2_set_top );
    xrb_define_1arg_method( c, "bottom=", AspectRect2_set_bottom );
    xrb_define_0arg_method( c, "to_s", AspectRect2_to_s );
    xrb_define_1arg_method( c, "==", AspectRect2_p_eql );
    xrb_define_1arg_method( c, "eql?", AspectRect2_p_eql );
    xrb_define_0arg_method( c, "hash", AspectRect2_get_hash );
    
    xrb_define_narg_global_function( "AspectRect2", AspectRect2_new );
    
    return ruby_class_object;
}

std::string BK::AspectRect2::to_string ( void ) const
{
    char buf [256];
    
    get_string( buf, 256 );
    
    return std::string( buf );
}

int BK::AspectRect2::get_string ( char * buf, unsigned int cap ) const
{
    if( buf != NULL ) {
        return snprintf( buf, cap, "(%f,%f)-(%f,%f)", get_left(), get_top(), get_right(), get_bottom() );
    }
    return 0;
}

VALUE BK::AspectRect2::create_ruby_reference ( void )
{
    return Data_Wrap_Struct( get_ruby_class(), NULL, AspectRect2_ref_free, this );
}

VALUE BK::AspectRect2::create_ruby_object ( void ) const
{
    AspectRect2 * dupobj = new AspectRect2( *this );
    
    return Data_Wrap_Struct( get_ruby_class(), NULL, AspectRect2_free, dupobj );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_AspectRect2 ( void )
{
    AspectRect2::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_AspectRect2 ( void )
{
}

//////////////////////////////////////////////////////////////////////
