#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::CharLayout
//
namespace {

/// IuWFNg̐
VALUE CharLayout_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    CharLayout * ptr;
    
    try {
        ptr = new CharLayout ();
        obj = ptr->ruby_wrap();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    rb_obj_call_init( obj, argc, argv );
    
    return obj;
}

/// IuWFNg̏
VALUE CharLayout_initialize ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    CharLayout * const ptr = CharLayout::value_to_data( self );
    
    try {
        Ruby::ArgScanner scanner("CharLayout#initialize", argc, argv);
        
        const Size2 size = scanner.fetch_Size2("CAEgTCY");
        
        scanner.finish();
        
        ptr->set_size( size );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::CharLayout
//

VALUE BK::CharLayout::ruby_class_object = Qnil;

BK::CharLayout::CharLayout ( void )
{
}

BK::CharLayout::~CharLayout ()
{
}

VALUE BK::CharLayout::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "CharLayout", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", CharLayout_new );
    
    xrb_define_narg_method( c, "initialize", CharLayout_initialize );
    
    return ruby_class_object;
}

char * BK::CharLayout::ruby_inspect ( char * buf, unsigned int cap ) const
{
    sprintf(buf, "<CharLayout:%s@%s>",
            get_size().to_string().c_str(),
            get_point().to_string().c_str() );
    
    return buf;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_CharLayout ( void )
{
    BK::CharLayout::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_CharLayout ( void )
{
}

//////////////////////////////////////////////////////////////////////
