#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Color
//
namespace {
extern "C" {

/// Color 
void Color_free ( BK::Color * ptr )
{
    using namespace BK;
    //log_trace("Ruby GC  Color ܂.");
    //Ȃ̏oĂ烍Oc
    delete ptr;
}

/// Color 쐬
VALUE Color_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    Color * ptr;
    Color color;
    
    try {
        Ruby::ArgScanner scanner("Color.new", argc, argv);
        
        color = scanner.fetch_Color();
        
        scanner.finish();
        
        ptr = new Color ( color );
        
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    // Color  RubyObject pĂȂ̂ ruby_wrap() gȂ
    obj = Data_Wrap_Struct( klass, NULL, Color_free, ptr );
    
    rb_obj_call_init( obj, argc, argv );
    
    return obj;
}

/// IuWFNg̏
VALUE Color_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE Color_initialize_copy ( VALUE self, VALUE obj )
{
    BK::Color * dest = BK::Color::value_to_data( self );
    
    if( !BK::Color::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  Color ɃRs[ł܂.", rb_obj_classname(obj));
    }
    
    BK::Color const * src = BK::Color::value_to_data( obj );
    
    *dest = *src;
    return self;
}

/// ԗvf擾
VALUE Color_get_red ( VALUE self )
{
    BK::Color const * color = BK::Color::value_to_data( self );
    
    return rb_fix_new(color->get_red());
}

/// Ηvf擾
VALUE Color_get_green ( VALUE self )
{
    BK::Color const * color = BK::Color::value_to_data( self );
    
    return rb_fix_new(color->get_green());
}

/// vf擾
VALUE Color_get_blue ( VALUE self )
{
    BK::Color const * color = BK::Color::value_to_data( self );
    
    return rb_fix_new(color->get_blue());
}

/// ԗvfݒ肷
VALUE Color_set_red ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Color * color = BK::Color::value_to_data( self );
    
    color->set_red( NUM2INT(numobj) );
    
    return numobj;
}

/// Ηvfݒ肷
VALUE Color_set_green ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Color * color = BK::Color::value_to_data( self );
    
    color->set_green( NUM2INT(numobj) );
    
    return numobj;
}

/// vfݒ肷
VALUE Color_set_blue ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Color * color = BK::Color::value_to_data( self );
    
    color->set_blue( NUM2INT(numobj) );
    
    return numobj;
}

/// J[f[^𕶎ɕϊ
VALUE Color_to_s ( VALUE self )
{
    BK::Color const * color = BK::Color::value_to_data( self );
    char buf [32];
    int len;
    
    len = color->get_string( buf, 32 );
    
    return rb_str_new(buf, len);
}

/// J[f[^̈vr
VALUE Color_p_eql ( VALUE self, VALUE obj )
{
    using namespace BK;
    Color * const color = Color::value_to_data( self );
    
    if( !xrb_is_kind_of(obj, Color::get_ruby_class()) ) {
        return Qfalse;
    }
    Color const * const rhs = Color::value_to_data( obj );
    
    return (*color == *rhs) ? Qtrue : Qfalse;
}

/// IuWFNg̃nbVl擾
VALUE Color_get_hash ( VALUE self )
{
    BK::Color const * color = BK::Color::value_to_data( self );
    
    return rb_fix_new((color->get_red()) ^ (color->get_green() << 8) ^ (color->get_blue() << 16));
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Color
//

VALUE BK::Color::ruby_class_object = Qnil;

VALUE BK::Color::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Color", rb_cData );
    
    xrb_define_narg_singleton_method( c, "new", Color_new );
    
    xrb_define_narg_method( c, "initialize", Color_initialize );
    xrb_define_1arg_method( c, "initialize_copy", Color_initialize_copy );
    xrb_define_0arg_method( c, "red", Color_get_red );
    xrb_define_0arg_method( c, "green", Color_get_green );
    xrb_define_0arg_method( c, "blue", Color_get_blue );
    xrb_define_1arg_method( c, "red=", Color_set_red );
    xrb_define_1arg_method( c, "green=", Color_set_green );
    xrb_define_1arg_method( c, "blue=", Color_set_blue );
    xrb_define_0arg_method( c, "to_s", Color_to_s );
    xrb_define_1arg_method( c, "==", Color_p_eql );
    xrb_define_1arg_method( c, "eql?", Color_p_eql );
    xrb_define_0arg_method( c, "hash", Color_get_hash );
    
    xrb_define_narg_global_function( "Color", Color_new );
    
    return ruby_class_object;
}

BK::Color::Color ( element_t r, element_t g, element_t b )
{
    set_red( r );
    set_green( g );
    set_blue( b );
}

void BK::Color::set_red ( BK::Color::element_t r )
{
    if( r > COLOR_ELEMENT_MAX ) {
        throw new argument_exception("Color Ɏw肳ꂽԗvf (%d) ͈͊Oł.", r);
    }
    num_red = r;
}

void BK::Color::set_blue ( BK::Color::element_t b )
{
    if( b > COLOR_ELEMENT_MAX ) {
        throw new argument_exception("Color Ɏw肳ꂽvf (%d) ͈͊Oł.", b);
    }
    num_blue = b;
}

void BK::Color::set_green ( BK::Color::element_t g )
{
    if( g > COLOR_ELEMENT_MAX ) {
        throw new argument_exception("Color Ɏw肳ꂽΗvf (%d) ͈͊Oł.", g);
    }
    num_green = g;
}

VALUE BK::Color::create_ruby_reference ( void )
{
    return Data_Wrap_Struct( Color::get_ruby_class(), NULL, Color_free, this );
}

VALUE BK::Color::create_ruby_object ( void ) const
{
    Color * dupobj = new Color( *this );
    
    return Data_Wrap_Struct( Color::get_ruby_class(), NULL, Color_free, dupobj );
}

std::string BK::Color::to_string ( void ) const
{
    char buf [32];
    
    get_string( buf, 32 );
    
    return std::string( buf );
}

int BK::Color::get_string ( char * buf, unsigned int cap ) const
{
    if( buf != NULL ) {
        return snprintf( buf, cap, "#%02X%02X%02X", get_red(), get_green(), get_blue() );
    }
    return 0;
}

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::AlphaColor
//
namespace {
extern "C" {

/// AlphaColor 쐬
VALUE AlphaColor_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    AlphaColor * ptr;
    AlphaColor color;
    
    try {
        Ruby::ArgScanner scanner("AlphaColor.new", argc, argv);
        
        color = scanner.fetch_AlphaColor();
        
        scanner.finish();
        
        ptr = new AlphaColor (color);
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    obj = Data_Wrap_Struct( klass, NULL, Color_free, dynamic_cast< Color * >(ptr) );
    
    rb_obj_call_init( obj, argc, argv );
    
    return obj;
}

/// IuWFNg̏
VALUE AlphaColor_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE AlphaColor_initialize_copy ( VALUE self, VALUE obj )
{
    using namespace BK;
    AlphaColor * dest = AlphaColor::value_to_data( self );
    
    if( !AlphaColor::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  AlphaColor ɃRs[ł܂.", rb_obj_classname(obj));
    }
    
    AlphaColor const * src = AlphaColor::value_to_data( obj );
    
    *dest = *src;
    
    return self;
}

/// xvf擾
VALUE AlphaColor_get_alpha ( VALUE self )
{
    BK::AlphaColor * color = BK::AlphaColor::value_to_data( self );
    
    return rb_fix_new(color->get_alpha());
}

/// xvfݒ肷
VALUE AlphaColor_set_alpha ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::AlphaColor * color = BK::AlphaColor::value_to_data( self );
    
    color->set_alpha( NUM2INT(numobj) );
    
    return numobj;
}

/// xtJ[f[^𕶎ɕϊ
VALUE AlphaColor_to_s ( VALUE self )
{
    BK::AlphaColor * color = BK::AlphaColor::value_to_data( self );
    char buf [32];
    int len;
    
    len = color->get_string( buf, 32 );
    
    return rb_str_new(buf, len);
}

/// xtJ[f[^̈vr
VALUE AlphaColor_p_eql ( VALUE self, VALUE obj )
{
    BK::AlphaColor * color = BK::AlphaColor::value_to_data( self );
    BK::AlphaColor * rhs;
    
    if( !xrb_is_kind_of(obj, BK::AlphaColor::get_ruby_class()) ) {
        return Qfalse;
    }
    rhs = BK::AlphaColor::value_to_data( obj );
    
    return (*color == *rhs) ? Qtrue : Qfalse;
}

/// xtJ[f[^̃nbVl擾
VALUE AlphaColor_get_hash ( VALUE self )
{
    BK::AlphaColor * color = BK::AlphaColor::value_to_data( self );
    
    return rb_fix_new((color->get_red())
                      ^ (color->get_green() << 8)
                      ^ (color->get_blue() << 16)
                      ^ (color->get_alpha() << 24));
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::AlphaColor
//

VALUE BK::AlphaColor::ruby_class_object = Qnil;

VALUE BK::AlphaColor::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "AlphaColor", BK::Color::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", AlphaColor_new );
    
    xrb_define_narg_method( c, "initialize", AlphaColor_initialize );
    xrb_define_1arg_method( c, "initialize_copy", AlphaColor_initialize_copy );
    xrb_define_0arg_method( c, "alpha", AlphaColor_get_alpha );
    xrb_define_1arg_method( c, "alpha=", AlphaColor_set_alpha );
    xrb_define_0arg_method( c, "to_s", AlphaColor_to_s );
    xrb_define_1arg_method( c, "==", AlphaColor_p_eql );
    xrb_define_1arg_method( c, "eql?", AlphaColor_p_eql );
    xrb_define_0arg_method( c, "hash", AlphaColor_get_hash );
    
    xrb_define_narg_global_function( "AlphaColor", AlphaColor_new );
    
    return ruby_class_object;
}

void BK::AlphaColor::set_alpha ( BK::Color::element_t a )
{
    if( a > COLOR_ELEMENT_MAX ) {
        throw new argument_exception("AlphaColor Ɏw肳ꂽxvf (%d) ͈͊Oł.", a);
    }
    num_alpha = a;
}

std::string BK::AlphaColor::to_string ( void ) const
{
    char buf [32];
    
    get_string( buf, 32 );
    
    return std::string( buf );
}

int BK::AlphaColor::get_string ( char * buf, unsigned int cap ) const
{
    if( buf != NULL ) {
        return snprintf( buf, cap, "#%02X%02X%02X@%02X", get_red(), get_green(), get_blue(), get_alpha() );
    }
    return 0;
}

VALUE BK::AlphaColor::create_ruby_reference ( void )
{
    return Data_Wrap_Struct( AlphaColor::get_ruby_class(), NULL, Color_free, this );
}

VALUE BK::AlphaColor::create_ruby_object ( void ) const
{
    AlphaColor * dupobj = new AlphaColor( *this );
    
    return Data_Wrap_Struct( AlphaColor::get_ruby_class(), NULL, Color_free, dupobj );
}

//////////////////////////////////////////////////////////////////////
////  O[o֐
//
namespace {

int hexchar_to_int ( char c )
{
    if( '0' <= c && c <= '9' ) {
        return c - '0';
    }
    if( 'a' <= c && c <= 'f' ) {
        return 10 + (c - 'a');
    }
    if( 'A' <= c && c <= 'F' ) {
        return 10 + (c - 'A');
    }
    return -1;
}

} /* namespace */

BK::Color BK::str_to_Color ( const char * src )
{
    const char * str = src;
    
    if( str == NULL ) {
        throw new argument_exception("Color 镶 NULL ł.");
    }
    
    if( *str == '#' ) {
        ++str;
    }
    
    int n [ 6 ];
    int i;
    
    for( i = 0; i < 6; ++i ) {
        int num = hexchar_to_int(*str);
        if( num < 0 ) {
            throw new argument_exception(
                "J[ (%s) ɕsȕ (R[h: %XH) ܂܂Ă܂.", src, *str);
        }
        n[i] = num;
        ++str;
    }
    if( *str != '\0' ) {
        throw new argument_exception("sȃJ[ (%s) ł.", src);
    }
    
    return Color( n[0] * 16 + n[1], n[2] * 16 + n[3], n[4] * 16 + n[5] );
}

BK::Color BK::value_to_Color ( VALUE obj )
{
    Ruby::ArgScanner scanner("Color", 1, &obj);
    
    return scanner.fetch_Color();
}

BK::AlphaColor BK::str_to_AlphaColor ( const char * src )
{
    const char * str = src;
    
    if( str == NULL ) {
        throw new argument_exception("AlphaColor 镶 NULL ł.");
    }
    
    if( *str == '#' ) {
        ++str;
    }
    
    int n [ 9 ];
    int i;
    
    for( i = 0; i < 9; ++i ) {
        if( i == 6 ) {
            if( *str == '\0' ) {
                // x񂪂ȂꍇT|[g
                return AlphaColor( n[0] * 16 + n[1], n[2] * 16 + n[3], n[4] * 16 + n[5] );
            }
            if( *str != '@' ) {
                throw new argument_exception("xtJ[ (%s) ɓx񂪂܂.", src);
            }
        }
        else {
            int num = hexchar_to_int(*str);
            if( num < 0 ) {
                throw new argument_exception(
                    "xtJ[ (%s) ɕsȕ (R[h: %XH) ܂܂Ă܂.", src, *str);
            }
            n[i] = num;
        }
        ++str;
    }
    
    if( *str != '\0' ) {
        throw new argument_exception("sȓxtJ[ (%s) ł.", src);
    }
    
    return AlphaColor( n[0] * 16 + n[1], n[2] * 16 + n[3], n[4] * 16 + n[5], n[7] * 16 + n[8] );
}

BK::AlphaColor BK::value_to_AlphaColor ( VALUE obj )
{
    Ruby::ArgScanner scanner("AlphaColor", 1, &obj);
    
    return scanner.fetch_AlphaColor();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_Color ( void )
{
    BK::Color::get_ruby_class();
    BK::AlphaColor::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_Color ( void )
{
}

//////////////////////////////////////////////////////////////////////
