#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace BK {

/// CAEgsړp̊֐IuWFNg
/**
 * RXgN^ɂĎw肳ꂽxNgAset_point() \bhgĕsړs܂B
 * Reiɑ΂ for_each ȂǂŎgp܂B
 */
class LayoutMover
{
private:
    
    /// ړ
    const Point2 point_move;
    
public:
    
    /// RXgN^
    LayoutMover ( const Point2 & delta )
            : point_move (delta)
    {
    }
    
    /// 
    void operator () ( Layout & layout )
    {
        layout.set_point( layout.get_point() + point_move );
    }
    
    /// 
    void operator () ( Layout * ptr )
    {
        if( ptr != NULL ) {
            operator() ( *ptr );
        }
    }
    
};

} /* namespace BK */
//////////////////////////////////////////////////////////////////////
////  t@C[Jȕϐ
//
namespace {

ID id_downcase_bang;

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace {

using namespace BK;

class LayoutUpdaterForDocumentLayout
{
private:
    
    /// XV
    bool flag_result;
    
public:
    
    /// RXgN^
    LayoutUpdaterForDocumentLayout ( void )
            : flag_result (false)
    {
    }
    
    /// 
    void operator () ( Layout & layout )
    {
        const Size2 prevsize = layout.get_size();
        if( layout.update() ) {
            if( prevsize != layout.get_size() ) {
                flag_result = true;
            }
        }
    }
    
    /// 
    void operator () ( Layout * ptr )
    {
        if( ptr != NULL ) {
            operator() ( *ptr );
        }
    }
    
    /// ʂ擾
    bool get_result ( void ) const
    {
        return flag_result;
    }
    
};

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

using namespace BK;

inline unsigned int copy_layouts ( const DocumentLayout::list_t & src, unsigned int len, Layout * * buf, unsigned int cap )
{
    if( buf == NULL ) {
        return 0;
    }
    
    const DocumentLayout::list_t::const_iterator e = src.end();
    DocumentLayout::list_t::const_iterator itr;
    unsigned int i;
    
    cap = std::min( cap, len );
    
    itr = src.begin();
    for( i = 0; i < len; ++i ) {
        buf[i] = *(itr++);
    }
    
    return len;
}

Layout::align_t rubyobj_to_align ( VALUE obj )
{
    VALUE volatile strobj = rb_String( obj );
    
    rb_funcall( strobj, id_downcase_bang, 0 );
    
    const char * const str = StringValuePtr( strobj );
    
    return Layout::string_to_align( str );
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::DocumentLayout
//
namespace {

/// CAEg̒ǉ
VALUE DocumentLayout_add ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    VALUE volatile ary = Qnil;
    
    if( argc == 1 ) {
        if( !Layout::is_kind_of(argv[0]) ) {
            ary = rb_check_array_type(argv[0]);
            
            if( NIL_P(ary) ) {
                rb_raise( rb_eArgError, "DocumentLayout#add  %s ͎ws.", rb_obj_classname(argv[0]) );
            }
            argc = RARRAY(ary)->len;
            argv = RARRAY(ary)->ptr;
        }
    }
    
    Layout * * const layouts = ALLOCA_N( Layout *, argc );
    int i;
    
    for( i = 0; i < argc; ++i ) {
        if( !Layout::is_kind_of( argv[i] ) ) {
            rb_raise( rb_eArgError, "DocumentLayout  Layout ȊO (%s) ͓o^s.", rb_obj_classname(argv[i]) );
        }
        layouts[i] = Layout::value_to_data( argv[i] );
    }
    ptr->add_layout( layouts, argc );
    
    return self;
}

/// ̈̃CAEg擾
VALUE DocumentLayout_get_contents ( VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    const unsigned int registered = ptr->count_registered_layouts();
    
    Layout * * const layouts = ALLOCA_N( Layout *, registered );
    
    const unsigned int len = ptr->get_registered_layouts( layouts, registered );
    
    VALUE volatile ret = rb_ary_new2(len);
    unsigned int i;
    
    for( i = 0; i < len; ++i ) {
        rb_ary_push( ret, layouts[i]->get_ruby_object() );
    }
    
    return ret;
}

/// ̈̃CAEg폜
VALUE DocumentLayout_wipe ( VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    try {
        ptr->clear_registered_layouts();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

/// o^Ă郌CAEg폜
VALUE DocumentLayout_clear ( VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    try {
        ptr->clear();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

/// ̈Oւ̔zuݒ
VALUE DocumentLayout_set_enable_overflow ( VALUE self, VALUE flagobj )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    if( RTEST(flagobj) ) {
        ptr->set_overflow_enabled( true );
    } else {
        ptr->set_overflow_enabled( false );
    }
    
    return flagobj;
}

/// ̈Oւ̓o^\ł邩𒲂ׂ
VALUE DocumentLayout_get_enable_overflow ( VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    return (ptr->is_overflow_enabled()) ? Qtrue : Qfalse;
}

/// ̈ʒu킹ݒ
VALUE DocumentLayout_set_horizontal_align ( VALUE self, VALUE alignobj )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    Layout::align_t num;
    
    try {
        if( RTEST(rb_obj_is_kind_of(alignobj, rb_cInteger)) ) {
            num = static_cast< Layout::align_t >( NUM2INT( alignobj ) );
        } else {
            num = rubyobj_to_align(alignobj);
        }
        ptr->set_horizontal_align( num );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return alignobj;
}

/// ̈ʒu킹ݒ
VALUE DocumentLayout_set_vertical_align ( VALUE self, VALUE alignobj )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    Layout::align_t num;
    
    try {
        if( RTEST(rb_obj_is_kind_of(alignobj, rb_cInteger)) ) {
            num = static_cast< Layout::align_t >( NUM2INT( alignobj ) );
        } else {
            num = rubyobj_to_align(alignobj);
        }
        ptr->set_vertical_align( num );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return alignobj;
}

/// ̈ʒu킹擾
VALUE DocumentLayout_get_horizontal_align ( VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    return INT2NUM( static_cast<int>( ptr->get_horizontal_align() ) );
}

/// ̈ʒu킹擾
VALUE DocumentLayout_get_vertical_align ( VALUE self )
{
    using namespace BK;
    DocumentLayout * const ptr = DocumentLayout::value_to_data( self );
    
    return INT2NUM( static_cast<int>( ptr->get_vertical_align() ) );
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::DocumentLayout
//

VALUE BK::DocumentLayout::ruby_class_object = Qnil;

BK::DocumentLayout::DocumentLayout ( void )
        : bool_overflow           (false),
          num_registered_layouts  (0),
          align_horizontal        (NONE),
          align_vertical          (NONE)
{
}

BK::DocumentLayout::~DocumentLayout ()
{
}

VALUE BK::DocumentLayout::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "DocumentLayout", parent_t::get_ruby_class() );
    
    xrb_define_narg_method( c, "add", DocumentLayout_add );
    xrb_define_0arg_method( c, "wipe", DocumentLayout_wipe );
    xrb_define_0arg_method( c, "clear", DocumentLayout_clear );
    xrb_define_0arg_method( c, "contents", DocumentLayout_get_contents );
    xrb_define_0arg_method( c, "overflow_enabled?", DocumentLayout_get_enable_overflow );
    xrb_define_1arg_method( c, "enable_overflow=", DocumentLayout_set_enable_overflow );
    xrb_define_0arg_method( c, "vertical_align", DocumentLayout_get_vertical_align );
    xrb_define_1arg_method( c, "vertical_align=", DocumentLayout_set_vertical_align );
    xrb_define_0arg_method( c, "horizontal_align", DocumentLayout_get_horizontal_align );
    xrb_define_1arg_method( c, "horizontal_align=", DocumentLayout_set_horizontal_align );
    
    return ruby_class_object;
}

void BK::DocumentLayout::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    std::for_each( this->ary_list.begin(), this->ary_list.end(), RubyObjectMarker() );
}

void BK::DocumentLayout::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    std::for_each( this->ary_list.begin(), this->ary_list.end(), RubyObjectWrapper() );
}

void BK::DocumentLayout::on_invoke_update ( void )
{
    if( update_document_layouts() ) {
        set_modified();
    }
}

void BK::DocumentLayout::on_set_point ( const BK::Point2 & delta )
{
    LayoutMover mover ( delta );
    unsigned int n;
    list_t::iterator itr = ary_list.begin();
    
    for( n = num_registered_layouts; n > 0; --n ) {
        if( itr == ary_list.end() ) {
            break;
        }
        mover( *itr );
        ++itr;
    }
}

void BK::DocumentLayout::set_registered_layouts_count ( unsigned int num )
{
    num_registered_layouts = num;
}

void BK::DocumentLayout::set_overflow_enabled ( bool flag )
{
    if( bool_overflow != flag ) {
        bool_overflow = flag;
        set_modified();
    }
}

void BK::DocumentLayout::clear ( void )
{
    if( ary_list.size() == 0 ) {
        return;
    }
    ary_list.clear();
    set_registered_layouts_count( 0 );
    set_modified();
}

void BK::DocumentLayout::add_layout ( BK::Layout * * layouts, unsigned int len )
{
    unsigned int i;
    
    if( layouts == NULL ) {
        throw new logic_exception("DocumentLayout::add_layout() ̃CAEgXg NULL w肳܂.");
    }
    
    if( len > 0 ) {
        ary_list.reserve( ary_list.size() + len );
        for( i = 0; i < len; ++i ) {
            Layout * const layout = layouts[i];
            ary_list.push_back( layout );
        }
    }
    set_modified();
}

unsigned int BK::DocumentLayout::get_document_layouts ( Layout * * buf, unsigned int len ) const
{
    if( buf == NULL ) {
        throw new logic_exception("DocumentLayout::get_document_layouts() ̃obt@ NULL w肳܂.");
    }
    return copy_layouts( ary_list, count_document_layouts(), buf, len );
}

unsigned int BK::DocumentLayout::get_registered_layouts ( Layout * * buf, unsigned int len ) const
{
    if( buf == NULL ) {
        throw new logic_exception("DocumentLayout::get_document_layouts() ̃obt@ NULL w肳܂.");
    }
    return copy_layouts( ary_list, count_registered_layouts(), buf, len );
}

void BK::DocumentLayout::clear_registered_layouts ( void )
{
    if( count_registered_layouts() == 0 ) {
        return;
    }
    list_t::iterator itr = ary_list.begin();
    
    std::advance( itr, count_registered_layouts() );
    ary_list.erase( ary_list.begin(), itr );
    
    set_registered_layouts_count( 0 );
    set_modified();
}

void BK::DocumentLayout::set_horizontal_align ( BK::Layout::align_t align )
{
    if( align_horizontal != align ) {
        align_horizontal = align;
        set_modified();
    }
}

void BK::DocumentLayout::set_vertical_align ( BK::Layout::align_t align )
{
    if( align_vertical != align ) {
        align_vertical = align;
        set_modified();
    }
}

bool BK::DocumentLayout::update_document_layouts ( void )
{
    LayoutUpdaterForDocumentLayout updater;
    
    std::for_each( ary_list.begin(), ary_list.end(), updater );
    
    return updater.get_result();
}

BK::Size2::num_t BK::DocumentLayout::get_minimum_height ( void ) const
{
    const list_t::const_iterator e = ary_list.end();
    list_t::const_iterator itr;
    BK::Size2::num_t minimum = 0;
    
    for( itr = ary_list.begin(); itr != ary_list.end(); ++itr ) {
        const Size2 s = (*itr)->get_size();
        
        if( minimum == 0 || s.get_height() < minimum ) {
            minimum = s.get_height();
        }
    }
    
    return minimum;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_DocumentLayout ( void )
{
    BK::DocumentLayout::get_ruby_class();
    
    Init_utility_LabelLayout();
    Init_utility_TextLayout();
    
    id_downcase_bang = rb_intern("downcase!");
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_DocumentLayout ( void )
{
    Exit_utility_TextLayout();
    Exit_utility_LabelLayout();
}

//////////////////////////////////////////////////////////////////////
