#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::Event
//

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::Event
//
namespace {
extern "C" {

VALUE RubyEvent_new ( VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        RubyEvent * const ptr = new RubyEvent();
        
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, 0, NULL );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

VALUE RubyEvent_initialize ( VALUE self )
{
    return self;
}

VALUE RubyEvent_is_signal ( VALUE self )
{
    using namespace BK;
    RubyEvent * const ptr = RubyEvent::value_to_data( self );
    
    return (ptr->is_signal()) ? Qtrue : Qfalse;
}

VALUE RubyEvent_set ( VALUE self )
{
    using namespace BK;
    RubyEvent * const ptr = RubyEvent::value_to_data( self );
    
    ptr->set();
    
    return self;
}

VALUE RubyEvent_reset ( VALUE self )
{
    using namespace BK;
    RubyEvent * const ptr = RubyEvent::value_to_data( self );
    
    ptr->reset();
    
    return self;
}

VALUE RubyEvent_wait ( VALUE self )
{
    rb_raise(rb_eNotImpError, "Event#wait ͖ł.");
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::RubyEvent
//

VALUE BK::RubyEvent::ruby_class_object = Qnil;

VALUE BK::RubyEvent::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Event", rb_cData );
    
    xrb_define_0arg_singleton_method( c, "new", RubyEvent_new );
    
    xrb_define_0arg_method( c, "initialize", RubyEvent_initialize );
    xrb_define_0arg_method( c, "signal?", RubyEvent_is_signal );
    xrb_define_0arg_method( c, "set", RubyEvent_set );
    xrb_define_0arg_method( c, "reset", RubyEvent_reset );
    xrb_define_0arg_method( c, "wait", RubyEvent_wait );
    
    return ruby_class_object;
}

BK::RubyEvent::RubyEvent ( void )
        : num_state (STATE_NOT_SIGNAL)
{
}

BK::RubyEvent::~RubyEvent ()
{
}

void BK::RubyEvent::set ( void )
{
    num_state = STATE_SIGNAL;
}

void BK::RubyEvent::reset ( void )
{
    num_state = STATE_NOT_SIGNAL;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_Event ( void )
{
    BK::RubyEvent::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_Event ( void )
{
}

//////////////////////////////////////////////////////////////////////
