#include "stdafx.h"
#include "schema/main.h"
#include <algorithm>

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Point2
//
namespace {
extern "C" {

/// Point2  (QƔ)
void Point2_ref_free ( BK::Point2 * ptr )
{
}

/// Size2 
void Point2_free ( BK::Point2 * ptr )
{
    delete ptr;
}

/// X W擾
VALUE Point2_get_x ( VALUE self )
{
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    
    return rb_fix_new( ptr->get_x() );
}

/// Y W擾
VALUE Point2_get_y ( VALUE self )
{
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    
    return rb_fix_new( ptr->get_y() );
}

/// IuWFNg̐
VALUE Point2_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile objvalue;
    Point2 * obj;
    
    try {
        Ruby::ArgScanner scanner("Point2.new", argc, argv);
        
        obj = new Point2 ();
        *obj = scanner.fetch_Point2();
        scanner.finish();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    // Point2  RubyObject pĂȂ̂ ruby_wrap() gȂ
    objvalue = Data_Wrap_Struct( BK::Point2::get_ruby_class(), NULL, Point2_free, obj );
    
    rb_obj_call_init( objvalue, argc, argv );
    
    return objvalue;
}

/// 
VALUE Point2_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE Point2_initialize_copy ( VALUE self, VALUE obj )
{
    if( !BK::Point2::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  Point2 ɃRs[ł܂.", rb_obj_classname(obj));
    }
    const BK::Point2 * const src = BK::Point2::value_to_data( obj );
    
    if( !BK::Point2::is_kind_of(self) ) {
        rb_raise(rb_eTypeError, "%s  Point2.initialize_copy Kp܂.", rb_obj_classname(self));
    }
    xrb_update_Data( self, NULL, Point2_free, new BK::Point2( *src ) );
    
    return self;
}

/// X Wݒ肷
VALUE Point2_set_x ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    
    ptr->set_x( NUM2INT(numobj) );
    
    return numobj;
}

/// Y Wݒ肷
VALUE Point2_set_y ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    
    ptr->set_y( NUM2INT(numobj) );
    
    return numobj;
}

/// W𕶎ɕϊ
VALUE Point2_to_s ( VALUE self )
{
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    char buf [32];
    int len;
    
    len = ptr->get_string( buf, 32 );
    
    return rb_str_new(buf, len);
}

/// WIuWFNg̔r
VALUE Point2_p_eql ( VALUE self, VALUE obj )
{
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    
    if( !BK::Point2::is_kind_of(obj) ) {
        return Qfalse;
    }
    BK::Point2 * const rhs = BK::Point2::value_to_data( obj );
    
    return (*ptr == *rhs) ? Qtrue : Qfalse;
}

/// WIuWFNg̃nbV擾
VALUE Point2_get_hash ( VALUE self )
{
    BK::Point2 * const ptr = BK::Point2::value_to_data( self );
    
    return rb_fix_new( (ptr->get_x()) ^ (ptr->get_y() << 16) );
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Point2
//

VALUE BK::Point2::ruby_class_object = Qnil;

VALUE BK::Point2::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Point2", rb_cData );
    
    xrb_define_narg_singleton_method( c, "new", Point2_new );
    
    xrb_define_narg_method( c, "initialize", Point2_initialize );
    xrb_define_1arg_method( c, "initialize_copy", Point2_initialize_copy );
    xrb_define_0arg_method( c, "x", Point2_get_x );
    xrb_define_0arg_method( c, "y", Point2_get_y );
    xrb_define_1arg_method( c, "x=", Point2_set_x );
    xrb_define_1arg_method( c, "y=", Point2_set_y );
    xrb_define_0arg_method( c, "to_s", Point2_to_s );
    xrb_define_1arg_method( c, "==", Point2_p_eql );
    xrb_define_1arg_method( c, "eql?", Point2_p_eql );
    xrb_define_0arg_method( c, "hash", Point2_get_hash );
    
    xrb_define_narg_global_function( "Point2", Point2_new );
    
    return ruby_class_object;
}

std::string BK::Point2::to_string ( void ) const
{
    char buf [32];
    
    get_string( buf, 32 );
    
    return std::string( buf );
}

int BK::Point2::get_string ( char * buf, unsigned int cap ) const
{
    if( buf != NULL ) {
        return snprintf( buf, cap, "(%d,%d)", get_x(), get_y() );
    }
    return 0;
}

VALUE BK::Point2::create_ruby_reference ( void )
{
    //return Data_Wrap_Struct( get_ruby_class(), NULL, Point2_ref_free, this );
    return Data_Wrap_Struct( get_ruby_class(), NULL, NULL, this );
}

VALUE BK::Point2::create_ruby_object ( void ) const
{
    Point2 * dupobj = new Point2( *this );
    
    return Data_Wrap_Struct( get_ruby_class(), NULL, Point2_free, dupobj );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_Point2 ( void )
{
    Point2::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_Point2 ( void )
{
}

//////////////////////////////////////////////////////////////////////
