#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::ProjectionInfo
//
namespace {
extern "C" {

/// ProjectionInfo ̃RXgN^
VALUE ProjectionInfo_new ( VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        ProjectionInfo * const ptr = new ProjectionInfo ();
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, 0, NULL );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// ProjectionInfo ̏
VALUE ProjectionInfo_initialize ( VALUE self )
{
    return self;
}

/// Rs[ɂ鏉
VALUE ProjectionInfo_initialize_copy ( VALUE self, VALUE obj )
{
    rb_raise( rb_eRuntimeError, "ProjectionInfo ̃Rs[sƂ͂ł܂." );
    return self;
}

/// ]̈̎擾
VALUE ProjectionInfo_get_source ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    return ptr->get_source().create_ruby_object();
}

/// ]ʒu̎擾
VALUE ProjectionInfo_get_destination ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    return ptr->get_destination_rect().create_ruby_object();
}

/// Z W̎擾
VALUE ProjectionInfo_get_z ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    return rb_fix_new( ptr->get_z() );
}

/// ]̈̐ݒ
VALUE ProjectionInfo_set_source ( VALUE self, VALUE argobj )
{
    using namespace BK;
    ProjectionInfo * const ptr = ProjectionInfo::value_to_data( self );
    
    try {
        Ruby::ArgScanner scanner("ProjectionInfo#src=", 1, &argobj);
        
        const Rect2 rect = scanner.fetch_Rect2();
        
        scanner.finish();
        
        ptr->set_source( rect );
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    return argobj;
}

/// ]ʒu̐ݒ
VALUE ProjectionInfo_set_destination ( VALUE self, VALUE argobj )
{
    using namespace BK;
    ProjectionInfo * const ptr = ProjectionInfo::value_to_data( self );
    
    try {
        Ruby::ArgScanner scanner("ProjectionInfo#dest=", 1, &argobj);
        
        const Rect2 rect = scanner.fetch_Rect2();
        
        scanner.finish();
        
        ptr->set_destination( rect );
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    return argobj;
}

/// Z W̐ݒ
VALUE ProjectionInfo_set_z ( VALUE self, VALUE zobj )
{
    using namespace BK;
    ProjectionInfo * const ptr = ProjectionInfo::value_to_data( self );
    
    try {
        ptr->set_z( NUM2INT( zobj ) );
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    return zobj;
}

/// ]ɎgFf[^̎擾
VALUE ProjectionInfo_get_color ( VALUE self )
{
    using namespace BK;
    ProjectionInfo * ptr = ProjectionInfo::value_to_data( self );
    AlphaColor const * const color = ptr->get_color();
    
    return (color == NULL) ? Qnil : color->create_ruby_object();
}

/// ]ɎgFf[^̐ݒ
VALUE ProjectionInfo_set_color ( VALUE self, VALUE argobj )
{
    using namespace BK;
    ProjectionInfo * ptr = ProjectionInfo::value_to_data( self );
    
    try {
        if( NIL_P(argobj) ) {
            ptr->set_color( NULL );
        }
        else {
            Ruby::ArgScanner scanner("ProjectionInfo#color=", 1, &argobj);
            
            const AlphaColor color = scanner.fetch_AlphaColor();
            
            scanner.finish();
            
            ptr->set_color( &color );
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return argobj;
}

/// ]̃ANeBuԂ擾
VALUE ProjectionInfo_is_active ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    return BK::OnOffObject_is_active( ptr );
}

/// ]ԂANeBu
VALUE ProjectionInfo_activate ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    BK::OnOffObject_activate( ptr );
    
    return self;
}

/// ]ԂANeBu
VALUE ProjectionInfo_deactivate ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    BK::OnOffObject_deactivate( ptr );
    
    return self;
}

/// ]ԃIuWFNg𖳌
VALUE ProjectionInfo_terminate ( VALUE self )
{
    BK::ProjectionInfo * const ptr = BK::ProjectionInfo::value_to_data( self );
    
    BK::OnOffObject_terminate( ptr );
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::ProjectionInfo
//

VALUE BK::ProjectionInfo::ruby_class_object = Qnil;

VALUE BK::ProjectionInfo::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "ProjectionInfo", BK::RubyObject::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "new", ProjectionInfo_new );
    
    xrb_define_0arg_method( c, "initialize", ProjectionInfo_initialize );
    xrb_define_1arg_method( c, "initialize_copy", ProjectionInfo_initialize_copy );
    xrb_define_0arg_method( c, "src", ProjectionInfo_get_source );
    xrb_define_0arg_method( c, "dest", ProjectionInfo_get_destination );
    xrb_define_0arg_method( c, "z", ProjectionInfo_get_z );
    xrb_define_0arg_method( c, "color", ProjectionInfo_get_color );
    xrb_define_1arg_method( c, "src=", ProjectionInfo_set_source );
    xrb_define_1arg_method( c, "dest=", ProjectionInfo_set_destination );
    xrb_define_1arg_method( c, "z=", ProjectionInfo_set_z );
    xrb_define_1arg_method( c, "color=", ProjectionInfo_set_color );
    xrb_define_0arg_method( c, "active?", ProjectionInfo_is_active );
    xrb_define_0arg_method( c, "activate", ProjectionInfo_activate );
    xrb_define_0arg_method( c, "deactivate", ProjectionInfo_deactivate );
    xrb_define_0arg_method( c, "terminate", ProjectionInfo_terminate );
    
    return ruby_class_object;
}

BK::ProjectionInfo::ProjectionInfo ( void )
        : rect_src   (0, 0, 0, 0),
          num_z      (0),
          ptr_color  (NULL)
{
}

BK::ProjectionInfo::~ProjectionInfo ()
{
    delete ptr_color;
}

bool BK::ProjectionInfo::is_ruby_gc_log_enabled ( void ) const
{
    return false;
}

char * BK::ProjectionInfo::ruby_inspect ( char * buf, unsigned int cap ) const
{
    const char          * const klassname  = rb_class2name( this->get_ruby_class_object() );
    const AlphaColor    * const color      = this->get_color();
    const destination_t &       dest       = this->get_destination();
    const Rect2                 src        = get_source();
    
    if( color != NULL ) {
        sprintf(buf, "#<%s:src=%s,dest=%s,%s,%s,%s,color=%s>",
                klassname,
                get_source().to_string().c_str(),
                dest.topleft.to_string().c_str(),
                dest.topright.to_string().c_str(),
                dest.bottomright.to_string().c_str(),
                dest.bottomleft.to_string().c_str(),
                color->to_string().c_str() );
    } else {
        sprintf(buf, "#<%s:src=%s,dest=%s,%s,%s,%s>",
                klassname,
                get_source().to_string().c_str(),
                dest.topleft.to_string().c_str(),
                dest.topright.to_string().c_str(),
                dest.bottomright.to_string().c_str(),
                dest.bottomleft.to_string().c_str() );
    }
    
    return buf;
}

void BK::ProjectionInfo::set_destination ( const BK::ProjectionInfo::destination_t & dest )
{
    this->obj_dest = dest;
}

void BK::ProjectionInfo::set_source ( const BK::Rect2 & r )
{
    this->rect_src = r;
}

void BK::ProjectionInfo::set_source ( const BK::SpriteFieldData & sprite )
{
    this->set_source( sprite.get_field_rect() );
}

void BK::ProjectionInfo::set_z ( int z )
{
    this->num_z = z;
}

void BK::ProjectionInfo::set_color ( const BK::AlphaColor * c )
{
    if( c == NULL ) {
        if( ptr_color != NULL ) {
            delete ptr_color;
        }
        ptr_color = NULL;
    } else {
        if( ptr_color == NULL ) {
            ptr_color = new AlphaColor();
        }
        *ptr_color = *c;
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_ProjectionInfo ( void )
{
    ProjectionInfo::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_ProjectionInfo ( void )
{
}

//////////////////////////////////////////////////////////////////////
