#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::exception_base
//

void BK::exception_base::set_string ( const char * str, va_list arg )
{
    what_str.assign( BK::strvformat(str, arg) );
}

void BK::exception_base::set_string ( const std::string & s )
{
    what_str.assign(s);
}

//////////////////////////////////////////////////////////////////////
////  BK::system_exit
//

BK::system_exit::system_exit ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::standard_exception
//

BK::standard_exception::standard_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::runtime_exception
//

BK::runtime_exception::runtime_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::logic_exception
//

BK::logic_exception::logic_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::argument_exception
//

BK::argument_exception::argument_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::no_memory_exception
//

BK::no_memory_exception::no_memory_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::unsupported_exception
//

BK::unsupported_exception::unsupported_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::index_exception
//

BK::index_exception::index_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK::out_of_range_exception
//

BK::out_of_range_exception::out_of_range_exception ( const char * format, ... )
{
    va_list arg;
    
    va_start( arg, format );
    set_string( format, arg );
    va_end( arg );
}

//////////////////////////////////////////////////////////////////////
////  BK-Ruby Ag (O)
//

void BK::throw_required_is_not_created ( const char * target, const char * required )
{
    throw new runtime_exception("%s̐ɂ%sKvł.", target, required);
}

void BK::throw_no_memory_for_object ( const char * name )
{
    throw new no_memory_exception("%s IuWFNg̐Ɏs܂.", name);
}

void BK::throw_unusable_type_for_initialize ( const char * object, const char * expected, const char * argtype )
{
    throw new argument_exception("%s  %s ȊO (%s) ŏs.", object, expected, argtype);
}

void BK::Ruby::raise_cannot_create_connection_to_device ( const char * devname )
{
    rb_raise( rb_eRuntimeError, "%sNĂ܂.", devname );
}

void BK::Ruby::raise_invalid_parameter_type_to_register ( const char * owner, const char * required, VALUE param )
{
    rb_raise( rb_eArgError, "%s %s ȊO (%s) ͓o^ł܂.", owner, required, rb_obj_classname(param) );
}

void BK::Ruby::raise_object_is_not_created ( const char * object )
{
    rb_raise( rb_eRuntimeError, "%s\zĂ܂.", object );
}

//////////////////////////////////////////////////////////////////////
