#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Bitmap
//
namespace {
extern "C" {

/// rbg}bṽTCY擾
VALUE Bitmap_get_size ( VALUE self )
{
    BK::Bitmap * const ptr = BK::Bitmap::value_to_data( self );
    
    return ptr->get_size().create_ruby_object();
}

VALUE Bitmap_acquire_body ( VALUE arg )
{
    return rb_yield( arg );
}

VALUE Bitmap_acquire_ensure ( VALUE arg )
{
    BK::Canvas * const canvas = BK::Canvas::value_to_data( arg );
    
    if( canvas != NULL ) {
        canvas->close_canvas();
    }
    
    return Qnil;
}

/// rbg}bṽLoX擾
VALUE Bitmap_acquire ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    Bitmap * const ptr = Bitmap::value_to_data( self );
    Canvas * canvas;
    Rect2 r;
    VALUE volatile canvasobj = Qnil;
    
    try {
        Ruby::ArgScanner scanner("Bitmap#acquire", argc, argv);
        
        if( !scanner.is_empty() ) {
            r = scanner.fetch_Rect2("LoẌ");
            scanner.finish();
            canvas = ptr->create_canvas( &r );
        }
        else {
            canvas = ptr->create_canvas();
        }
        canvasobj = canvas->ruby_wrap();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return xrb_ensure(Bitmap_acquire_body, canvasobj, Bitmap_acquire_ensure, canvasobj);
}

/// rbg}bṽt@CC[W擾
VALUE Bitmap_to_s ( VALUE self )
{
    using namespace BK;
    const unsigned int MAX_TEMPNAME = 1024 * 4;
    Bitmap * const ptr = Bitmap::value_to_data( self );
    exception_base * exception = NULL;
    VALUE volatile ret = Qnil;
    char tempname [MAX_TEMPNAME];
    int result;
    int handle = -1;
    
    try {
        get_temp_filename( tempname, MAX_TEMPNAME );
        ptr->write_to_file( tempname );
        
        handle = open( tempname, O_RDONLY | O_BINARY );
        if( handle == -1 ) {
            throw new runtime_exception("e|C[Wt@C '%s' ̓ǂݍ݂Ɏs.", tempname);
        }
        if( lseek(handle, 0, SEEK_END) == -1 ) {
            throw new runtime_exception("e|C[Wt@C̃V[N (t@C) Ɏs.");
        }
        
        long size = tell(handle);
        if( log_is_trace() ) {
            log_trace("e|C[Wt@C: %ld oCg", size);
        }
        
        if( size == -1 ) {
            throw new runtime_exception("e|C[W̒擾Ɏs.");
        }
        
        // Ƃ₵Ȏc Ruby Ŋmۂobt@Ƀf[^𗬂
        ret = rb_str_new( NULL, size );
        if( lseek(handle, 0, SEEK_SET) == -1 ) {
            throw new runtime_exception("e|C[Wt@C̃V[N (t@C擪) Ɏs.");
        }
        read( handle, RSTRING(ret)->ptr, size );
    }
    catch ( exception_base * e ) {
        exception = e;
    }
    
    if( handle != -1 ) {
        if( close(handle) != 0 ) {
            log_error("e|C[Wt@C '%s' ܂.", tempname);
        }
    }
    
    result = remove( tempname );
    if( result != 0 ) {
        log_error("e|t@C '%s' ̍폜Ɏs.", tempname);
    }
    if( exception != NULL ) {
        ruby_throw( exception );
    }
    
    return ret;
}

/// rbg}bv̓]
VALUE Bitmap_blit ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    Bitmap * const ptr = Bitmap::value_to_data( self );
    
    try {
        Ruby::ArgScanner scanner("Bitmap#blit", argc, argv);
        Bitmap * bitmap;
        Point2 p;
        Rect2 r;
        VALUE arg;
        
        p   = scanner.fetch_Point2("rbg}bv]W");
        arg = scanner.fetch_value("]rbg}bv");
        r   = scanner.fetch_Rect2("rbg}bv]`");
        
        if( !Bitmap::is_kind_of(arg) ) {
            rb_raise(rb_eArgError, "]rbg}bv Bitmap ȊO (%s) ͎wł܂.", rb_obj_classname(arg));
        }
        bitmap = Bitmap::value_to_data( arg );
        
        scanner.finish();
        
        ptr->blit( p, *bitmap, r );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Bitmap
//

VALUE BK::Bitmap::ruby_class_object = Qnil;

BK::Bitmap::Bitmap ()
{
}

BK::Bitmap::~Bitmap ()
{
}

VALUE BK::Bitmap::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Bitmap", parent_t::get_ruby_class() );
    
    xrb_define_0arg_method( c, "size", Bitmap_get_size );
    xrb_define_narg_method( c, "acquire", Bitmap_acquire );
    xrb_define_0arg_method( c, "to_s", Bitmap_to_s );
    xrb_define_narg_method( c, "blit", Bitmap_blit );
    
    return ruby_class_object;
}

char * BK::Bitmap::ruby_inspect ( char * buf, unsigned int cap ) const
{
    std::string info = this->inspect();
    char * ret;
    
    if( info.size() < cap ) {
        ret = buf;
    } else {
        ret = new char [ info.size() + 1 ];
    }
    strcpy( ret, info.c_str() );
    
    return ret;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_Bitmap ( void )
{
    BK::Bitmap::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_Bitmap ( void )
{
}

//////////////////////////////////////////////////////////////////////
