#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BitmapProjectionLayer
//

VALUE BitmapProjectionLayer_get_image ( VALUE self )
{
    BK::BitmapProjectionLayer * const ptr = BK::BitmapProjectionLayer::value_to_data( self );
    
    return ptr->get_bitmap().get_ruby_object();
}

//////////////////////////////////////////////////////////////////////
////  BK::BitmapProjectionLayer
//

VALUE BK::BitmapProjectionLayer::ruby_class_object = Qnil;

BK::BitmapProjectionLayer::BitmapProjectionLayer ( BK::Bitmap & bmp )
        : obj_bitmap (bmp)
{
}

BK::BitmapProjectionLayer::~BitmapProjectionLayer ()
{
}

VALUE BK::BitmapProjectionLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "BitmapProjectionLayer", parent_t::get_ruby_class() );
    
    xrb_define_0arg_method( c, "image", BitmapProjectionLayer_get_image );
    
    return ruby_class_object;
}

void BK::BitmapProjectionLayer::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    this->obj_bitmap.gc_mark_self();
}

void BK::BitmapProjectionLayer::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    this->obj_bitmap.ruby_wrap();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_BitmapProjectionLayer ( void )
{
    BK::BitmapProjectionLayer::get_ruby_class();
    
    Init_graphic_layer_ImageLayer();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_BitmapProjectionLayer ( void )
{
    Exit_graphic_layer_ImageLayer();
}

//////////////////////////////////////////////////////////////////////
