#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

/// LoXĂꍇ̗Oo
void throw_canvas_already_closed ( const BK::Canvas * canvas )
{
    throw new BK::logic_exception("LoX <%p> ̓N[YĂ܂.", canvas);
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  CanvasImplement
//
namespace {

using namespace BK;

class CanvasImplement : public Canvas::implement_t
{
public:
    
    /// RGB l\
    /**
     * vZp݂̂Ɏgp\̂łB
     * RAGABAꂼ̕\@͎RłBꂼ̒l̂܂܎Ă悢łA
     * Vtgς݂̒lݒ肷邱Ƃł܂BVtgς݂̒lݒ肵قA኱A
     * ǂȂ܂BVtgς݂̒lݒ肷ꍇAI[o[t[NȂ悤
     * CKv܂B
     */
    struct rgb_t
    {
        unsigned int r;
        unsigned int g;
        unsigned int b;
        
        /// RXgN^
        rgb_t ( void )
        {
        }
        
        /// RXgN^
        rgb_t ( unsigned int _r, unsigned int _g, unsigned int _b )
                : r (_r), g (_g), b (_b)
        {
        }
        
        /// At@ufBO
        /**
         * ^ꂽ RGB f[^ƃAt@ufBOs܂B
         *  RGB f[^̃At@l alpha ̎cɂȂ܂B
         *
         * @param rgb [in] ufBOΏۂ RGB f[^
         * @param alpha [in] rgb ̃At@l
         */
        rgb_t blend ( const rgb_t & d, Color::element_t da ) const
        {
            const Color::element_t sa = COLOR_ELEMENT_MAX - da;
            return rgb_t(
                (r * sa + d.r * da) / COLOR_ELEMENT_MAX,
                (g * sa + d.g * da) / COLOR_ELEMENT_MAX,
                (b * sa + d.b * da) / COLOR_ELEMENT_MAX );
        }
    };
    
public:
    
    /// RXgN^
    CanvasImplement ( const Rect2 & rect, Canvas::pixel_t pxfmt, void * image, unsigned int pitch )
            : implement_t (rect, pxfmt, image, pitch)
    {
    }
    
    /// oCgPʃANZXp̌^ɕϊ
    byte_t * get_byte_image ( void )
    {
        return reinterpret_cast< byte_t * >( get_image() );
    }
    
    /// LoX̃C擪AhX擾
    void * at_line_ptr ( int y )
    {
        return get_byte_image() + (y * get_pitch());
    }
    
};

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Canvas16
//
namespace {

using namespace BK;

/// 16 rbgsNZpLoX
class Canvas16 : public CanvasImplement
{
public:
    
    /// sNZ^
    typedef uint16 pixel_t;
    
public:
    
    /// RXgN^
    Canvas16 ( const Rect2 & rect, Canvas::pixel_t pxfmt, void * image, unsigned int pitch )
            : CanvasImplement (rect, pxfmt, image, pitch)
    {
    }
    
    /// LoX̃C擪AhX擾
    pixel_t * at_line ( int y )
    {
        return reinterpret_cast< pixel_t * >( at_line_ptr(y) );
    }
    
    /// w肳ꂽ_̃LoXAhX擾
    /**
     * w肳ꂽ_LoẌ̗OɂꍇAȌʂ͓܂B
     * Canvas?? NX̕W\bhłB
     *
     * @param p [in] 擾_
     */
    pixel_t * at ( const Point2 & p )
    {
        return at_line(p.get_y()) + p.get_x();
    }
    
    /// 1 Ci߂AhX擾
    /**
     * Canvas?? NX̕W\bhłB
     *
     * @param ptr [in] i߂AhX
     * @return 1 Ci߂ꂽAhX
     */
    pixel_t * advance_line ( pixel_t * ptr )
    {
        return reinterpret_cast< pixel_t * >( reinterpret_cast< byte_t * >(ptr) + get_pitch() );
    }
    
};

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Canvas32
//
namespace {

using namespace BK;

/// 32 rbgsNZpLoX
class Canvas32 : public CanvasImplement
{
public:
    
    /// sNZ^
    typedef uint32 pixel_t;
    
public:
    
    /// RXgN^
    Canvas32 ( const Rect2 & rect, Canvas::pixel_t pxfmt, void * image, unsigned int pitch )
            : CanvasImplement (rect, pxfmt, image, pitch)
    {
    }
    
    /// LoX̃C擪AhX擾
    pixel_t * at_line ( int y )
    {
        return reinterpret_cast< pixel_t * >( at_line_ptr(y) );
    }
    
    /// w肳ꂽ_̃LoXAhX擾
    /**
     * w肳ꂽ_LoẌ̗OɂꍇAȌʂ͓܂B
     * Canvas?? NX̕W\bhłB
     *
     * @param p [in] 擾_
     */
    pixel_t * at ( const Point2 & p )
    {
        return at_line(p.get_y()) + p.get_x();
    }
    
    /// 1 Ci߂AhX擾
    /**
     * Canvas?? NX̕W\bhłB
     *
     * @param ptr [in] i߂AhX
     * @return 1 Ci߂ꂽAhX
     */
    pixel_t * advance_line ( pixel_t * ptr )
    {
        return reinterpret_cast< pixel_t * >( reinterpret_cast< byte_t * >(ptr) + get_pitch() );
    }
    
};

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  CanvasR5G6B5
//
namespace {

using namespace BK;

/// sNZtH[}bg R5G6B5 p̃LoX
/**
 * RRRR RGGG GGGB BBBB
 */
class CanvasR5G6B5 : public Canvas16
{
public: /* static \bh */
    
    static pixel_t color_to_pixel ( const Color & c )
    {
        return ((c.get_red() & 0xf8) << 8) | ((c.get_green() & 0xfc) << 3) | (c.get_blue() >> 3);
    }
    
    static pixel_t get_pixel_red ( const pixel_t & p )
    {
        return p & 0xf800;
    }
    
    static pixel_t get_pixel_green ( const pixel_t & p )
    {
        return p & 0x07e0;
    }
    
    static pixel_t get_pixel_blue ( const pixel_t & p )
    {
        return p & 0x001f;
    }
    
    static rgb_t pixel_to_rgb ( const pixel_t & p )
    {
        return rgb_t( get_pixel_red(p), get_pixel_green(p), get_pixel_blue(p) );
    }
    
    static pixel_t rgb_to_pixel ( const rgb_t & rgb )
    {
        return rgb.r | rgb.g | rgb.b;
    }
    
public: /* implement_t C^[tFCX */
    
    /// draw_film() RA
    virtual void draw_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src );
    
    /// blit_film() RA
    virtual void blit_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src );
    
    /// fill_rect() RA
    virtual void fill_rect ( const AlphaColor & color, const Rect2 & dst );
    
public:
    
    /// RXgN^
    CanvasR5G6B5 ( const Rect2 & rect, Canvas::pixel_t pxfmt, void * image, unsigned int pitch )
            : Canvas16 (rect, pxfmt, image, pitch)
    {
    }
    
};

void CanvasR5G6B5::draw_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src )
{
    const Film::pixel_t * rline = film.at( src.get_point() );
    const unsigned int rpitch = film.get_size().get_width();
    
    pixel_t * wline = at( dst.get_point() );
    
    const pixel_t sp = color_to_pixel( color );
    const rgb_t sc = pixel_to_rgb( sp );
    
    const unsigned int width = dst.get_width();
    const unsigned int height = dst.get_height();
    
    unsigned int x, y;
    
    for( y = height; y > 0; --y ) {
        for( x = 0; x < width; ++x ) {
            const Film::pixel_t sa = rline[x];
            
            if( sa == 0 ) {
                continue;
            }
            if( sa == COLOR_ELEMENT_MAX ) {
                wline[x] = sp;
            } else {
                wline[x] = rgb_to_pixel( pixel_to_rgb(wline[x]).blend(sc, sa) );
            }
        }
        wline = advance_line( wline );
        rline += rpitch;
    }
}

void CanvasR5G6B5::blit_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src )
{
    pixel_t * wline = at( dst.get_point() );
    
    const Film::pixel_t * rline = film.at( src.get_point() );
    const unsigned int rpitch = film.get_size().get_width();
    
    const pixel_t sp = color_to_pixel( color );
    
    const unsigned int width = dst.get_width();
    const unsigned int height = dst.get_height();
    
    unsigned int x, y;
    
    for( y = height; y > 0; --y ) {
        for( x = 0; x < width; ++x ) {
            const Film::pixel_t sa = rline[x];
            
            if( sa == 0 ) {
                continue;
            }
            wline[x] = sp;
        }
        wline = advance_line( wline );
        rline += rpitch;
    }
}

void CanvasR5G6B5::fill_rect ( const AlphaColor & color, const Rect2 & dst )
{
    pixel_t * wline = at( dst.get_point() );
    
    const pixel_t sp = color_to_pixel( color );
    
    const unsigned int width = dst.get_width();
    const unsigned int height = dst.get_height();
    
    unsigned int x, y;
    
    for( y = height; y > 0; --y ) {
        for( x = 0; x < width; ++x ) {
            wline[x] = sp;
        }
        wline = advance_line( wline );
    }
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  CanvasA8R8G8B8
//
namespace {

using namespace BK;

/// sNZtH[}bg A8R8G8B8 p̃LoX
/**
 * AAAA AAAA RRRR RRRR GGGG GGGG BBBB BBBB
 */
class CanvasA8R8G8B8 : public Canvas32
{
public: /* static \bh */
    
    static pixel_t color_to_pixel ( Color::element_t alpha, const Color & c )
    {
        return
            (alpha << 24) |
            (static_cast<pixel_t>(c.get_red()) << 16) |
            (static_cast<pixel_t>(c.get_green()) << 8) |
            static_cast<pixel_t>(c.get_blue());
    }
    
    static pixel_t color_to_pixel ( const Color & c )
    {
        return color_to_pixel( 0, c );
    }
    
    static pixel_t get_pixel_alpha ( const pixel_t & p )
    {
        return p & 0xff000000;
    }
    
    static pixel_t get_pixel_red ( const pixel_t & p )
    {
        return p & 0x00ff0000;
    }
    
    static pixel_t get_pixel_green ( const pixel_t & p )
    {
        return p & 0x0000ff00;
    }
    
    static pixel_t get_pixel_blue ( const pixel_t & p )
    {
        return p & 0x000000ff;
    }
    
    static rgb_t pixel_to_rgb ( const pixel_t & p )
    {
        return rgb_t( get_pixel_red(p), get_pixel_green(p), get_pixel_blue(p) );
    }
    
    static pixel_t rgb_to_pixel ( const rgb_t & rgb )
    {
        return rgb.r | rgb.g | rgb.b;
    }
    
public: /* implement_t C^[tFCX */
    
    /// draw_film() RA
    virtual void draw_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src );
    
    /// blit_film() RA
    virtual void blit_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src );
    
    /// fill_rect() RA
    virtual void fill_rect ( const AlphaColor & color, const Rect2 & dst );
    
public:
    
    /// RXgN^
    CanvasA8R8G8B8 ( const Rect2 & rect, Canvas::pixel_t pxfmt, void * image, unsigned int pitch )
            : Canvas32 (rect, pxfmt, image, pitch)
    {
    }
    
};

void CanvasA8R8G8B8::draw_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src )
{
    const Film::pixel_t * rline = film.at( src.get_point() );
    const unsigned int rpitch = film.get_size().get_width();
    
    pixel_t * wline = at( dst.get_point() );
    
    const pixel_t sp = color_to_pixel( color );
    const rgb_t sc = pixel_to_rgb( sp );
    
    const unsigned int width = dst.get_width();
    const unsigned int height = dst.get_height();
    
    unsigned int x, y;
    
    for( y = height; y > 0; --y ) {
        for( x = 0; x < width; ++x ) {
            const Film::pixel_t sa = rline[x];
            
            if( sa == 0 ) {
                continue;
            }
            if( sa == COLOR_ELEMENT_MAX ) {
                wline[x] = (wline[x] & 0xff000000) | sp;
            } else if( sa != 0 ) {
                wline[x] = (wline[x] & 0xff000000) | rgb_to_pixel( pixel_to_rgb(wline[x]).blend(sc, sa) );
            }
        }
        wline = advance_line( wline );
        rline += rpitch;
    }
}

void CanvasA8R8G8B8::blit_film ( const Rect2 & dst, const Color & color, const Film & film, const Rect2 & src )
{
    pixel_t * wline = at( dst.get_point() );
    
    const Film::pixel_t * rline = film.at( src.get_point() );
    const unsigned int rpitch = film.get_size().get_width();
    
    const pixel_t sp = color_to_pixel( color );
    
    const unsigned int width = dst.get_width();
    const unsigned int height = dst.get_height();
    
    unsigned int x, y;
    
    for( y = height; y > 0; --y ) {
        for( x = 0; x < width; ++x ) {
            const pixel_t sa = rline[x];
            
            if( sa == 0 ) {
                continue;
            }
            wline[x] = (sa << 24) | sp;
        }
        wline = advance_line( wline );
        rline += rpitch;
    }
}

void CanvasA8R8G8B8::fill_rect ( const AlphaColor & color, const Rect2 & dst )
{
    pixel_t * wline = at( dst.get_point() );
    
    const pixel_t sp = color_to_pixel( color );
    
    const unsigned int width = dst.get_width();
    const unsigned int height = dst.get_height();
    
    unsigned int x, y;
    
    for( y = height; y > 0; --y ) {
        for( x = 0; x < width; ++x ) {
            wline[x] = sp;
        }
        wline = advance_line( wline );
    }
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[JȃO[o֐
//
namespace {

using namespace BK;

/// LoX擾
Canvas::implement_t * create_canvas_implement ( const Rect2 & rect, Canvas::pixel_t pxfmt, void * image, unsigned int pitch )
{
    switch( pxfmt )
    {
    case Canvas::PX16_R5G6B5:
        return new CanvasR5G6B5(rect, pxfmt, image, pitch);
        
    case Canvas::PX32_A8R8G8B8:
        return new CanvasA8R8G8B8(rect, pxfmt, image, pitch);
        
    default:
        throw new runtime_exception(
            "create_canvas_implement(): sNZtH[}bg %s ͖T|[g.", Canvas::pixel_to_string(pxfmt));
    }
    return NULL;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Canvas
//
namespace {
extern "C" {

/// łɃN[YꂽLoXgpꍇ
void Canvas_is_closed ( BK::Canvas * canvas )
{
    if( canvas == NULL ) {
        rb_raise(rb_eRuntimeError, "ꂽLoXւ̃ANZX܂.");
    }
}

/// LoX̏擾
VALUE Canvas_inspect ( VALUE self )
{
    BK::Canvas * const ptr = BK::Canvas::value_to_data( self );
    
    std::string info = ptr->inspect();
    
    return rb_str_new(info.c_str(), info.length());
}

/// LoX̃TCY擾
VALUE Canvas_get_size ( VALUE self )
{
    BK::Canvas * const canvas = BK::Canvas::value_to_data( self );
    
    Canvas_is_closed(canvas);
    
    return canvas->get_size().create_ruby_object();
}

/// LoXɃtB`悷
/* draw_film( point, color, film [, rect] )
 */
VALUE Canvas_draw_film ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    
    try {
        Ruby::ArgScanner scanner("Canvas#draw_film", argc, argv);
        Point2 p;
        Rect2 r;
        Color color;
        VALUE obj;
        Film * film;
        
        p     = scanner.fetch_Point2("tB]W");
        color = scanner.fetch_Color("tBF");
        obj   = scanner.fetch_value("]tB");
        
        if( !Film::is_kind_of(obj) ) {
            rb_raise(rb_eArgError, "]tB %s ͎wł܂.", rb_obj_classname(obj));
        }
        film = Film::value_to_data( obj );
        
        if( scanner.is_empty() ) {
            r = Rect2( film->get_size() );
        } else {
            r = scanner.fetch_Rect2("tB]̈");
        }
        
        scanner.finish();
        
        Canvas * const canvas = Canvas::value_to_data( self );
        
        canvas->draw_film( p, color, *film, r );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

/// LoXɃtB]
/* draw_film( point, color, film [, rect] )
 */
VALUE Canvas_blit_film ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    Canvas * const ptr = Canvas::value_to_data( self );
    
    try {
        Ruby::ArgScanner scanner("Canvas#blit_film", argc, argv);
        AlphaColor color;
        Point2 p;
        Rect2 r;
        Film * film;
        VALUE obj;
        
        p     = scanner.fetch_Point2("tB]W");
        color = scanner.fetch_Color("tBF");
        obj   = scanner.fetch_value("]tB");
        
        if( !Film::is_kind_of(obj) ) {
            rb_raise(rb_eArgError, "]tB %s ͎wł܂.", rb_obj_classname(obj));
        }
        film = Film::value_to_data( obj );
        
        if( scanner.is_empty() ) {
            r = Rect2( film->get_size() );
        } else {
            r = scanner.fetch_Rect2("tB]̈");
        }
        
        scanner.finish();
        
        ptr->blit_film( p, color, *film, r );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

/// LoXhԂ
VALUE Canvas_fill ( int argc, VALUE * argv, VALUE self )
{
    using namespace BK;
    Canvas * const ptr = Canvas::value_to_data( self );
    
    try {
        Ruby::ArgScanner scanner("Canvas#fill", argc, argv);
        AlphaColor color;
        Rect2 r;
        
        color = scanner.fetch_AlphaColor("tBF");
        if( scanner.is_empty() ) {
            r = Rect2( ptr->get_size() );
        } else {
            r = scanner.fetch_Rect2("hԂ̈");
        }
        scanner.finish();
        
        ptr->fill_rect( color, r );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Canvas
//

VALUE BK::Canvas::ruby_class_object = Qnil;

const char * BK::Canvas::pixel_to_string ( pixel_t p )
{
    switch( p )
    {
    case PX32_A2B10G10R10:
        return "PX32_A2B10G10R10";
        
    case PX32_A8R8G8B8:
        return "PX32_A8R8G8B8";
        
    case PX32_X8R8G8B8:
        return "PX32_X8R8G8B8";
        
    case PX32_A8B8G8R8:
        return "PX32_A8B8G8R8";
        
    case PX32_X8B8G8R8:
        return "PX32_X8B8G8R8";
        
    case PX24_R8G8B8:
        return "PX24_R8G8B8";
        
    case PX16_R5G6B5:
        return "PX16_R5G6B5";
        
    case PX16_X1R5G5B5:
        return "PX16_X1R5G5B5";
        
    case PX16_A1R5G5B5:
        return "PX16_A1R5G5B5";
        
    case PX16_A4R4G4B4:
        return "PX16_A4R4G4B4";
        
    case PX16_X4R4G4B4:
        return "PX16_X4R4G4B4";
    }
    return "PX_Unknown";
}

unsigned int BK::Canvas::get_pixel_bytes ( BK::Canvas::pixel_t p )
{
    switch( p )
    {
    case PX32_A2B10G10R10:
    case PX32_A8R8G8B8:
    case PX32_X8R8G8B8:
    case PX32_A8B8G8R8:
    case PX32_X8B8G8R8:
        return 4;
        
    case PX24_R8G8B8:
        return 3;
        
    case PX16_R5G6B5:
    case PX16_X1R5G5B5:
    case PX16_A1R5G5B5:
    case PX16_A4R4G4B4:
    case PX16_X4R4G4B4:
        return 2;
    }
    return 0;
}

BK::Canvas::Canvas ( BK::RubyObject * owner, const Rect2 & rect, BK::Canvas::pixel_t pxfmt, void * src, unsigned int pitch )
        : ptr_implement  (create_canvas_implement(rect, pxfmt, src, pitch)),
          ptr_owner      (owner)
{
    implement_t * const impl = this->ptr_implement;
    
    this->rect_canvas       = impl->get_rect();
    this->size_canvas       = impl->get_size();
    this->num_pixel_format  = impl->get_pixel_info();
    this->num_pitch         = impl->get_pitch();
}

BK::Canvas::~Canvas ()
{
    if( ptr_implement != NULL ) {
        delete ptr_implement;
        throw new logic_exception("LoXN[YĂ܂.");
    }
}

VALUE BK::Canvas::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Canvas", parent_t::get_ruby_class() );
    
    // Picture Ȃǂɂč쐬̂ŃRXgN^͂Ȃ
    
    xrb_define_0arg_method( c, "size", Canvas_get_size );
    xrb_define_narg_method( c, "draw_film", Canvas_draw_film );
    xrb_define_narg_method( c, "blit_film", Canvas_blit_film );
    xrb_define_narg_method( c, "fill", Canvas_fill );
    
    return ruby_class_object;
}

void BK::Canvas::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    if( this->ptr_owner != NULL ) {
        this->ptr_owner->gc_mark_self();
    }
}

void BK::Canvas::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    if( this->ptr_owner != NULL ) {
        this->ptr_owner->ruby_wrap();
    }
}

char * BK::Canvas::ruby_inspect ( char * buf, unsigned int cap ) const
{
    const Size2 s = get_size();
    
    snprintf(
        buf, cap, 
        "<< LoX <%p> ̏ڍ >>\n"
        "----------------------------------------------------------------------\n"
        "LoX̃TCY: %s\n"
        "Csb`: %d oCg\n"
        "sNZtH[}bg: %s\n"
        "----------------------------------------------------------------------",
        this,
        s.to_string().c_str(),
        get_pitch(),
        get_pixel_string() );
    
    return buf;
}

void BK::Canvas::close_canvas ( void )
{
    if( this->ptr_implement == NULL ) {
        throw_canvas_already_closed(this);
    }
    delete this->ptr_implement;
    this->ptr_implement = NULL;
}

void * BK::Canvas::get_image ( void )
{
    if( this->ptr_implement == NULL ) {
        throw_canvas_already_closed(this);
    }
    return this->ptr_implement->get_image();
}

void BK::Canvas::draw_film ( const BK::Point2 & p, const BK::Color & color, const BK::Film & film, const BK::Rect2 & rect )
{
    if( this->ptr_implement == NULL ) {
        throw_canvas_already_closed(this);
    }
    
    const Rect2 srcarea = rect.get_normalized().get_clipped( film.get_size() );
    const Rect2 dstarea = (srcarea + p).get_clipped( get_size() );
    
    if( !dstarea.is_empty() ) {
        this->ptr_implement->draw_film( dstarea, color, film, srcarea );
    }
}

void BK::Canvas::blit_film ( const BK::Point2 & p, const BK::Color & color, const BK::Film & film, const BK::Rect2 & rect )
{
    if( this->ptr_implement == NULL ) {
        throw_canvas_already_closed(this);
    }
    
    const Rect2 srcarea = rect.get_normalized().get_clipped( film.get_size() );
    const Rect2 dstarea = (srcarea + p).get_clipped( get_size() );
    
    if( !dstarea.is_empty() ) {
        this->ptr_implement->blit_film( dstarea, color, film, srcarea );
    }
}

void BK::Canvas::fill_rect ( const BK::AlphaColor & color, const BK::Rect2 & rect )
{
    if( this->ptr_implement == NULL ) {
        throw_canvas_already_closed(this);
    }
    
    const Rect2 dstarea = rect.get_normalized();
    
    if( !dstarea.is_empty() ) {
        this->ptr_implement->fill_rect( color, dstarea );
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_Canvas ( void )
{
    BK::Canvas::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_Canvas ( void )
{
}

//////////////////////////////////////////////////////////////////////
