#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {


/// ]̈obt@̏TCY
const int INITIAL_INFO_CAPACITY = 128;

/// tBC[pC[W̃ftHgTCY
const BK::Size2 DEFAULT_IMAGE_SIZE = BK::Size2( 64, 64 );


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

using namespace BK;

typedef BK::FilmLayer::list_t infoary_t;
typedef infoary_t::list_t list_t;

/// œKȃTCỸC[W𐶐
/**
 * ary Ɋ܂܂]̈悩œKȃTCỸC[WvZ܂B
 * ݎgp̃C[WsKȏꍇÃ\bhŃC[WjA
 * VȃC[W쐬ĕԂ܂B
 *
 * @param ary [in] ]̈̃Xg
 * @param currimg [in] ݎgp̃C[W
 * @return gpC[W
 */
Image * prepare_suitable_image ( const list_t & ary, Image * currimg )
{
    const list_t::const_iterator e = ary.end();
    list_t::const_iterator itr;
    Size2 s = DEFAULT_IMAGE_SIZE;
    
    if( currimg != NULL ) {
        for( itr = ary.begin(); itr != e; ++itr ) {
            Film * const film = (*itr)->get_film();
            const Size2 filmsize = film->get_size();
            
            if( s.get_width() < filmsize.get_width() ) {
                s.set_width( filmsize.get_width() );
            }
            if( s.get_height() < filmsize.get_height() ) {
                s.set_height( filmsize.get_height() );
            }
        }
    }
    if( currimg == NULL || currimg->get_size() != s ) {
        GraphicDevice * const gdev = GraphicDevice::get_instance();
        if( gdev == NULL ) {
            throw_required_is_not_created("ƗpC[W", "OtBbNfoCX");
        }
        delete currimg;
        currimg = gdev->create_image( s );
    }
    
    return currimg;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FilmLayer::ProjectionInfo
//
namespace {
extern "C" {

VALUE FilmLayer_ProjectionInfo_get_film ( VALUE self )
{
    using namespace BK;
    FilmLayer::info_t * const ptr = FilmLayer::info_t::value_to_data( self );
    
    return ptr->get_film()->get_ruby_object();
}

VALUE FilmLayer_ProjectionInfo_set_film ( VALUE self, VALUE filmobj )
{
    using namespace BK;
    FilmLayer::info_t * const ptr = FilmLayer::info_t::value_to_data( self );
    
    if( !Film::is_kind_of(filmobj) ) {
        rb_raise(rb_eArgError, "FilmLayer::ProjectionInfo  Film ȊO (%s) ͐ݒs.", rb_obj_classname(filmobj));
    }
    
    try {
        ptr->set_film( Film::value_to_data(filmobj) );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return filmobj;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FilmLayer::info_t
//

VALUE BK::FilmLayer::info_t::ruby_class_object = Qnil;

BK::FilmLayer::info_t::info_t ( void )
        : ptr_film (NULL)
{
}

void BK::FilmLayer::info_t::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    if( this->ptr_film != NULL ) {
        this->ptr_film->gc_mark_self();
    }
}

void BK::FilmLayer::info_t::on_ruby_wrap ( void )
{
    parent_t::ruby_gc_mark();
    if( this->ptr_film != NULL ) {
        this->ptr_film->ruby_wrap();
    }
}

void BK::FilmLayer::info_t::set_film ( BK::Film * film )
{
    this->ptr_film = film;
}

VALUE BK::FilmLayer::info_t::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE ownerklass = BK::FilmLayer::get_ruby_class();
    VALUE c;
    
    c = ruby_class_object = rb_define_class_under( ownerklass, "ProjectionInfo", parent_t::get_ruby_class() );
    
    xrb_define_0arg_method( c, "film", FilmLayer_ProjectionInfo_get_film );
    xrb_define_1arg_method( c, "film=", FilmLayer_ProjectionInfo_set_film );
    
    return ruby_class_object;
}

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FilmLayer
//
namespace {
extern "C" {

VALUE FilmLayer_new ( VALUE klass )
{
    using namespace BK;
    FilmLayer * ptr = NULL;
    VALUE volatile obj = Qnil;
    
    try {
        ptr = create_FilmLayer();
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, 0, NULL );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

VALUE FilmLayer_initialize ( VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FilmLayer
//

VALUE BK::FilmLayer::ruby_class_object = Qnil;

BK::FilmLayer::FilmLayer ( void )
        : obj_list   (INITIAL_INFO_CAPACITY),
          ptr_image  (NULL)
{
}

BK::FilmLayer::~FilmLayer ()
{
    delete this->ptr_image;
}

VALUE BK::FilmLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "FilmLayer", BK::BitmapProjectionLayer::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "new", FilmLayer_new );
    
    xrb_define_0arg_method( c, "initialize", FilmLayer_initialize );
    
    return ruby_class_object;
}

void BK::FilmLayer::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    this->obj_list.ruby_gc_mark();
    if( this->ptr_image != NULL ) {
        this->ptr_image->gc_mark_self();
    }
}

void BK::FilmLayer::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    this->obj_list.on_ruby_wrap();
    if( this->ptr_image != NULL ) {
        this->ptr_image->ruby_wrap();
    }
}

BK::ProjectionInfo * BK::FilmLayer::register_projection ( void )
{
    info_t * const info = new info_t ();
    
    if( info == NULL ) {
        throw new runtime_exception("FilmLayer ]̈̐Ɏs܂.");
    }
    
    ProjectionInfo * const registered = this->obj_list.add( *info );
    
    return registered;
}

void BK::FilmLayer::delete_projection ( BK::ProjectionInfo * ptr )
{
    info_t * const info = dynamic_cast< info_t * >( ptr );
    
    if( info == NULL ) {
        throw new argument_exception("قȂ^̓]̈ <%s> w肳܂.", typeid(*ptr).name());
    }
    
    if( !this->obj_list.erase( *info ) ) {
        throw new argument_exception("w肳ꂽ]̈ <%p> ̓tBC[ɑ݂܂.", ptr);
    }
}

unsigned int BK::FilmLayer::count_projection ( void ) const
{
    return this->obj_list.size();
}

void BK::FilmLayer::execute ( GraphicDevice * dev )
{
    this->execute_by_ImageLayer(dev);
}

void BK::FilmLayer::execute_by_canvas ( BK::GraphicDevice * dev )
{
    typedef list_t::list_t list_t;
    
    const list_t & list = this->obj_list.get_sorted_array();
    
    const list_t::const_iterator e = list.end();
    list_t::const_iterator itr;
    
    Canvas * const canvas = dev->create_canvas();
    try {
        for( itr = list.begin(); itr != e; ++itr ) {
            const info_t * const info = *itr;
            const AlphaColor * const color = info->get_color();
            const Film * const film = info->get_film();
            
            if( color != NULL && film != NULL ) {
                canvas->draw_film( info->get_destination().topleft, *color, *film, Rect2(film->get_size()) );
            }
        }
    } catch ( exception_base * ) {
        canvas->close_canvas();
        delete canvas;
        throw;
    }
    canvas->close_canvas();
    delete canvas;
}

void BK::FilmLayer::execute_by_ImageLayer ( BK::GraphicDevice * dev )
{
    typedef list_t::list_t list_t;
    const list_t & list = this->obj_list.get_sorted_array();
    
    ptr_image = prepare_suitable_image( list, ptr_image );
    
    const list_t::const_reverse_iterator e = list.rend();
    list_t::const_reverse_iterator itr;
    
    std::auto_ptr < ImageLayer > imglayer ( create_ImageLayer(*ptr_image) );
    std::auto_ptr < ProjectionInfo > info ( imglayer->register_projection() );
    
    for( itr = list.rbegin(); itr != e; ++itr ) {
        const info_t * const filminfo = *itr;
        
        const Film       * const film  = filminfo->get_film();
        const AlphaColor * const color = filminfo->get_color();
        
        if( film == NULL || color == NULL ) {
            continue;
        }
        const Rect2 r ( filminfo->get_film()->get_size() );
        {
            std::auto_ptr < Canvas > canvas ( ptr_image->create_canvas(&r) );
            canvas->fill_rect( AlphaColor(0, 0, 0, 0), r );
            canvas->blit_film( Point2(0, 0), *color, *film, r );
        }
        
        info->set_destination( filminfo->get_destination() );
        info->set_source( r );
        
        imglayer->execute( dev );
    }
    imglayer->delete_projection( info.get() );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_FilmLayer ( void )
{
    BK::FilmLayer::get_ruby_class();
    BK::FilmLayer::info_t::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_FilmLayer ( void )
{
}

//////////////////////////////////////////////////////////////////////
