#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::GlyphLayout
//
namespace {

/// IuWFNg̐
VALUE GlyphLayout_new ( VALUE klass, VALUE glyphobj )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    if( !Glyph::is_kind_of(glyphobj) ) {
        rb_raise(rb_eArgError, "GlyphLayout.new  Glyph ȊO (%s) ͎wsł.",
                 rb_obj_classname(glyphobj));
    }
    
    Glyph * const glyph = Glyph::value_to_data( glyphobj );
    
    try {
        GlyphLayout * const ptr = new GlyphLayout ();
        
        ptr->set_glyph( glyph );
        
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, 1, &glyphobj );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// IuWFNg̏
VALUE GlyphLayout_initialize ( VALUE self, VALUE glyphobj )
{
    return self;
}

/// Ot擾
VALUE GlyphLayout_get_glyph ( VALUE self )
{
    using namespace BK;
    GlyphLayout * const ptr = GlyphLayout::value_to_data( self );
    Glyph * const glyph = ptr->get_glyph();
    
    return (glyph == NULL) ? Qnil : glyph->get_ruby_object();
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::GlyphLayout
//

VALUE BK::GlyphLayout::ruby_class_object = Qnil;

BK::GlyphLayout::GlyphLayout ( void )
        : ptr_glyph (NULL)
{
}

BK::GlyphLayout::~GlyphLayout ()
{
}

VALUE BK::GlyphLayout::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "GlyphLayout", parent_t::get_ruby_class() );
    
    xrb_define_1arg_singleton_method( c, "new", GlyphLayout_new );
    xrb_define_1arg_method( c, "initialize", GlyphLayout_initialize );
    xrb_define_0arg_method( c, "glyph", GlyphLayout_get_glyph );
    
    return ruby_class_object;
}

void BK::GlyphLayout::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    if( this->ptr_glyph != NULL ) {
        this->ptr_glyph->gc_mark_self();
    }
}

void BK::GlyphLayout::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    if( this->ptr_glyph != NULL ) {
        this->ptr_glyph->ruby_wrap();
    }
}

void BK::GlyphLayout::set_glyph ( BK::Glyph * glyph )
{
    this->ptr_glyph = glyph;
    if( glyph != NULL ) {
        this->set_size( glyph->get_size() );
    }
}

char * BK::GlyphLayout::ruby_inspect ( char * buf, unsigned int cap ) const
{
    if( ptr_glyph == NULL ) {
        return parent_t::ruby_inspect(buf, cap);
    } else {
        sprintf(
            buf,
            "<GlyphLayout:%s@%s,'%s'>",
            this->get_size().to_string().c_str(),
            this->get_point().to_string().c_str(),
            this->ptr_glyph->get_character() );
        return buf;
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_GlyphLayout ( void )
{
    BK::GlyphLayout::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_GlyphLayout ( void )
{
}

//////////////////////////////////////////////////////////////////////
