#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {

const bool INITIAL_IS_FULLSCREEN = false;

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace BK {


class RubyGraphicDevice : public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: GraphicDevice
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static RubyGraphicDevice * value_to_data ( VALUE obj )
    {
        return ruby_basecast< RubyGraphicDevice, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
public:
    
    /// RXgN^
    RubyGraphicDevice ( GraphicDevice * )
    {
    }
    
    /// fXgN^
    ~RubyGraphicDevice ()
    {
    }
    
};


} /* namespace BK */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::GraphicDevice
//
namespace {
extern "C" {

/// OtBbNfoCX̊Jn
VALUE GraphicDevice_start ( VALUE klass )
{
    using namespace BK;
    GraphicDevice * const dev = GraphicDevice::get_instance();
    
    try {
        dev->start();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// OtBbNfoCX̒~
VALUE GraphicDevice_stop ( VALUE klass )
{
    using namespace BK;
    GraphicDevice * const dev = GraphicDevice::get_instance();
    
    try {
        dev->stop();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// OtBbNfoCXNĂ邩𒲂ׂ
VALUE GraphicDevice_is_started ( VALUE klass )
{
    BK::GraphicDevice * const dev = BK::GraphicDevice::get_instance();
    
    return (dev->is_started()) ? Qtrue : Qfalse;
}

/// OfoCX̑IuWFNg쐬
VALUE GraphicDevice_connect ( VALUE klass )
{
    using namespace BK;
    GraphicDevice * const dev = GraphicDevice::get_instance();
    
    if( !dev->is_started() ) {
        Ruby::raise_cannot_create_connection_to_device("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    try {
        RubyGraphicDevice * const ptr = new RubyGraphicDevice( dev );
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// C[Xg̎擾
VALUE GraphicDevice_get_layer_array ( VALUE self )
{
    using namespace BK;
    GraphicDevice * const grp = GraphicDevice::get_instance();
    LayerArray * const ary = grp->get_layer_array();
    
    return (ary == NULL) ? Qnil : ary->get_ruby_object();
}

/// C[Xg̐ݒ
VALUE GraphicDevice_set_layer_array ( VALUE self, VALUE obj )
{
    using namespace BK;
    GraphicDevice * const grp = GraphicDevice::get_instance();
    VALUE volatile ret;
    
    if( !LayerArray::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "layer_array  LayerArray ȊO (%s) ݒs.", rb_obj_classname(obj));
    }
    
    try {
        LayerArray * const prevary = grp->get_layer_array();
        
        ret = (prevary == NULL) ? Qnil : prevary->get_ruby_object();
        
        LayerArray * const ary = LayerArray::value_to_data( obj );
        
        grp->set_layer_array( ary );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return ret;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::RubyGraphicDevice
//

VALUE BK::RubyGraphicDevice::ruby_class_object = Qnil;

VALUE BK::RubyGraphicDevice::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "GraphicDevice", BK::RubyObject::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "start", GraphicDevice_start );
    xrb_define_0arg_singleton_method( c, "started?", GraphicDevice_is_started );
    xrb_define_0arg_singleton_method( c, "stop", GraphicDevice_stop );
    xrb_define_0arg_singleton_method( c, "connect", GraphicDevice_connect );
    xrb_define_0arg_singleton_method( c, "new", GraphicDevice_connect );
    
    xrb_define_0arg_method( c, "layer_array", GraphicDevice_get_layer_array );
    xrb_define_1arg_method( c, "layer_array=", GraphicDevice_set_layer_array );
    
    return ruby_class_object;
}

// ɃO[oŃ}[NĂ
//void BK::RubyGraphicDevice::ruby_gc_mark ( void )
//{
//    GraphicDevice::get_instance()->ruby_gc_mark();
//}

//////////////////////////////////////////////////////////////////////
////  BK::GraphicDevice
//

BK::GraphicDevice * BK::GraphicDevice::singleton_object = NULL;

bool BK::GraphicDevice::flag_initial_fullscreen = INITIAL_IS_FULLSCREEN;

BK::GraphicDevice::GraphicDevice ( void )
        : ptr_layer_array            (NULL),
          num_screen_update_counter  (0)
{
    if( singleton_object != NULL ) {
        throw new logic_exception("GraphicDevice ̍č\zs܂.");
    }
    singleton_object = this;
    
    if( log_is_comment() ) {
        log_comment("OtBbNfoCX <%p> ̍\zI܂.", this);
    }
}

BK::GraphicDevice::~GraphicDevice ()
{
    if( log_is_comment() ) {
        log_comment("OtBbNfoCX <%p> ̔jJn܂.", this);
    }
    
    // jI
    if( singleton_object != this ) {
        throw new logic_exception("s GraphicDevice o܂.");
    }
    singleton_object = NULL;
}

void BK::GraphicDevice::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    if( this->ptr_layer_array != NULL ) {
        this->ptr_layer_array->gc_mark_self();
    }
}

const char * BK::GraphicDevice::get_device_name ( void ) const
{
    return "OtBbNT[rX";
}

void BK::GraphicDevice::_start ( void )
{
    this->ptr_layer_array = new LayerArray();
    this->ptr_layer_array->ruby_wrap();
}

void BK::GraphicDevice::_stop ( void )
{
    // ptr_layer_array ̉ Ruby GC ɔC
    ptr_layer_array = NULL;
}

void BK::GraphicDevice::broadcast ( void )
{
    ptr_layer_array->execute( this );
}

void BK::GraphicDevice::update_screen ( void )
{
    ++num_screen_update_counter;
}

BK::LayerArray * BK::GraphicDevice::set_layer_array ( LayerArray * ptr )
{
    LayerArray * const ret = ptr_layer_array;
    
    ptr_layer_array = ptr;
    
    return ret;
}

BK::Size2 BK::GraphicDevice::get_screen_size ( void ) const
{
    ApplicationDevice * const adev = ApplicationDevice::get_instance();
    
    if( adev == NULL ) {
        throw new logic_exception("AvP[VfoCX\zł.");
    }
    
    return adev->get_application_area_size();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_GraphicDevice ( void )
{
    {
        GraphicDevice * dev = create_GraphicDevice();
        if( dev == NULL ) {
            throw new logic_exception("OtBbNfoCX̐Ɏs܂.");
        }
    }
    BK::RubyGraphicDevice::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_GraphicDevice ( void )
{
    {
        GraphicDevice * dev = GraphicDevice::get_instance();
        if( dev->is_started() ) {
            dev->stop();
        }
        delete dev;
    }
}

//////////////////////////////////////////////////////////////////////
