#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Image
//
namespace {
extern "C" {

/// VIuWFNg𐶐
VALUE Image_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    VALUE volatile obj = Qnil;
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    try {
        Ruby::ArgScanner scanner("Image.new", argc, argv);
        
        const Size2 s = scanner.fetch_Size2("C[WTCY");
        
        scanner.finish();
        
        Image * const ptr = gdev->create_image( s );
        
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, argc, argv );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// t@CC[WIuWFNg\z
VALUE Image_open ( VALUE klass, VALUE arg )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    Image * ptr = NULL;
    
    try {
        if( TYPE(arg) == T_STRING ) {
            ptr = gdev->load_image_from_file( xrb_str_ptr(arg) );
            obj = ptr->ruby_wrap();
        } else {
            rb_raise(rb_eArgError, "%s ł̍\z͕s.", rb_obj_classname(arg));
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// C[WC[WIuWFNg\z
VALUE Image_read ( VALUE klass, VALUE arg )
{
    using namespace BK;
    GraphicDevice * gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    Image * ptr = NULL;
    
    try {
        if( TYPE(arg) == T_STRING ) {
            ptr = gdev->load_image_from_memory( xrb_str_ptr(arg), xrb_str_len(arg) );
            obj = ptr->ruby_wrap();
        } else {
            rb_raise(rb_eArgError, "%s ł̍\z͕s.", rb_obj_classname(arg));
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// C[W̏
VALUE Image_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Image
//

VALUE BK::Image::ruby_class_object = Qnil;

BK::Image::Image ( void )
{
}

BK::Image::~Image ()
{
}

VALUE BK::Image::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Image", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", Image_new );
    xrb_define_1arg_singleton_method( c, "open", Image_open );
    xrb_define_1arg_singleton_method( c, "read", Image_read );
    
    xrb_define_narg_method( c, "initialize", Image_initialize );
    
    return ruby_class_object;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_Image ( void )
{
    BK::Image::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_Image ( void )
{
}

//////////////////////////////////////////////////////////////////////
