#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::ImageLayer
//
namespace {
extern "C" {

/// ImageLayer ̐
VALUE ImageLayer_new ( VALUE klass, VALUE imgobj )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    ImageLayer * ptr;
    
    if( !Image::is_kind_of(imgobj) ) {
        rb_raise(rb_eArgError, "ImageLayer  Image ȊO (%s) ł͏s.", rb_obj_classname(imgobj));
    }
    Image * const img = Image::value_to_data( imgobj );
    
    try {
        ptr = create_ImageLayer(*img);
        if( ptr == NULL ) {
            throw_no_memory_for_object("ImageLayer");
        }
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, 1, &imgobj );
    
    return obj;
}

/// C[WC[̏
VALUE ImageLayer_initialize ( VALUE self, VALUE imgobj )
{
    return self;
}

/// gpĂC[W̎擾
VALUE ImageLayer_get_image ( VALUE self )
{
    BK::ImageLayer * const ptr = BK::ImageLayer::value_to_data( self );
    VALUE volatile obj = Qnil;
    
    try {
        BK::Image & img = ptr->get_image();
        obj = img.ruby_wrap();
    }
    catch ( BK::exception_base * e ) {
        BK::ruby_throw( e );
    }
    
    return obj;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::ImageLayer
//

VALUE BK::ImageLayer::ruby_class_object = Qnil;

BK::ImageLayer::ImageLayer ( Image & image )
        : BitmapProjectionLayer  (image),
          obj_image              (image)
{
}

BK::ImageLayer::~ImageLayer ()
{
}

VALUE BK::ImageLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "ImageLayer", parent_t::get_ruby_class() );
    
    xrb_define_1arg_singleton_method( c, "new", ImageLayer_new );
    
    xrb_define_1arg_method( c, "initialize", ImageLayer_initialize );
    
    return ruby_class_object;
}

void BK::ImageLayer::ruby_gc_mark ( void )
{
    this->obj_image.gc_mark_self();
}

void BK::ImageLayer::on_ruby_wrap ( void )
{
    this->obj_image.ruby_wrap();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_ImageLayer ( void )
{
    BK::ImageLayer::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_ImageLayer ( void )
{
}

//////////////////////////////////////////////////////////////////////
