#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

void throw_name_not_found ( const char * name )
{
    throw new BK::argument_exception("C[ '%s' ܂.", name);
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::LayerArray
//
namespace {
extern "C" {

/// C[Xg̐
VALUE LayerArray_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile aryobj = Qnil;
    
    try {
        LayerArray * const ptr = new LayerArray();
        aryobj = ptr->ruby_wrap();
        rb_obj_call_init( aryobj, argc, argv );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return aryobj;
}

/// C[̎擾
VALUE LayerArray_get_layer ( VALUE self, VALUE keyobj )
{
    using namespace BK;
    LayerArray * const ptr = LayerArray::value_to_data( self );
    Layer * layer;
    
    try {
        if( FIXNUM_P(keyobj) ) {
            layer = ptr->at( FIX2INT(keyobj) );
        } else {
            const char * const name = StringValuePtr( keyobj );
            layer = ptr->get_layer( name );
        }
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    return (layer == NULL) ? Qnil : layer->get_ruby_object();
}

/// C[̐ݒ
VALUE LayerArray_set_layer ( VALUE self, VALUE keyobj, VALUE layerobj )
{
    using namespace BK;
    
    if( !NIL_P(layerobj) ) {
        if( !Layer::is_kind_of(layerobj) ) {
            Ruby::raise_invalid_parameter_type_to_register("C[Xg", "Layer", layerobj);
        }
    }
    LayerArray * const ptr = LayerArray::value_to_data( self );
    
    try {
        Layer * const layer = (NIL_P(layerobj)) ? NULL : Layer::value_to_data(layerobj);
        
        if( FIXNUM_P(keyobj) ) {
            ptr->set_at( FIX2INT(keyobj), layer );
        } else {
            const char * const name = StringValuePtr( keyobj );
            ptr->set_layer( name, layer );
        }
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    return layerobj;
}

/// C[̎擾
VALUE LayerArray_get_names ( VALUE self )
{
    using namespace BK;
    LayerArray * const ptr = LayerArray::value_to_data( self );
    const unsigned int cap = ptr->size();
    
    const char * * const namebuf = ALLOCA_N( const char *, cap + 1 );
    try {
        ptr->get_names( namebuf, cap );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    VALUE volatile ary = rb_ary_new();
    unsigned int i;
    
    for( i = 0; i < cap; ++i ) {
        rb_ary_push( ary, rb_str_new2(namebuf[i]) );
    }
    
    return ary;
}

/// C[̐ݒ
VALUE LayerArray_set_names ( VALUE self, VALUE ary )
{
    using namespace BK;
    if( TYPE(ary) != T_ARRAY ) {
        Ruby::raise_invalid_parameter_type_to_register("C[Xg", "Array", ary);
    }
    LayerArray * const ptr = LayerArray::value_to_data( self );
    const unsigned int len = xrb_ary_length(ary);
    
    const char * * const names = ALLOCA_N( const char *, len + 1 );
    try {
        VALUE volatile cache = rb_ary_new();
        unsigned int i;
        
        for( i = 0; i < len; ++i ) {
            VALUE volatile nameobj = RARRAY(ary)->ptr[i];
            const char * const name = StringValuePtr( nameobj );
            
            if( name[0] == '\0' ) {
                rb_raise(rb_eArgError, "ݒ肷郌C[ɋ󕶎񂪑݂܂.");
            }
            if( str_index_char( name, '/' ) >= 0 ) {
                rb_raise(rb_eArgError, "ݒ肷郌C[ / ܂܂ĂĂ͂Ȃ܂.");
            }
            names[i] = name;
            rb_ary_push( cache, nameobj );
        }
        names[len] = NULL;
        ptr->set_names( names );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return ary;
}

/// C[̐擾
VALUE LayerArray_get_size ( VALUE self )
{
    using namespace BK;
    LayerArray * const ptr = LayerArray::value_to_data( self );
    
    return UINT2NUM( ptr->size() );
}

/// C[ɑΉCfNX擾
VALUE LayerArray_index ( VALUE self, VALUE strobj )
{
    using namespace BK;
    LayerArray * const ptr = LayerArray::value_to_data( self );
    const char * str = StringValuePtr( strobj );
    unsigned int index;
    
    try {
        index = ptr->get_index( str );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return UINT2NUM( index );
}

/// IuWFNg̏
VALUE LayerArray_initialize ( VALUE self, VALUE aryobj )
{
    LayerArray_set_names( self, aryobj );
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::LayerArray
//

VALUE BK::LayerArray::ruby_class_object = Qnil;

VALUE BK::LayerArray::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "LayerArray", BK::Layer::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", LayerArray_new );
    
    xrb_define_larg_method( c, "initialize", LayerArray_initialize );
    xrb_define_1arg_method( c, "[]", LayerArray_get_layer );
    xrb_define_2arg_method( c, "[]=", LayerArray_set_layer );
    xrb_define_0arg_method( c, "names", LayerArray_get_names );
    xrb_define_1arg_method( c, "names=", LayerArray_set_names );
    xrb_define_0arg_method( c, "size", LayerArray_get_size );
    xrb_define_1arg_method( c, "index", LayerArray_index );
    
    return ruby_class_object;
}

BK::LayerArray::LayerArray ( void )
{
}

BK::LayerArray::~LayerArray ()
{
}

void BK::LayerArray::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    std::for_each( this->ary_list.begin(), this->ary_list.end(), RubyObjectMarker() );
}

void BK::LayerArray::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    std::for_each( this->ary_list.begin(), this->ary_list.end(), RubyObjectWrapper() );
}

const BK::LayerArray::data_t * BK::LayerArray::find_data ( const char * name ) const
{
    if( name == NULL ) {
        log_warn("[LayerArray::find_data()] C[ NULL w肳܂.");
        return NULL;
    }
    const list_t::const_iterator i = std::find( ary_list.begin(), ary_list.end(), name );
    
    return (i == ary_list.end()) ? NULL : &(*i);
}

BK::LayerArray::data_t * BK::LayerArray::find_data ( const char * name )
{
    if( name == NULL ) {
        log_warn("[LayerArray::find_data()] C[ NULL w肳܂.");
        return NULL;
    }
    const list_t::iterator i = std::find( ary_list.begin(), ary_list.end(), name );
    
    return (i == ary_list.end()) ? NULL : &(*i);
}

void BK::LayerArray::set_names ( const char * const * names )
{
    //TraceScopeLog methodname ("BK::LayerArray::set_names()");
    if( names == NULL ) {
        log_warn("[LayerArray::set_names()] C[Xg NULL ݒ肳܂.");
        ary_list.clear();
        return;
    }
    
    unsigned int len;
    unsigned int i;
    
    for( len = 0; names[len] != NULL; ++len ) {
        for( i = 0; i < len; ++i ) {
            if( strcmp(names[i], names[len]) == 0 ) {
                throw new argument_exception("ݒ肷郌C[ɏd ('%s') ݂܂.", names[len]);
            }
        }
    }
    
    list_t tmplist;
    
    for( i = 0; i < len; ++i ) {
        const char * const name = names[i];
        const data_t * const data = find_data(name);
        
        tmplist.push_back( (data != NULL) ? *data : data_t(name, NULL) );
    }
    
    ary_list.swap( tmplist );
}

unsigned int BK::LayerArray::get_names ( const char * * names, unsigned int cap ) const
{
    if( names == NULL ) {
        return 0;
    }
    
    const list_t::const_iterator e = this->ary_list.end();
    list_t::const_iterator i;
    unsigned int index = 0;
    
    for( i = this->ary_list.begin(); index < cap && i != e; ++i ) {
        names[index++] = i->get_name();
    }
    return index;
}

void BK::LayerArray::set_layer ( const char * name, Layer * layer )
{
    if( name == NULL ) {
        throw new argument_exception("C[ NULL ͎wł܂.");
    }
    
    data_t * const dat = this->find_data( name );
    
    if( dat == NULL ) {
        throw_name_not_found( name );
    }
    dat->set_layer( layer );
}

BK::Layer * BK::LayerArray::get_layer ( const char * name ) const
{
    data_t const * const data = this->find_data(name);
    
    if( data == NULL ) {
        throw_name_not_found( name );
    }
    
    return data->get_layer();
}

void BK::LayerArray::execute ( BK::GraphicDevice * dev )
{
    const list_t::iterator e = this->ary_list.end();
    list_t::iterator i;
    
    for( i = this->ary_list.begin(); i != e; ++i ) {
        Layer * const layer = i->get_layer();
        
        if( layer != NULL ) {
            layer->execute( dev );
        }
    }
}

BK::Layer * BK::LayerArray::at ( unsigned int index ) const
{
    if( index >= this->ary_list.size() ) {
        throw new argument_exception("͈͊ÕCfNX %u w肳܂. (0...%u)", index, ary_list.size());
    }
    list_t::const_iterator i = this->ary_list.begin();
    
    std::advance( i, index );
    
    return i->get_layer();
}

void BK::LayerArray::set_at ( unsigned int index, BK::Layer * layer )
{
    if( index >= this->ary_list.size() ) {
        throw new argument_exception("͈͊ÕCfNX %u w肳܂. (0...%u)", index, ary_list.size());
    }
    list_t::iterator i = this->ary_list.begin();
    
    std::advance( i, index );
    
    i->set_layer( layer );
}

bool BK::LayerArray::find_name ( const char * name, unsigned int * ptr ) const
{
    const list_t::const_iterator e = this->ary_list.end();
    list_t::const_iterator i;
    unsigned int index = 0;
    
    for( i = this->ary_list.begin(); i != e; ++i ) {
        if( *i == name ) {
            if( ptr != NULL ) {
                *ptr = index;
            }
            return true;
        }
        ++index;
    }
    
    return false;
}

unsigned int BK::LayerArray::get_index ( const char * name ) const
{
    unsigned int index;
    
    if( !this->find_name( name, &index ) ) {
        throw_name_not_found( name );
    }
    return index;
}

void BK::LayerArray::insert_at ( unsigned int index, const char * name, Layer * layer )
{
    if( index > this->ary_list.size() ) {
        throw new argument_exception("͈͊ÕCfNX %u w肳܂. (0..%u)", this->ary_list.size(), index);
    }
    if( name == NULL ) {
        throw new argument_exception("C[ NULL w肳܂.");
    }
    
    if( this->find_data(name) != NULL ) {
        throw new argument_exception("̃C[ '%s' ݂܂.", name);
    }
    
    list_t::iterator i = this->ary_list.begin();
    
    std::advance( i, index );
    this->ary_list.insert( i, data_t(name, layer) );
}

void BK::LayerArray::erase_at ( unsigned int index )
{
    if( index >= this->ary_list.size() ) {
        throw new argument_exception("͈͊ÕCfNX %u w肳܂. (0...%u)", this->ary_list.size(), index);
    }
    
    list_t::iterator i = this->ary_list.begin();
    
    std::advance( i, index );
    this->ary_list.erase( i );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_LayerArray ( void )
{
    BK::LayerArray::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_LayerArray ( void )
{
}

//////////////////////////////////////////////////////////////////////
