#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Picture
//
namespace {
extern "C" {

/// ṼsN`IuWFNg𐶐
VALUE Picture_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    VALUE volatile obj = Qnil;
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    try {
        Ruby::ArgScanner scanner("Picture.new", argc, argv);
        Size2 s;
        
        s = scanner.fetch_Size2("sN`TCY");
        
        scanner.finish();
        
        Picture * const ptr = gdev->create_picture( s );
        
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, argc, argv );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// t@CsN`IuWFNg\z
VALUE Picture_open ( VALUE klass, VALUE arg )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    Picture * ptr = NULL;
    
    try {
        if( TYPE(arg) == T_STRING ) {
            ptr = gdev->load_picture_from_file( xrb_str_ptr(arg) );
            obj = ptr->ruby_wrap();
        } else {
            rb_raise(rb_eArgError, "%s ł̍\z͕s.", rb_obj_classname(arg));
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// C[WsN`IuWFNg\z
VALUE Picture_read ( VALUE klass, VALUE arg )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    Picture * ptr = NULL;
    
    try {
        if( TYPE(arg) == T_STRING ) {
            ptr = gdev->load_picture_from_memory( xrb_str_ptr(arg), xrb_str_len(arg) );
            obj = ptr->ruby_wrap();
        } else {
            rb_raise(rb_eArgError, "%s ł̍\z͕s.", rb_obj_classname(arg));
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// sN`̏
VALUE Picture_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Picture
//

VALUE BK::Picture::ruby_class_object = Qnil;

VALUE BK::Picture::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Picture", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", Picture_new );
    xrb_define_1arg_singleton_method( c, "open", Picture_open );
    xrb_define_1arg_singleton_method( c, "read", Picture_read );
    
    xrb_define_narg_method( c, "initialize", Picture_initialize );
    
    return ruby_class_object;
}

BK::Picture::Picture ( void )
{
}

BK::Picture::~Picture ()
{
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_Picture ( void )
{
    BK::Picture::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_Picture ( void )
{
}

//////////////////////////////////////////////////////////////////////
