#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::PictureData
//
namespace {
extern "C" {

/// ṼsN`IuWFNg𐶐
VALUE PictureData_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    VALUE volatile obj = Qnil;
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    try {
        Ruby::ArgScanner scanner("Picture.new", argc, argv);
        
        const Size2 s = scanner.fetch_Size2("sN`TCY");
        
        scanner.finish();
        
        PictureData * const ptr = gdev->create_picture_data( s );
        
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, argc, argv );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// t@CsN`IuWFNg\z
VALUE PictureData_open ( VALUE klass, VALUE arg )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    PictureData * ptr = NULL;
    
    try {
        if( TYPE(arg) == T_STRING ) {
            ptr = gdev->load_picture_data_from_file( xrb_str_ptr(arg) );
            obj = ptr->ruby_wrap();
        } else {
            rb_raise(rb_eArgError, "%s ł̍\z͕s.", rb_obj_classname(arg));
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// C[WsN`IuWFNg\z
VALUE PictureData_read ( VALUE klass, VALUE arg )
{
    using namespace BK;
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        Ruby::raise_object_is_not_created("OtBbNfoCX");
    }
    
    VALUE volatile obj = Qnil;
    PictureData * ptr = NULL;
    
    try {
        if( TYPE(arg) == T_STRING ) {
            ptr = gdev->load_picture_data_from_memory( xrb_str_ptr(arg), xrb_str_len(arg) );
            obj = ptr->ruby_wrap();
        } else {
            rb_raise(rb_eArgError, "%s ł̍\z͕s.", rb_obj_classname(arg));
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// sN`f[^̏
VALUE PictureData_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::PictureData
//

VALUE BK::PictureData::ruby_class_object = Qnil;

BK::PictureData::PictureData ( void )
{
}

BK::PictureData::~PictureData ()
{
}

VALUE BK::PictureData::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "PictureData", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", PictureData_new );
    xrb_define_1arg_singleton_method( c, "open", PictureData_open );
    xrb_define_1arg_singleton_method( c, "read", PictureData_read );
    
    xrb_define_narg_method( c, "initialize", PictureData_initialize );
    
    return ruby_class_object;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_PictureData ( void )
{
    BK::PictureData::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_PictureData ( void )
{
}

//////////////////////////////////////////////////////////////////////
