#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::PictureLayer
//
namespace {
extern "C" {

/// PictureLayer CX^X̐
VALUE PictureLayer_new ( VALUE klass, VALUE pictobj )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    if( !Picture::is_kind_of(pictobj) ) {
        rb_raise(rb_eArgError, "PictureLayer  Picture ȊO (%s) ł͏s.", rb_obj_classname(pictobj));
    }
    Picture * const pict = Picture::value_to_data( pictobj );
    
    try {
        PictureLayer * const ptr = create_PictureLayer(pict);
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, 1, &pictobj );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// sN`C[̏
VALUE PictureLayer_initialize ( VALUE self, VALUE pictobj )
{
    return self;
}

/// sN`̎擾
VALUE PictureLayer_get_picture ( VALUE self )
{
    using namespace BK;
    PictureLayer * const ptr = PictureLayer::value_to_data( self );
    Picture * const pic = ptr->get_picture();
    
    return (pic == NULL) ? Qnil : pic->get_ruby_object();
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::PictureLayer
//

VALUE BK::PictureLayer::ruby_class_object = Qnil;

BK::PictureLayer::PictureLayer ( BK::Picture * picture )
        : ptr_picture (picture)
{
    if( this->ptr_picture == NULL ) {
        throw new argument_exception("PictureLayer  NULL ŏ܂.");
    }
}

BK::PictureLayer::~PictureLayer ()
{
}

VALUE BK::PictureLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "PictureLayer", parent_t::get_ruby_class() );
    
    xrb_define_1arg_singleton_method( c, "new", PictureLayer_new );
    
    xrb_define_1arg_method( c, "initialize", PictureLayer_initialize );
    xrb_define_0arg_method( c, "image", PictureLayer_get_picture );
    xrb_define_0arg_method( c, "picture", PictureLayer_get_picture );
    
    return ruby_class_object;
}

void BK::PictureLayer::ruby_gc_mark ( void )
{
    this->ptr_picture->gc_mark_self();
}

void BK::PictureLayer::on_ruby_wrap ( void )
{
    this->ptr_picture->ruby_wrap();
}

void BK::PictureLayer::execute ( BK::GraphicDevice * dev )
{
    if( ptr_picture ) {
        Point2  p ( 0, 0 );
        
        dev->blit_picture( p, ptr_picture );
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_PictureLayer ( void )
{
    BK::PictureLayer::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_PictureLayer ( void )
{
}

//////////////////////////////////////////////////////////////////////
