#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::ProjectionLayer
//
namespace {
extern "C" {

/// ]̈擾
VALUE ProjectionLayer_register ( VALUE self )
{
    using namespace BK;
    ProjectionLayer * const ptr = ProjectionLayer::value_to_data( self );
    VALUE volatile obj = Qnil;
    
    try {
        ProjectionInfo * const info = ptr->register_projection();
        obj = info->ruby_wrap();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// ]̈Xg폜
VALUE ProjectionLayer_delete ( VALUE self, VALUE projobj )
{
    using namespace BK;
    ProjectionLayer * const ptr = ProjectionLayer::value_to_data( self );
    
    if( !ProjectionInfo::is_kind_of(projobj) ) {
        rb_raise( rb_eArgError, "폜]̈ ProjectionInfo ȊO (%s) ͎ws.", rb_obj_classname(projobj) );
    }
    ProjectionInfo * const projptr = ProjectionInfo::value_to_data( projobj );
    
    try {
        ptr->delete_projection( projptr );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return projobj;
}

/// o^Ă]̈̐擾
VALUE ProjectionLayer_get_size ( VALUE self )
{
    BK::ProjectionLayer * const ptr = BK::ProjectionLayer::value_to_data( self );
    
    return rb_fix_new( ptr->count_projection() );
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::ProjectionLayer
//

VALUE BK::ProjectionLayer::ruby_class_object = Qnil;

BK::ProjectionLayer::ProjectionLayer ( void )
{
}

BK::ProjectionLayer::~ProjectionLayer ()
{
}

VALUE BK::ProjectionLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "ProjectionLayer", parent_t::get_ruby_class() );
    
    xrb_define_0arg_method( c, "register", ProjectionLayer_register );
    xrb_define_1arg_method( c, "delete", ProjectionLayer_delete );
    xrb_define_0arg_method( c, "size", ProjectionLayer_get_size );
    
    return ruby_class_object;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_ProjectionLayer ( void )
{
    BK::ProjectionLayer::get_ruby_class();
    
    Init_graphic_layer_FillLayer();
    Init_graphic_layer_FilmLayer();
    Init_graphic_layer_BitmapProjectionLayer();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_ProjectionLayer ( void )
{
    Exit_graphic_layer_BitmapProjectionLayer();
    Exit_graphic_layer_FilmLayer();
    Exit_graphic_layer_FillLayer();
}

//////////////////////////////////////////////////////////////////////
