#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  SpriteData
//

BK::SpriteData::SpriteData ( BK::PictureData * bmp, const BK::Rect2 & rect, const BK::Point2 & center )
        : ptr_picture (bmp),
          rect_sprite (rect.get_normalized()),
          point_center (center)
{
    if( this->ptr_picture == NULL ) {
        throw new argument_exception("XvCg̉摜 NULL w肳܂.");
    }
    
    const Rect2 pictrect ( this->ptr_picture->get_size() );
    
    if( !pictrect.is_include( this->rect_sprite ) ) {
        throw new argument_exception(
            "XvCg̈ %s 摜̈ %s Oɂ܂.",
            this->rect_sprite.to_string().c_str(), pictrect.to_string().c_str());
    }
}

BK::SpriteData::~SpriteData ()
{
}

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Sprite
//
namespace {
extern "C" {

/// XvCg̐
VALUE Sprite_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        Ruby::ArgScanner scanner("Sprite.new", argc, argv);
        Point2 center;
        Rect2 rect;
        VALUE bmpobj;
        
        bmpobj = scanner.fetch_value("XvCg摜");
        rect   = scanner.fetch_Rect2("XvCg̈");
        if( scanner.is_empty() ) {
            center.set_point( 0, 0 );
        } else {
            center = scanner.fetch_Point2("XvCgS_");
        }
        
        scanner.finish();
        
        if( !PictureData::is_kind_of(bmpobj) ) {
            rb_raise(rb_eArgError, "XvCg摜 PictureData ȊO (%s) ͎wł܂.", rb_obj_classname(bmpobj));
        }
        
        PictureData * const bmp = PictureData::value_to_data( bmpobj );
        
        Sprite * const ptr = new Sprite ( bmp, rect, center );
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, argc, argv );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// IuWFNg̏
VALUE Sprite_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE Sprite_initialize_copy ( VALUE self, VALUE obj )
{
    using namespace BK;
    
    if( !Sprite::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  Sprite ɃRs[ł܂.", rb_obj_classname(obj));
    }
    const Sprite * const src = BK::Sprite::value_to_data( obj );
    
    if( !Sprite::is_kind_of(self) ) {
        rb_raise(rb_eTypeError, "%s  Sprite.initialize_copy Kp܂.", rb_obj_classname(self));
    }
    Sprite * const ptr = new Sprite ( *src );
    ptr->update_Data( self );
    
    return self;
}

/// XvCgQƂĂ摜擾
VALUE Sprite_get_picture ( VALUE self )
{
    BK::Sprite * const ptr = BK::Sprite::value_to_data( self );
    
    return ptr->get_picture()->get_ruby_object();
}

/// XvCgQƂĂ̈擾
VALUE Sprite_get_rect ( VALUE self )
{
    BK::Sprite * const ptr = BK::Sprite::value_to_data( self );
    
    return ptr->get_rect().create_ruby_object();
}

/// XvCgQƂĂ钆S_擾
VALUE Sprite_get_center ( VALUE self )
{
    BK::Sprite * const ptr = BK::Sprite::value_to_data( self );
    
    return ptr->get_center().create_ruby_object();
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Sprite
//

VALUE BK::Sprite::ruby_class_object = Qnil;

BK::Sprite::Sprite ( const BK::SpriteData & dat )
        : SpriteData (dat)
{
}

BK::Sprite::Sprite ( BK::PictureData * bmp, const BK::Rect2 & rect, const BK::Point2 & center )
        : SpriteData (bmp, rect, center)
{
}

BK::Sprite::~Sprite ()
{
}

VALUE BK::Sprite::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Sprite", BK::RubyObject::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", Sprite_new );
    
    xrb_define_narg_method( c, "initialize", Sprite_initialize );
    xrb_define_1arg_method( c, "initialize_copy", Sprite_initialize_copy );
    xrb_define_0arg_method( c, "picture", Sprite_get_picture );
    xrb_define_0arg_method( c, "rect", Sprite_get_rect );
    xrb_define_0arg_method( c, "center", Sprite_get_center );
    
    return ruby_class_object;
}

void BK::Sprite::ruby_gc_mark ( void )
{
    RubyObject::ruby_gc_mark();
    get_picture()->gc_mark_self();
}

void BK::Sprite::on_ruby_wrap ( void )
{
    RubyObject::on_ruby_wrap();
    get_picture()->ruby_wrap();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_Sprite ( void )
{
    Sprite::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_Sprite ( void )
{
}

//////////////////////////////////////////////////////////////////////
