#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace {

using namespace BK;

/// XvCgtB[h̏[eBeB
class copier_t
{
public:
    
    /// t[
    typedef SpriteField::frame_t frame_t;
    
    /// t[}bv
    typedef SpriteField::framemap_t framemap_t;
    
    /// gpsN`e[ǔ^
    typedef SpriteField::imageset_t imageset_t;
    
    /// XvCgCfNXe[ǔ^
    typedef SpriteField::indexmap_t indexmap_t;
    
private:
    
    /// I[i[ƂȂXvCgtB[h
    SpriteField * const ptr_owner;
    
    /// XvCgtB[h
    const char * const ptr_name;
    
    /// XvCgCfNXe[u
    indexmap_t & map_index;
    
    /// gpsN`e[u
    imageset_t & set_image;
    
    /// t[}bv
    framemap_t & map_frame;
    
    /// XvCgobt@
    SpriteFieldData * * ary_sprite;
    
    /// XvCg
    unsigned int num_sprite;
    
private:
    
    /// 
    frame_t * init ( std::string & path, const SpriteSet & set );
    
public:
    
    /// RXgN^
    copier_t ( SpriteField * field, const char * name, indexmap_t & index, imageset_t & image, framemap_t & fmap, const SpriteSet & set );
    
    /// fXgN^
    ~copier_t ();
    
    /// XvCgobt@̈Ϗ
    SpriteFieldData * * release ( void )
    {
        SpriteFieldData * * const ptr = this->ary_sprite;
        this->ary_sprite = NULL;
        return ptr;
    }
    
    /// XvCg̎擾
    unsigned int size ( void ) const
    {
        return num_sprite;
    }
    
};

copier_t::copier_t (
    SpriteField * field,
    const char * name,
    copier_t::indexmap_t & index,
    copier_t::imageset_t & image,
    copier_t::framemap_t & fmap,
    const SpriteSet & set )
        : ptr_owner  (field),
          ptr_name   (name),
          map_index  (index),
          set_image  (image),
          map_frame  (fmap)
{
    this->num_sprite = set.count_sprite();
    this->ary_sprite = new SpriteFieldData * [ num_sprite ];
    
    std::string path;
    path.reserve(1024); // 1KB Ώ\...H
    path.assign("");
    init( path, set );
}

copier_t::~copier_t ()
{
    delete[] this->ary_sprite;
}

copier_t::frame_t * copier_t::init ( std::string & path, const SpriteSet & set )
{
    frame_t * const newframe = new frame_t ();
    
    path.append("/");
    try {
        const std::string::size_type baselen = path.length();
        const SpriteSet::const_iterator e = set.end();
        SpriteSet::const_iterator itr;
        
        for( itr = set.begin(); itr != e; ++itr ) {
            const std::string       &       name = itr->first;
            const SpriteSet::data_t * const data = itr->second;
            
            path.append( name );
            if( data->is_sprite() ) {
                const SpriteData * const sprite = data->get_sprite();
                SpriteFieldData * const newsprite = new SpriteFieldData ( *(this->ptr_owner), *sprite );
                try {
                    const unsigned int id = map_index.size();
                    
                    if( id >= num_sprite ) {
                        throw new logic_exception("XvCgtB[h \"%s\" ŃXvCgZbg̕ԂXvCgs.",
                                                  this->ptr_name);
                    }
                    if( !this->map_index.insert( indexmap_t::value_type(path, id) ).second ) {
                        throw new runtime_exception("XvCgtB[h \"%s\" ւ̃XvCg \"%s\" ǉɎs.",
                                                    this->ptr_name, path.c_str());
                    }
                    if( !this->set_image.insert( sprite->get_picture() ).second ) {
                        throw new runtime_exception("XvCgtB[h \"%s\" ւ̃sN`[f[^ǉɎs.",
                                                    this->ptr_name);
                    }
                    ary_sprite[id] = newsprite;
                }
                catch ( exception_base * ) {
                    delete newsprite;
                    throw;
                }
                newframe->add( name, data->get_area() );
            } else { // else if( data->is_set() ) {
                frame_t * const child = this->init( path, *(data->get_set()) );
                newframe->add( name, child );
            }
            path.erase(path.begin() + baselen, path.end());
        }
    }
    catch ( exception_base * ) {
        delete newframe;
        throw;
    }
    
    path.resize( path.length() - 1 ); //  "/" 菜
    if( !this->map_frame.insert( framemap_t::value_type(path, newframe) ).second ) {
        throw new runtime_exception("XvCgtB[h \"%s\" ւ̃t[ \"%s\" ǉɎs.",
                                    this->ptr_name, path.c_str());
    }
    
    return newframe;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

using namespace BK;

/// XvCgtB[ḧ̗悪gpł̂𒲂ׂ
/**
 * O[oXvCgtB[h\zĂ̂OƂ܂B
 */
void check_spritefield_area ( const char * name, BitmapProjectionLayer * layer, const Rect2 & fieldrect )
{
    GlobalSpriteField * const db = GlobalSpriteField::get_instance();
    Bitmap & bmp = layer->get_bitmap();
    const Rect2 bmprect ( bmp.get_size() );
    
    // \z̈悪rbg}bvɎ܂Ă邩H
    if( !bmprect.is_include(fieldrect) ) {
        throw new argument_exception("XvCgtB[h \"%s\" %s rbg}bv̈ %s ̊Oɂ܂.",
                                     name,
                                     fieldrect.to_string().c_str(),
                                     bmprect.to_string().c_str() );
    }
    
    // \z̈悪ق̃XvCgtB[hƏdȂĂȂH
    const SpriteField * const conflict = db->get_conflict( layer, fieldrect );
    
    if( conflict != NULL ) {
        throw new argument_exception("XvCgtB[h \"%s\" %s ̓XvCgtB[h \"%s\" %s ƏՓ˂܂.",
                                     name,
                                     fieldrect.to_string().c_str(),
                                     conflict->get_name(),
                                     conflict->get_area().to_string().c_str());
    }
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  SpriteFieldData
//

BK::SpriteFieldData::SpriteFieldData ( const BK::SpriteField & field, const BK::SpriteData & data )
        : SpriteData   (data),
          obj_field    (field),
          rect_field   (data.get_rect() + field.get_point()),
          rect_aspect  (data.get_rect() + field.get_point(), field.get_bitmap().get_size())
{
}

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::SpriteField
//
namespace {
extern "C" {

/// XvCgtB[h̐
VALUE SpriteField_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj;
    VALUE volatile nameobj;
    VALUE layerobj;
    VALUE setobj;
    Point2 point;
    
    try {
        Ruby::ArgScanner scanner("SpriteField.new", argc, argv);
        
        nameobj  = scanner.fetch_value("tB[h");
        layerobj = scanner.fetch_value("WJC[");
        setobj   = scanner.fetch_value("XvCgZbg");
        point    = scanner.fetch_Point2("WJʒu");
        
        scanner.finish();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    const char * const name = StringValuePtr( nameobj );
    
    if( !BitmapProjectionLayer::is_kind_of(layerobj) ) {
        rb_raise(rb_eArgError, "XvCgtB[h̓WJ BitmapProjectionLayer ȊO (%s) ͎wł܂.",
                 rb_obj_classname(layerobj));
    }
    if( !SpriteSet::is_kind_of(setobj) ) {
        rb_raise(rb_eArgError, "XvCgtB[h̓WJ SpriteSet ȊO (%s) ͎gpł܂.",
                 rb_obj_classname(setobj));
    }
    
    try {
        BitmapProjectionLayer * const layer = BitmapProjectionLayer::value_to_data( layerobj );
        SpriteSet * const set = SpriteSet::value_to_data( setobj );
        
        SpriteField * const ptr = new SpriteField ( name, *layer, *set, point );
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, argc, argv );
        
        // OtBbN܂ĂȂԂȂ̂œǂݍޕKv
        ptr->update_bitmap();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// XvCgtB[h̏
VALUE SpriteField_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// XvCgtB[ȟ
VALUE SpriteField_global_find ( VALUE klass, VALUE nameobj )
{
    using namespace BK;
    GlobalSpriteField * const ptr = GlobalSpriteField::get_instance();
    
    if( ptr == NULL ) {
        Ruby::raise_object_is_not_created("O[oXvCgtB[h");
    }
    const char * const name = StringValuePtr( nameobj );
    SpriteField * field;
    
    try {
        field = ptr->find( name );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return (field == NULL) ? Qnil : field->get_ruby_object();
}

/// XvCgtB[h̎擾
VALUE SpriteField_get_name ( VALUE self )
{
    using namespace BK;
    SpriteField * const ptr = SpriteField::value_to_data( self );
    const std::string & str = ptr->get_name_string();
    
    return rb_str_new( str.c_str(), str.size() );
}

/// XvCgtB[h̊Ԃ擾
VALUE SpriteField_is_active ( VALUE self )
{
    BK::SpriteField * const ptr = BK::SpriteField::value_to_data( self );
    
    return BK::OnOffObject_is_active( ptr );
}

/// LN^[Ԃɐݒ肷
VALUE SpriteField_activate ( VALUE self )
{
    BK::SpriteField * const ptr = BK::SpriteField::value_to_data( self );
    
    BK::OnOffObject_activate( ptr );
    
    return self;
}

/// LN^[񊈐Ԃɐݒ肷
VALUE SpriteField_deactivate ( VALUE self )
{
    BK::SpriteField * const ptr = BK::SpriteField::value_to_data( self );
    
    BK::OnOffObject_deactivate( ptr );
    
    return self;
}

/// LN^[~Ԃɐݒ肷
VALUE SpriteField_terminate ( VALUE self )
{
    BK::SpriteField * const ptr = BK::SpriteField::value_to_data( self );
    
    BK::OnOffObject_terminate( ptr );
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  SpriteField
//

VALUE BK::SpriteField::ruby_class_object = Qnil;

BK::SpriteField::SpriteField ( const char * name, BK::BitmapProjectionLayer & layer, const BK::SpriteSet & set, const BK::Point2 & point )
        : str_name    ((name == NULL) ? "" : name),
          obj_layer   (layer),
          rect_field  (point, set.get_size()),
          ary_sprite  (NULL),
          num_sprite  (0)
{
    GlobalSpriteField * const db = GlobalSpriteField::get_instance();
    
    if( db == NULL ) {
        throw new logic_exception("O[oXvCgtB[h\zĂ܂.");
    }
    if( str_name.size() == 0 ) {
        throw new argument_exception("XvCgtB[h̍\zŖOɋ󕶎񂪎w肳܂.");
    }
    
    // ̈`FbN
    check_spritefield_area( name, &layer, this->rect_field );
    
    // Zbg̃Rs[
    {
        copier_t copier ( this, name, this->map_index, this->set_image, this->map_frame, set );
        this->num_sprite = copier.size();
        this->ary_sprite = copier.release();
    }
    
    // O[of[^x[Xɒǉ
    db->add( this );
    if( log_is_info() ) {
        log_info("XvCgtB[h \"%s\" \z܂.", name);
    }
}

BK::SpriteField::~SpriteField ()
{
    delete[] this->ary_sprite;
    {
        const framemap_t::iterator e = this->map_frame.end();
        framemap_t::iterator itr;
        
        for( itr = this->map_frame.begin(); itr != e; ++itr ) {
            delete itr->second;
        }
    }
    {
        GlobalSpriteField * const db = GlobalSpriteField::get_instance();
        
        if( db == NULL ) {
            log_error("XvCgtB[hjOɃO[oXvCgtB[hjĂ܂.");
        } else {
            try {
                db->erase( get_name() );
            } catch ( argument_exception * e ) {
                log_warn("O[oXvCgtB[hɑ݂ȂtB[h \"%s\" ̍폜s܂.",
                         this->get_name());
                delete e;
            }
        }
    }
}

VALUE BK::SpriteField::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "SpriteField", rb_cData );
    
    xrb_define_narg_singleton_method( c, "new", SpriteField_new );
    xrb_define_1arg_singleton_method( c, "[]", SpriteField_global_find );
    
    xrb_define_narg_method( c, "initialize", SpriteField_initialize );
    xrb_define_0arg_method( c, "name", SpriteField_get_name );
    xrb_define_0arg_method( c, "active?", SpriteField_is_active );
    xrb_define_0arg_method( c, "activate", SpriteField_activate );
    xrb_define_0arg_method( c, "deactivate", SpriteField_deactivate );
    xrb_define_0arg_method( c, "terminate", SpriteField_terminate );
    
    return ruby_class_object;
}

void BK::SpriteField::ruby_gc_mark ( void )
{
    RubyObject::ruby_gc_mark();
    obj_layer.gc_mark_self();
    std::for_each( set_image.begin(), set_image.end(), RubyObjectMarker() );
}

void BK::SpriteField::on_ruby_wrap ( void )
{
    RubyObject::on_ruby_wrap();
    obj_layer.ruby_wrap();
    std::for_each( set_image.begin(), set_image.end(), RubyObjectWrapper() );
}

const BK::SpriteFieldData * BK::SpriteField::at ( unsigned int id ) const
{
    if( id >= this->num_sprite ) {
        return NULL;
    }
    return this->ary_sprite[id];
}

const BK::SpriteFieldData * BK::SpriteField::find ( const char * name ) const
{
    const indexmap_t::const_iterator i = this->map_index.find( name );
    
    if( i == this->map_index.end() ) {
        return NULL;
    }
    return at( i->second );
}

void BK::SpriteField::update_bitmap ( void )
{
    const SpriteFieldData * const * ptr = ary_sprite;
    Bitmap & bmp = obj_layer.get_bitmap();
    
    for( unsigned int i = num_sprite; i > 0; --i ) {
        const SpriteFieldData * sprite = *ptr;
        
        const Point2   dstp = sprite->get_field_rect().get_point();
        const Rect2 &  srcr = sprite->get_rect();
        
        bmp.blit( dstp, *(sprite->get_picture()), srcr );
        ++ptr;
    }
    if( log_is_comment() ) {
        log_comment("XvCgtB[h '%s' ̃rbg}bvXV܂.", get_name());
    }
}

//////////////////////////////////////////////////////////////////////
////  SpriteField::frame_t
//

void BK::SpriteField::frame_t::add ( const std::string & name, const BK::Rect2 & area )
{
    if( !map_area.insert( areamap_t::value_type(name, area) ).second ) {
        throw new argument_exception("XvCgtB[ht[ւ̗̈ \"%s\" o^Ɏs.", name.c_str());
    }
}

void BK::SpriteField::frame_t::add ( const std::string & name, BK::SpriteField::frame_t * subframe )
{
    if( !map_subframe.insert( framemap_t::value_type(name, subframe) ).second ) {
        throw new argument_exception("XvCgtB[ht[ւ̎qt[ \"%s\" o^Ɏs.", name.c_str());
    }
}

//////////////////////////////////////////////////////////////////////
////  GlobalSpriteField
//

BK::GlobalSpriteField * BK::GlobalSpriteField::singleton_object = NULL;

BK::GlobalSpriteField::GlobalSpriteField ( void )
{
    if( singleton_object != NULL ) {
        throw new logic_exception("GlobalSpriteField ̍č\zs܂.");
    }
    singleton_object = this;
    if( log_is_comment() ) {
        log_comment("Singleton GlobalSpriteField <%p> \z.", this);
    }
}

BK::GlobalSpriteField::~GlobalSpriteField ()
{
    if( singleton_object != this ) {
        throw new logic_exception("s GlobalSpriteField o܂.");
    }
    singleton_object = NULL;
    if( log_is_comment() ) {
        log_comment("Singleton GlobalSpriteField <%p> j.", this);
    }
}

void BK::GlobalSpriteField::ruby_gc_mark ( void )
{
    std::for_each( this->set_field.begin(), this->set_field.end(), RubyObjectMarker() );
}

void BK::GlobalSpriteField::add ( BK::SpriteField * field )
{
    if( field == NULL ) {
        throw new argument_exception("O[oXvCgtB[hւ̒ǉ NULL w肳܂.");
    }
    const char * const name = field->get_name();
    const set_t::iterator i = this->set_field.find( name );
    
    if( i != this->set_field.end() ) {
        throw new argument_exception("O[oXvCgtB[hɓ̃XvCgtB[h \"%s\" ǉ܂.", name);
    }
    if( !set_field.insert( field ).second ) {
        throw new runtime_exception("O[oXvCgtB[hւ̃XvCgtB[h \"%s\" ǉs܂.", name);
    }
    if( log_is_trace() ) {
        log_trace("O[oXvCgtB[hɃXvCgtB[h \"%s\" ǉ܂.", name);
    }
}

BK::SpriteField * BK::GlobalSpriteField::erase ( const char * name )
{
    if( name == NULL ) {
        throw new argument_exception("O[oXvCgtB[h̍폜 NULL w肳܂.");
    }
    const set_t::iterator itr = this->set_field.find( name );
    
    if( itr == this->set_field.end() ) {
        throw new argument_exception("O[oXvCgtB[hɃXvCgtB[h \"%s\" ͖o^ł.", name);
    }
    SpriteField * const ret = *itr;

    this->set_field.erase( itr );
    if( log_is_trace() ) {
        log_trace("O[oXvCgtB[hXvCgtB[h \"%s\" 폜܂.", name);
    }
    
    return ret;
}

BK::SpriteField const * BK::GlobalSpriteField::get_conflict ( BK::BitmapProjectionLayer * layer, BK::Rect2 const & area ) const
{
    set_t::iterator itr;
    
    for( itr = this->set_field.begin(); itr != this->set_field.end(); ++itr ) {
        SpriteField * const field = *itr;
        
        if( layer == &(field->get_layer()) ) {
            if( field->get_area().is_shared(area) ) {
                return field;
            }
        }
    }
    return NULL;
}

BK::SpriteField * BK::GlobalSpriteField::find ( const char * name )
{
    const set_t::iterator itr = set_field.find( name );
    
    return (itr == set_field.end()) ? NULL : *itr;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_SpriteField ( void )
{
    new GlobalSpriteField ();
    SpriteField::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_SpriteField ( void )
{
    delete GlobalSpriteField::get_instance();
}

//////////////////////////////////////////////////////////////////////
