#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::AbstractInput
//
namespace {
extern "C" {

/// ̓foCX̖O擾
VALUE AbstractInput_get_name ( VALUE self )
{
    BK::AbstractInput * const ptr = BK::AbstractInput::value_to_data( self );
    
    return rb_str_new2( ptr->get_name() );
}

/// ̓foCX̃{^擾
VALUE AbstractInput_get_size ( VALUE self )
{
    BK::AbstractInput * const ptr = BK::AbstractInput::value_to_data( self );
    
    return rb_fix_new( ptr->count_button() );
}

/// L[̕ωʂ擾
VALUE AbstractInput_get_delta ( VALUE self )
{
    BK::AbstractInput * const ptr = BK::AbstractInput::value_to_data( self );
    
    return ptr->get_delta().create_ruby_object();
}

/// {^̏Ԃ擾
VALUE AbstractInput_get_state ( VALUE self, VALUE indexobj )
{
    BK::AbstractInput * const ptr = BK::AbstractInput::value_to_data( self );
    int index = NUM2INT( indexobj );
    int state;
    
    if( index < 0 || index >= ptr->count_button() ) {
        return Qnil;
    }
    
    try {
        state = ptr->get_button_state(index);
    }
    catch ( BK::exception_base * e ) {
        // zg͗OĂ͂ȂȂ
        BK::ruby_throw( e );
    }
    
    return rb_fix_new( state );
}

/// ̓IuWFNg̃^Cv擾
VALUE AbstractInput_get_type ( VALUE self )
{
    BK::AbstractInput * const ptr = BK::AbstractInput::value_to_data( self );
    
    return BK::AbstractInput::type_to_VALUE( ptr->get_type() );
}

/// foCX̏ԂM
VALUE AbstractInput_update ( VALUE self )
{
    using namespace BK;
    BK::AbstractInput * const ptr = BK::AbstractInput::value_to_data( self );
    
    try {
        ptr->update();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::AbstractInput
//
namespace {

const char * const InputDevTypeSymbol_Unknown   = "UNKNOWN";
const char * const InputDevTypeSymbol_Keyboard  = "KEYBOARD";
const char * const InputDevTypeSymbol_Mouse     = "MOUSE";
const char * const InputDevTypeSymbol_GamePad   = "GAMEPAD";

} /* namespace */

VALUE BK::AbstractInput::ruby_class_object = Qnil;

VALUE BK::AbstractInput::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    VALUE volatile value;
    
    c = ruby_class_object = define_ruby_bk_class( "AbstractInput", parent_t::get_ruby_class() );
    
    xrb_define_0arg_method( c, "name", AbstractInput_get_name );
    xrb_define_0arg_method( c, "type", AbstractInput_get_type );
    xrb_define_0arg_method( c, "delta", AbstractInput_get_delta );
    xrb_define_0arg_method( c, "size", AbstractInput_get_size );
    xrb_define_1arg_method( c, "[]", AbstractInput_get_state );
    xrb_define_0arg_method( c, "update", AbstractInput_update );
    
    value = rb_str_new2( InputDevTypeSymbol_Unknown );
    rb_define_const( c, "UNKNOWN", value );
    
    value = rb_str_new2( InputDevTypeSymbol_Keyboard );
    rb_define_const( c, "KEYBOARD", value );
    
    value = rb_str_new2( InputDevTypeSymbol_Mouse );
    rb_define_const( c, "MOUSE", value );
    
    value = rb_str_new2( InputDevTypeSymbol_GamePad );
    rb_define_const( c, "GAMEPAD", value );
    
    value = rb_fix_new( BUTSTAT_RELEASED );
    rb_define_const( c, "STAT_RELEASE", value );
    
    value = rb_fix_new( BUTSTAT_PRESSED );
    rb_define_const( c, "STAT_PRESS", value );
    
    return ruby_class_object;
}

BK::AbstractInput::AbstractInput ( void )
{
}

BK::AbstractInput::~AbstractInput ()
{
}

int BK::AbstractInput::get_button_state ( int index ) const
{
    int ret;
    
    get_button_states( &ret, index, 1 );
    
    return ret;
}

VALUE BK::AbstractInput::type_to_VALUE ( BK::AbstractInput::type_t type )
{
    const char * symbol;
    
    switch( type ) {
    case DEV_KEYBOARD:
        symbol = "KEYBOARD";
        break;
        
    case DEV_MOUSE:
        symbol = "MOUSE";
        break;
        
    case DEV_GAMEPAD:
        symbol = "GAMEPAD";
        break;
        
    default:
        symbol = "UNKNOWN";
        break;
    }
    
    return rb_const_get( BK::AbstractInput::get_ruby_class(), rb_intern(symbol) );
}

void BK::AbstractInput::get_button_states ( int * index, int start, int count ) const
{
    if( start < 0 || count < 0 || start + count >= count_button() ) {
        throw new argument_exception(
            "̓foCX (%s) ̏Ԏ擾ŕsȒl (%d...%d) n܂. ({^: %d)",
            this->get_name(), start, start + count, this->count_button());
    }
}

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::MouseInput
//
namespace {
extern "C" {


} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::MouseInput
//

VALUE BK::MouseInput::ruby_class_object = Qnil;

VALUE BK::MouseInput::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "MouseInput", parent_t::get_ruby_class() );
    
    return ruby_class_object;
}

BK::MouseInput::MouseInput ()
{
}

BK::MouseInput::~MouseInput ()
{
}

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::KeyboardInput
//
namespace {
extern "C" {


} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::KeyboardInput
//

VALUE BK::KeyboardInput::ruby_class_object = Qnil;

VALUE BK::KeyboardInput::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "KeyboardInput", parent_t::get_ruby_class() );
    
    return ruby_class_object;
}

BK::KeyboardInput::KeyboardInput ()
{
}

BK::KeyboardInput::~KeyboardInput ()
{
}

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::GamepadInput
//
namespace {
extern "C" {


} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::GamepadInput
//

VALUE BK::GamepadInput::ruby_class_object = Qnil;

VALUE BK::GamepadInput::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "GamepadInput", parent_t::get_ruby_class() );
    
    return ruby_class_object;
}

BK::GamepadInput::GamepadInput ()
{
}

BK::GamepadInput::~GamepadInput ()
{
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_input_AbstractInput ( void )
{
    BK::AbstractInput::get_ruby_class();
    BK::MouseInput::get_ruby_class();
    BK::KeyboardInput::get_ruby_class();
    BK::GamepadInput::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_input_AbstractInput ( void )
{
}

//////////////////////////////////////////////////////////////////////
