#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace BK {


class RubyInputDevice : public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: InputDevice
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static RubyInputDevice * value_to_data ( VALUE obj )
    {
        return ruby_basecast< RubyInputDevice, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
public:
    
    /// RXgN^
    RubyInputDevice ( InputDevice * )
    {
    }
    
    /// fXgN^
    ~RubyInputDevice ()
    {
    }
    
};


} /* namespace BK */
//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::InputDevice
//
namespace {
extern "C" {

/// foCX̊Jn
VALUE InputDevice_start ( VALUE klass )
{
    using namespace BK;
    InputDevice * const dev = InputDevice::get_instance();
    
    try {
        dev->start();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// foCX̒~
VALUE InputDevice_stop ( VALUE klass )
{
    using namespace BK;
    InputDevice * const dev = InputDevice::get_instance();
    
    try {
        dev->stop();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// foCXNĂ邩𒲂ׂ
VALUE InputDevice_is_started ( VALUE klass )
{
    BK::InputDevice * const dev = BK::InputDevice::get_instance();
    
    return (dev->is_started()) ? Qtrue : Qfalse;
}

/// foCX̑IuWFNg쐬
VALUE InputDevice_connect ( VALUE klass )
{
    using namespace BK;
    InputDevice * const dev = InputDevice::get_instance();
    RubyInputDevice * ptr;
    VALUE volatile obj;
    
    if( !dev->is_started() ) {
        Ruby::raise_cannot_create_connection_to_device("CvbgfoCX");
    }
    try {
        ptr = new RubyInputDevice( dev );
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// ڑꂽfoCXf[^̃Xg擾
VALUE InputDevice_get_devices ( VALUE self )
{
    using namespace BK;
    InputDevice * const dev = InputDevice::get_instance();
    VALUE volatile ret = rb_ary_new();
    int size;
    int n;
    
    try {
        size = dev->count_device();
        for( n = 0; n < size; ++n ) {
            std::string devname = dev->get_device_name(n);
            BK::AbstractInput::type_t devtype = dev->get_device_type(n);
            VALUE volatile pair;
            VALUE volatile typeval;
            VALUE volatile nameval;
            
            typeval = BK::AbstractInput::type_to_VALUE(devtype);
            nameval = rb_str_new2(devname.c_str());
            
            pair = rb_assoc_new( typeval, nameval );
            rb_ary_push( ret, pair );
        }
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return ret;
}

/// foCXhCo̍\z
VALUE InputDevice_acquire ( VALUE self, VALUE indexobj )
{
    using namespace BK;
    InputDevice * const dev = InputDevice::get_instance();
    AbstractInput * input;
    VALUE volatile obj;
    
    if( TYPE(indexobj) != T_FIXNUM ) {
        rb_raise(rb_eArgError, "InputDevice#acquire  Fixnum ȊO (%s) ͎wsł.", rb_obj_classname(indexobj));
    }
    
    const int index = FIX2INT(indexobj);
    try {
        input = dev->setup_device( index );
        obj = input->ruby_wrap();
    } catch ( out_of_range_exception * e ) {
        delete e;
        rb_raise(rb_eArgError, "͈͊O̓̓foCXԍ (%d) w肳܂. (0...%d)", index, dev->count_device());
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::RubyInputDevice
//

VALUE BK::RubyInputDevice::ruby_class_object = Qnil;

VALUE BK::RubyInputDevice::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "InputDevice", RubyObject::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "start", InputDevice_start );
    xrb_define_0arg_singleton_method( c, "started?", InputDevice_is_started );
    xrb_define_0arg_singleton_method( c, "stop", InputDevice_stop );
    xrb_define_0arg_singleton_method( c, "connect", InputDevice_connect );
    xrb_define_0arg_singleton_method( c, "new", InputDevice_connect );
    
    xrb_define_0arg_method( c, "devices", InputDevice_get_devices );
    xrb_define_1arg_method( c, "acquire", InputDevice_acquire );
    
    return ruby_class_object;
}

//////////////////////////////////////////////////////////////////////
////  BK::InputDevice
//

BK::InputDevice * BK::InputDevice::singleton_object = NULL;

BK::InputDevice::InputDevice ( void )
{
    if( singleton_object != NULL ) {
        throw new logic_exception("InputDevice ̍č\zs܂.");
    }
    singleton_object = this;
    
    log_comment("CvbgfoCX <%p> ̍\zI܂.", this);
}

BK::InputDevice::~InputDevice ()
{
    log_comment("CvbgfoCX <%p> ̔jJn܂.", this);
    
    // jI
    if( singleton_object != this ) {
        throw new logic_exception("s InputDevice o܂.");
    }
    singleton_object = NULL;
}

void BK::InputDevice::ruby_gc_mark ( void )
{
    ServiceDevice::ruby_gc_mark();
}

const char * BK::InputDevice::get_device_name ( void ) const
{
    return "CvbgT[rX";
}

void BK::InputDevice::_start ( void )
{
}

void BK::InputDevice::_stop ( void )
{
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_input_InputDevice ( void )
{
    {
        InputDevice * dev = create_InputDevice();
        if( dev == NULL ) {
            throw new logic_exception("CvbgfoCX̐Ɏs܂.");
        }
    }
    BK::RubyInputDevice::get_ruby_class();
    
    BK::Init_input_AbstractInput();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_input_InputDevice ( void )
{
    BK::Exit_input_AbstractInput();
    {
        InputDevice * dev = InputDevice::get_instance();
        if( dev->is_started() ) {
            dev->stop();
        }
        delete dev;
    }
}

//////////////////////////////////////////////////////////////////////
