#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {

static ID id_write;
static ID id_flush;
static ID id_inspect;

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace BK {


class RubyLogDevice : public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: LogDevice
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static RubyLogDevice * value_to_data ( VALUE obj )
    {
        return ruby_cast< RubyLogDevice >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
    /// }[Np֐擾
    void * get_ruby_mark_function ( void );
    
    /// p֐擾
    void * get_ruby_free_function ( void );
    
    /// bsOɎgp|C^̎擾
    void * get_wrapped_address ( void )
    {
        return this;
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
public:
    
    /// RXgN^
    RubyLogDevice ( LogDevice * dev )
    {
    }
    
    /// fXgN^
    ~RubyLogDevice ()
    {
    }
    
};


} /* namespace BK */
//////////////////////////////////////////////////////////////////////
////  Ruby NX : BK::LogDevice
//
namespace {
extern "C" {

/// Ruby Kx[WRN^p}[N
void LogDevice_mark ( BK::RubyLogDevice * ptr )
{
    ptr->ruby_gc_mark();
}

/// IuWFNg̉
void LogDevice_free ( BK::RubyLogDevice * ptr )
{
    delete ptr;
}

/// foCX̋N
VALUE LogDevice_start ( VALUE klass )
{
    using namespace BK;
    LogDevice * const dev = LogDevice::get_instance();
    
    if( dev == NULL ) {
        rb_raise( rb_eRuntimeError, "OfoCX̃CX^X܂." );
    }
    
    try {
        dev->start();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return Qtrue;
}

/// foCX̏I
VALUE LogDevice_stop ( VALUE klass )
{
    BK::LogDevice * dev = BK::LogDevice::get_instance();
    
    try {
        dev->stop();
    } catch ( BK::exception_base * e ) {
        BK::ruby_throw( e );
    }
    
    return Qtrue;
}

/// foCXNĂ邩𒲂ׂ
VALUE LogDevice_is_started ( VALUE klass )
{
    BK::LogDevice * dev = BK::LogDevice::get_instance();
    
    return (dev->is_started()) ? Qtrue : Qfalse;
}

/// foCX̑IuWFNg쐬
VALUE LogDevice_connect ( VALUE klass )
{
    using namespace BK;
    LogDevice * dev = LogDevice::get_instance();
    VALUE volatile obj = Qnil;
    
    if( !dev->is_started() ) {
        Ruby::raise_cannot_create_connection_to_device("OfoCX");
    }
    try {
        RubyLogDevice * const ptr = new RubyLogDevice( dev );
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

VALUE LogDevice_set_out ( VALUE klass, VALUE obj )
{
    using namespace BK;
    LogDevice * const dev = LogDevice::get_instance();
    
    try {
        dev->set_logger( obj );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

VALUE LogDevice_get_out ( VALUE klass )
{
    BK::LogDevice * const dev = BK::LogDevice::get_instance();
    
    return dev->get_logger();
}

VALUE LogDevice_set_filter ( VALUE klass, VALUE levelobj )
{
    BK::LogDevice * const dev = BK::LogDevice::get_instance();
    int level;
    
    level = NUM2INT(levelobj);
    
    dev->set_filter( level );
    
    return levelobj;
}

VALUE LogDevice_get_filter ( VALUE klass )
{
    BK::LogDevice * const dev = BK::LogDevice::get_instance();
    
    return dev->get_filter();
}

VALUE LogDevice_write ( int argc, VALUE * argv, VALUE self )
{
    BK::LogDevice * dev = BK::LogDevice::get_instance();
    VALUE volatile strval = Qnil;
    const char * str;
    int level;
    
    
    try {
        switch( argc ) {
        case 1:
            strval = argv[0];
            str = StringValuePtr( strval );
            dev->write( BK::LOG_USER, str );
            break;
            
        case 2:
            level = NUM2INT( argv[0] );
            strval = argv[1];
            str = StringValuePtr( strval );
            dev->write( level, str );
            break;
            
        default:
            rb_raise( rb_eArgError, "sȈ LogDevice.log_write() Ăяo܂." );
        }
    } catch ( BK::exception_base * e ) {
        BK::ruby_throw( e );
    }
    
    return strval;
}

VALUE LogDevice_write_op ( VALUE self, VALUE strobj )
{
    BK::LogDevice * dev = BK::LogDevice::get_instance();
    const char * str;
    
    str = StringValuePtr( strobj );
    dev->write( BK::LOG_USER, str );
    
    return self;
}

VALUE LogDevice_global_log_write ( int argc, VALUE * argv, VALUE klass )
{
    BK::LogDevice * dev = BK::LogDevice::get_instance();
    
    if( dev->is_started() ) {
        return LogDevice_write( argc, argv, Qnil );
    }
    
    return Qnil;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::RubyLogDevice
//

VALUE BK::RubyLogDevice::ruby_class_object = Qnil;

VALUE BK::RubyLogDevice::get_ruby_class ( void )
{
    if( ruby_class_object != Qnil ) {
        return ruby_class_object;
    }
    VALUE c;
    VALUE volatile value;
    
    c = ruby_class_object = define_ruby_bk_class( "LogDevice", rb_cData );
    
    xrb_define_0arg_singleton_method( c, "start", LogDevice_start );
    xrb_define_0arg_singleton_method( c, "started?", LogDevice_is_started );
    xrb_define_0arg_singleton_method( c, "stop", LogDevice_stop );
    xrb_define_0arg_singleton_method( c, "connect", LogDevice_connect );
    xrb_define_0arg_singleton_method( c, "new", LogDevice_connect );
    xrb_define_1arg_singleton_method( c, "out=", LogDevice_set_out );
    xrb_define_0arg_singleton_method( c, "out", LogDevice_get_out );
    xrb_define_1arg_singleton_method( c, "filter=", LogDevice_set_filter );
    xrb_define_0arg_singleton_method( c, "filter", LogDevice_get_filter );
    
    xrb_define_narg_method( c, "write", LogDevice_write );
    xrb_define_1arg_method( c, "<<", LogDevice_write_op );
    
    value = INT2NUM( BK::LOG_TRACE );
    rb_define_const( c, "TRACE", value );
    
    value = INT2NUM( BK::LOG_COMMENT );
    rb_define_const( c, "COMMENT", value );
    
    value = INT2NUM( BK::LOG_INFO );
    rb_define_const( c, "INFO", value );
    
    value = INT2NUM( BK::LOG_DEBUG );
    rb_define_const( c, "DEBUG", value );
    
    value = INT2NUM( BK::LOG_USER );
    rb_define_const( c, "USER", value );
    
    value = INT2NUM( BK::LOG_WARN );
    rb_define_const( c, "WARN", value );
    
    value = INT2NUM( BK::LOG_ERROR );
    rb_define_const( c, "ERROR", value );
    
    xrb_define_narg_global_function( "log_write", LogDevice_global_log_write );
    
    return ruby_class_object;
}

void * BK::RubyLogDevice::get_ruby_mark_function ( void )
{
    return LogDevice_mark;
}

void * BK::RubyLogDevice::get_ruby_free_function ( void )
{
    return LogDevice_free;
}

void BK::RubyLogDevice::ruby_gc_mark ( void )
{
    LogDevice::get_instance()->ruby_gc_mark();
}

//////////////////////////////////////////////////////////////////////
////  BK::LogDevice
//

BK::LogDevice * BK::LogDevice::singleton_object = NULL;

BK::LogDevice::LogDevice ( void )
        : num_filter_level (0),
          num_indent (0),
          ptr_ostream (NULL),
          ptr_current_logger (Qnil),
          ptr_critical (create_CriticalSection())
{
    if( singleton_object != NULL ) {
        throw new logic_exception("LogDevice ̍č\zs܂.");
    }
    singleton_object = this;
    
    log_comment("OfoCX <%p> ̍\zI܂.", this);
}

BK::LogDevice::~LogDevice ()
{
    log_comment("OfoCX <%p> ̔jJn܂.", this);
    delete ptr_ostream;
    delete ptr_critical;
    
    // jI
    if( singleton_object != this ) {
        throw logic_exception("s LogDevice o܂.");
    }
    singleton_object = NULL;
}

void BK::LogDevice::ruby_gc_mark ( void )
{
    ServiceDevice::ruby_gc_mark();
    rb_gc_mark( ptr_current_logger );
}

const char * BK::LogDevice::get_device_name ( void ) const
{
    return "OT[rX";
}

void BK::LogDevice::_start ( void )
{
    // start() ͏o͐悪ݒ肳ĂȂ
    //set_logger( Qnil );
    //set_logger_stream( NULL );
}

void BK::LogDevice::_stop ( void )
{
    set_logger( Qnil );
    set_logger_stream( NULL );
    num_filter_level = 0;
    num_indent = 0;
}

bool BK::LogDevice::is_log_available ( VALUE obj )
{
    return (rb_respond_to(obj, id_write) && rb_respond_to(obj, id_flush)) ? true : false;
}

namespace {

extern "C" {

VALUE logger_finalizer ( VALUE arg, VALUE self )
{
    BK::LogDevice * dev = BK::LogDevice::get_instance();
    
    dev->set_logger( Qnil );
    
    return Qnil;
}

} /* extern "C" */

void log_set_logger_finalizer ( VALUE newlogger, VALUE prelogger )
{
    VALUE objspace = rb_const_get( rb_cObject, rb_intern("ObjectSpace") );
    VALUE volatile procobj = xrb_proc_new( logger_finalizer, Qnil );
    
    // prelogger ̃t@CiCU폜
    if( !NIL_P(prelogger) ) {
        rb_funcall( objspace, rb_intern("undefine_finalizer"), 1, prelogger );
    }
    
    // newlogger ̃t@CiCUo^
    if( !NIL_P(newlogger) ) {
        rb_funcall( objspace, rb_intern("define_finalizer"), 2, newlogger, procobj );
    }
}

} /* namespace */

VALUE BK::LogDevice::set_logger ( VALUE logger )
{
    if( !is_started() ) {
        throw new runtime_exception("NĂȂOfoCXɏo͐ Ruby IuWFNgݒ肳܂.");
    }
    
    if( !NIL_P(logger) && !LogDevice::is_log_available(logger) ) {
        log_error("%s IuWFNg̓Ȍo͐ɐݒł܂.", rb_obj_classname(logger));
        throw new argument_exception(
            "%s IuWFNg write \bhȂ߃Ȍo͐ɐݒł܂.",
            rb_obj_classname(logger));
    }
    
    VALUE volatile ret = ptr_current_logger;
    
    if( logger != ptr_current_logger ) {
        log_info("OfoCX Ruby o͐ (%s IuWFNg) ̐ڑj܂.", rb_obj_classname(ptr_current_logger));
        log_set_logger_finalizer( logger, ptr_current_logger );
        ptr_current_logger = logger;
        log_comment("OfoCX Ruby o͐ (%s IuWFNg) ڑ܂.", rb_obj_classname(ptr_current_logger));
    }
    
    return ret;
}

BK::LogDevice::ostream_t * BK::LogDevice::set_logger_stream ( BK::LogDevice::ostream_t * ptr )
{
    if( !is_started() ) {
        throw new runtime_exception("NĂȂOfoCXɏo͐Xg[ݒ肳܂.");
    }
    
    ostream_t * ret = ptr_ostream;
    
    if( ptr != ptr_ostream ) {
        log_info("OfoCXƏo̓Xg[̐ڑj܂.");
        ptr_ostream = ptr;
    }
    
    return ret;
}

namespace {

const char * get_level_string ( int level )
{
    switch( level ) {
    case BK::LOG_TRACE:    return " trace:";
    case BK::LOG_COMMENT:  return " (cmnt)";
    case BK::LOG_INFO:     return " [INFO]";
    case BK::LOG_DEBUG:    return " DEBUG:";
    case BK::LOG_USER:     return "";
    case BK::LOG_WARN:     return " [WARN]";
    case BK::LOG_ERROR:    return " ERROR:";
    }
    return "";
}

VALUE _log_output_string ( VALUE pair )
{
    VALUE * ptr = RARRAY(pair)->ptr;
    
    rb_io_write( ptr[0], ptr[1] );
    rb_funcall( ptr[0], id_flush, 0 );
    
    return Qnil;
}

void log_output_string ( VALUE logger, VALUE strobj )
{
    rb_protect( _log_output_string, rb_assoc_new(logger, strobj), NULL );
}

} /* namespace */

void BK::LogDevice::_write ( int level, const char * str, unsigned int len )
{
    if( ptr_ostream == NULL && NIL_P(ptr_current_logger) ) {
        return;
    }
    
    int const indent = num_indent;
    const char * const levelstr = get_level_string( level );
    
    time_t const currtime = time(NULL);
    struct tm * const td = localtime(&currtime);
    
    char * const headstr = ALLOCA_N( char, indent + 64 );
    int headstrlen;
    
    headstrlen = sprintf(&headstr[0], "[%02d:%02d:%02d]%s ", td->tm_hour, td->tm_min, td->tm_sec, levelstr);
    if( indent > 0 ) {
        {
            char * ptr = &headstr[headstrlen];
            for( int i = indent; i > 0; --i ) {
                *(ptr++) = ' ';
            }
            headstrlen += indent;
        }
    }
    
    char * const buf = ALLOCA_N( char, headstrlen + len + 1 );
    ostream_t * const ostream = ptr_ostream;
    
    strcpy( &buf[0], headstr );
    strcpy( &buf[headstrlen], str );
    strcpy( &buf[headstrlen + len], "\n" );
    
    if( ostream != NULL ) {
        if( NIL_P(ptr_current_logger) ) {
            {
                ptr_critical->enter();
                (*ostream) << buf;
                ostream->flush();
                ptr_critical->leave();
            }
        } else {
            {
                VALUE volatile headstrobj = rb_str_buf_new( headstrlen + len + 1 );
                rb_str_buf_cat(headstrobj, buf, headstrlen + len + 1);
                
                ptr_critical->enter();
                log_output_string( ptr_current_logger, headstrobj );
                (*ostream) << buf;
                ostream->flush();
                ptr_critical->leave();
            }
        }
    } else {
        if( NIL_P(ptr_current_logger) ) {
            ; // Ȃ
        } else {
            {
                VALUE volatile headstrobj = rb_str_buf_new( headstrlen + len + 1 );
                rb_str_buf_cat(headstrobj, buf, headstrlen + len + 1);
                
                ptr_critical->enter();
                log_output_string( ptr_current_logger, headstrobj );
                ptr_critical->leave();
            }
        }
    }
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_log_LogDevice ( void )
{
    LogDevice * const dev = create_LogDevice();
    
    if( dev == NULL ) {
        throw new logic_exception("OfoCX̐Ɏs܂.");
    }
    
    id_write = rb_intern("write");
    id_flush = rb_intern("flush");
    
    RubyLogDevice::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_log_LogDevice ( void )
{
    LogDevice * const dev = LogDevice::get_instance();
    if( dev->is_started() ) {
        dev->stop();
    }
    delete dev;
}

//////////////////////////////////////////////////////////////////////
