TestName = 'AvP[VfoCX - eXg'

$stdout = File.open("./stdout.log", "w")

$Config['LogDevice.InitialLogger'] = open("AppDevice.log", "w")
$Config['LogDevice.InitialLevel'] = BK::LogDevice::TRACE
$Config['ApplicationDevice.InitialCaption'] = TestName

BK::LogDevice.start()
BK::ApplicationDevice.start()
BK::GraphicDevice.start()
BK::InputDevice.start()

p $Input.devices

main_layers = $Graphic.layer

main_layers.names = [ "picture", "fill", "front" ]

picture = BK::Picture.open("./img640x480.png")
p picture

filllayer = BK::FillLayer.new()
filllayer.color = "#202020@80"
filllayer.area = Rect2( 16, 300, 624, 464 )

log_write("(1) picture's size = #{picture.size}")

picturelayer = BK::PictureLayer.new()
picturelayer.picture = picture

log_write("(2)")

image = BK::Image.open("./chr128x128.png")
p image

main_layers["fill"] = filllayer
main_layers["picture"] = picturelayer

log_write("(3)")

point = BK::Point2.new(20, 20)
p point
p point.hash

point = BK::Point2.new(21, 21)
p point
p point.hash

r = BK::Rect2.new(10, 10, 20, 20)
p r
p r.hash

r = BK::Rect2.new(10, 11, 20, 21)
p r
p r.hash

log_write("(4)")

imgstr = <<EOD
FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF
FF000000000000FF
FF000000000000FF
FF880000000088FF
FF884400004488FF
FF888844448888FF
FF888888888888FF
FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF
FF000FFFFFF00FFF
FF0F0FFFFF0F0FFF
FF0FF0FFF0FF0FFF
FF0FFF0F0FFF0FFF
FF0FFFF0FFFF0FFF
FFFFFFFFFFFFFFFF
EOD
img = imgstr.gsub(/\s/, '').split(//)
img.map! { |s| Integer("0x#{s}0") }
img2 = [ ]
img.each {|e| img2 << e; img2 << e }
film = BK::Film.new( BK::Size2.new(32, 16), img2 )
p film

font = BK::Font.new("lr SVbN", 32)
p font.name

glyphs = font.fetch("Tv")

picture.acquire do |canvas|
  p canvas.size
  canvas.draw_film( 100, 100, "#FF0000", film )
  canvas.draw_film( 130, 100, "#00FF00", film, BK::Rect2.new(0, 0, 16, 8) )
  canvas.draw_film( 100, 130, "#0000FF", film )
  canvas.draw_film( 130, 130, "#FFFF00", film )
  
  y = 0
  glyphs.each do |glyph|
    _ = glyph.film
    canvas.draw_film( 100 + y, 200 + y, "#808080", _ )
    y += 32
  end
end

picture = BK::PictureData.open("chr128x128.png")
p picture

gear = BK::FrameWaitGear.new
gear.wait_frame = 500

log_write("C[vJn܂.")
i = 0
$Application.loop(gear)
#$Application.loop do
#  i < 300
#end

